import * as i0 from '@angular/core';
import { EventEmitter, Directive, Input, Output, HostListener, Pipe, forwardRef, Component, ViewChild, Injectable, NgModule, InjectionToken, Optional, Inject, Injector, ViewChildren, ViewEncapsulation } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { NgControl, NG_VALUE_ACCESSOR } from '@angular/forms';
import { Subject, BehaviorSubject, Subscription, of, forkJoin } from 'rxjs';
import { debounceTime, delay, map, catchError } from 'rxjs/operators';
import * as i1$1 from '@ng-bootstrap/ng-bootstrap';
import { NgbTooltipModule, NgbAlertModule, NgbProgressbarModule } from '@ng-bootstrap/ng-bootstrap';
import * as i1$2 from '@angular/platform-browser';
import * as i1$3 from '@angular/common/http';
import { HttpEventType } from '@angular/common/http';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { ComponentPortal } from '@angular/cdk/portal';
import * as i1$4 from '@angular/cdk/overlay';
import { OverlayModule } from '@angular/cdk/overlay';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { __awaiter } from 'tslib';
import { DataSource } from '@angular/cdk/collections';
import * as i3 from '@angular/cdk/scrolling';
import { ScrollingModule } from '@angular/cdk/scrolling';

class VgDelayInputDirective {
    constructor() {
        this.delayTime = 1000;
        this.delayInput = new EventEmitter();
        this.inputSubject = new Subject();
    }
    ngOnInit() {
        this.subscription = this.inputSubject
            .pipe(debounceTime(this.delayTime))
            .subscribe((e) => this.delayInput.emit(e));
    }
    clickEvent(event) {
        event.preventDefault();
        event.stopPropagation();
        this.inputSubject.next(event);
    }
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
}
VgDelayInputDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDelayInputDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
VgDelayInputDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgDelayInputDirective, selector: "[vgDelayInput]", inputs: { delayTime: "delayTime" }, outputs: { delayInput: "delayInput" }, host: { listeners: { "input": "clickEvent($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDelayInputDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgDelayInput]',
                }]
        }], propDecorators: { delayTime: [{
                type: Input
            }], delayInput: [{
                type: Output
            }], clickEvent: [{
                type: HostListener,
                args: ['input', ['$event']]
            }] } });

class VgPipeWrapperPipe {
    // eslint-disable-next-line
    transform(value, ...args) {
        var _a;
        // eslint-disable-next-line
        const convertFunc = (_a = args[0]) !== null && _a !== void 0 ? _a : ((val) => val);
        return convertFunc(value);
    }
}
VgPipeWrapperPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeWrapperPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
VgPipeWrapperPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeWrapperPipe, name: "vgPipeWrapper", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeWrapperPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vgPipeWrapper',
                    pure: false,
                }]
        }] });

class VgAutoInputComponent {
    constructor(inj) {
        this.inj = inj;
        this.text = '';
        // eslint-disable-next-line
        this.value = null;
        this.isFocused = false;
        // eslint-disable-next-line
        this.modelToTextMapper = (obj) => obj['name'];
        // eslint-disable-next-line
        this.resultToModelMapper = (obj) => obj;
        // eslint-disable-next-line
        this.modelToImgSrcMapper = (obj) => obj['url'];
        this.size = 'md';
        this.isDisabled = false;
        this.isReadonly = false;
        // eslint-disable-next-line
        this.searchResults = [];
        this.limit = 10;
        this.placeholder = '';
        // eslint-disable-next-line
        this.itemTemplateCtx = null;
        this.changeTextEvent = new EventEmitter();
        // eslint-disable-next-line
        this.changeValueEvent = 
        // eslint-disable-next-line
        new EventEmitter();
        this.status = 'VALID';
        // eslint-disable-next-line
        this.onChange = (val) => {
            console.debug(val);
        };
        this.onTouched = () => {
            console.debug();
        };
    }
    ngOnInit() {
        this.ngControl = this.inj.get(NgControl);
    }
    ngAfterViewInit() {
        if (this.inputElement) {
            this.inputElement.nativeElement.classList.add(`form-control-${this.size}`);
        }
    }
    ngOnChanges(changes) {
        if (changes.searchResults) {
            this.searchResults = this.searchResults.slice(0, this.limit - 1);
        }
    }
    // eslint-disable-next-line
    selectResult(event, result) {
        this.value = this.resultToModelMapper(result);
        this.text = this.modelToTextMapper(result);
        this.inputElement.nativeElement.value = this.text;
        this.changeTextEvent.emit(this.text);
        this.changeValueEvent.emit(this.value);
        this.onChange(this.value);
        this.onTouched();
        this.isFocused = false;
    }
    inputText(event) {
        if (this.isDisabled) {
            return;
        }
        if (!this.isFocused) {
            this.isFocused = true;
        }
        this.text = event.target.value;
        this.changeTextEvent.emit(this.text);
        this.onChange(null);
        this.onTouched();
    }
    focus() {
        if (this.isDisabled) {
            return;
        }
        this.isFocused = true;
        this.inputElement.nativeElement.focus();
    }
    blur() {
        if (this.isDisabled) {
            return;
        }
        this.isFocused = false;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    // eslint-disable-next-line
    writeValue(obj) {
        this.value = obj;
        this.text = this.modelToTextMapper(obj);
        this.changeValueEvent.emit(this.value);
    }
}
VgAutoInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgAutoInputComponent, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
VgAutoInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgAutoInputComponent, selector: "vg-auto-input", inputs: { modelToTextMapper: "modelToTextMapper", resultToModelMapper: "resultToModelMapper", modelToImgSrcMapper: "modelToImgSrcMapper", size: "size", isDisabled: "isDisabled", isReadonly: "isReadonly", searchResults: "searchResults", limit: "limit", placeholder: "placeholder", itemTemplateRef: "itemTemplateRef", itemTemplateCtx: "itemTemplateCtx" }, outputs: { changeTextEvent: "changeTextEvent", changeValueEvent: "changeValueEvent" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => VgAutoInputComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputElement", first: true, predicate: ["inputElement"], descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div class=\"autocomplete\" (focusin)=\"focus()\" (focusout)=\"blur()\">\n  <input\n    #inputElement\n    type=\"text\"\n    class=\"form-control\"\n    [class.ng-invalid]=\"ngControl['invalid']\"\n    [value]=\"text\"\n    [placeholder]=\"placeholder\"\n    [disabled]=\"isDisabled\"\n    [readOnly]=\"isReadonly\"\n    vgDelayInput\n    (delayInput)=\"inputText($event)\"\n  />\n  <ng-container\n    *ngIf=\"itemTemplateRef; then templateBlock; else noTemplateBlock\"\n  >\n  </ng-container>\n  <ng-template #templateBlock>\n    <div\n      class=\"autocomplete-items\"\n      *ngIf=\"itemTemplateRef; else noTemplateBlock\"\n      [hidden]=\"!isFocused\"\n    >\n      <div\n        *ngFor=\"let result of searchResults\"\n        [ngbTooltip]=\"result | vgPipeWrapper: modelToTextMapper\"\n        (mousedown)=\"$event.preventDefault()\"\n        (click)=\"selectResult($event, result)\"\n      >\n        <ng-container\n          [ngTemplateOutlet]=\"itemTemplateRef\"\n          [ngTemplateOutletContext]=\"{ item: result }\"\n        ></ng-container>\n      </div>\n    </div>\n  </ng-template>\n  <ng-template #noTemplateBlock>\n    <div\n      class=\"autocomplete-items\"\n      *ngIf=\"modelToImgSrcMapper; else noImageBlock\"\n      [hidden]=\"!isFocused\"\n    >\n      <div\n        *ngFor=\"let result of searchResults\"\n        [ngbTooltip]=\"result | vgPipeWrapper: modelToTextMapper\"\n        (mousedown)=\"$event.preventDefault()\"\n        (click)=\"selectResult($event, result)\"\n      >\n        <img\n          class=\"d-inline-block autocomplete-thumb\"\n          [src]=\"result | vgPipeWrapper: modelToImgSrcMapper\"\n          [alt]=\"result | vgPipeWrapper: modelToTextMapper\"\n        />\n        <small class=\"d-inline-block w-75 text-truncate pl-1\">{{\n          result | vgPipeWrapper: modelToTextMapper\n        }}</small>\n      </div>\n    </div>\n  </ng-template>\n  <ng-template #noImageBlock>\n    <div class=\"autocomplete-items\" [hidden]=\"!isFocused\">\n      <div\n        *ngFor=\"let result of searchResults\"\n        [ngbTooltip]=\"result | vgPipeWrapper: modelToTextMapper\"\n        (mousedown)=\"$event.preventDefault()\"\n        (click)=\"selectResult($event, result)\"\n      >\n        <small class=\"d-inline-block w-100 text-truncate pl-1\">{{\n          result | vgPipeWrapper: modelToTextMapper\n        }}</small>\n      </div>\n    </div>\n  </ng-template>\n</div>\n", styles: [":host{display:block}.autocomplete{position:relative;display:inline-block;width:100%;color:#000}.autocomplete-items{position:absolute;border:1px solid #d4d4d4;border-bottom:none;border-top:none;z-index:99;top:100%;left:0;right:0}.autocomplete-items>div{display:flex;align-items:center;padding:.5rem;cursor:pointer;background-color:#fff;border-bottom:1px solid #d4d4d4;box-sizing:content-box}.autocomplete-items.auto-with-thumb>div>img{width:25%}.autocomplete-items.auto-no-thumb>div>img{display:none}.autocomplete-items.auto-with-thumb>div>small{width:75%}.autocomplete-items.auto-no-thumb>div>small{width:100%}.autocomplete-items div:hover{background-color:#e9e9e9}.autocomplete-active{background-color:#1e90ff!important;color:#fff}.autocomplete-thumb{max-height:3rem;max-width:3rem}:host{--lh: 1.4rem;--max-lines: 3}.truncate-overflow{line-height:var(--lh);max-height:calc(var(--lh) * var(--max-lines));overflow:hidden}.truncate-overflow:before{content:\"...\";position:absolute;bottom:0;right:0}\n"], directives: [{ type: VgDelayInputDirective, selector: "[vgDelayInput]", inputs: ["delayTime"], outputs: ["delayInput"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1$1.NgbTooltip, selector: "[ngbTooltip]", inputs: ["animation", "autoClose", "placement", "triggers", "container", "disableTooltip", "tooltipClass", "openDelay", "closeDelay", "ngbTooltip"], outputs: ["shown", "hidden"], exportAs: ["ngbTooltip"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "vgPipeWrapper": VgPipeWrapperPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgAutoInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-auto-input',
                    templateUrl: './vg-auto-input.component.html',
                    styleUrls: ['./vg-auto-input.component.scss'],
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => VgAutoInputComponent),
                            multi: true,
                        },
                    ],
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }]; }, propDecorators: { modelToTextMapper: [{
                type: Input
            }], resultToModelMapper: [{
                type: Input
            }], modelToImgSrcMapper: [{
                type: Input
            }], size: [{
                type: Input
            }], isDisabled: [{
                type: Input
            }], isReadonly: [{
                type: Input
            }], searchResults: [{
                type: Input
            }], limit: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], itemTemplateRef: [{
                type: Input
            }], itemTemplateCtx: [{
                type: Input
            }], changeTextEvent: [{
                type: Output
            }], changeValueEvent: [{
                type: Output
            }], inputElement: [{
                type: ViewChild,
                args: ['inputElement']
            }] } });

class VgErrorDictService {
    constructor() {
        this.messagePrefix = '';
    }
    register(messagePrefix, 
    // eslint-disable-next-line
    service, translateFuncName) {
        this.messagePrefix = messagePrefix;
        this.translateService = service;
        this.translateFuncName = translateFuncName;
    }
    // eslint-disable-next-line
    translate(key, label, argsObj) {
        return this.translateService[this.translateFuncName](`${this.messagePrefix}${key}`, Object.assign({ label }, argsObj));
    }
}
VgErrorDictService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorDictService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
VgErrorDictService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorDictService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorDictService, decorators: [{
            type: Injectable
        }] });

class VgErrorMessagePipe {
    constructor(vgErrorDictService) {
        this.vgErrorDictService = vgErrorDictService;
    }
    // eslint-disable-next-line
    transform(value, ...args) {
        return this.vgErrorDictService.translate(value, args[0], args[1]);
    }
}
VgErrorMessagePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorMessagePipe, deps: [{ token: VgErrorDictService }], target: i0.ɵɵFactoryTarget.Pipe });
VgErrorMessagePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorMessagePipe, name: "vgError", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorMessagePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vgError',
                    pure: false,
                }]
        }], ctorParameters: function () { return [{ type: VgErrorDictService }]; } });

class VgErrorSectionComponent {
    constructor() {
        this.label = 'Label';
    }
    ngOnInit() {
        if (!this.control) {
            this.control = this.group.get(this.controlName);
        }
    }
}
VgErrorSectionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorSectionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
VgErrorSectionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgErrorSectionComponent, selector: "vg-error-section", inputs: { label: "label", group: "group", controlName: "controlName", control: "control" }, ngImport: i0, template: "<p *ngIf=\"control && control.touched && control.errors\">\n  <ng-container *ngIf=\"control.errors?.required; else notRequiredBlock\">\n    <ngb-alert [type]=\"'danger'\" [dismissible]=\"false\" [ngClass]=\"'mt-1'\">\n      <small>{{ \"required\" | vgError: label:control.errors.required }}</small>\n    </ngb-alert>\n  </ng-container>\n  <ng-template #notRequiredBlock>\n    <ngb-alert [type]=\"'danger'\" [dismissible]=\"false\" [ngClass]=\"'mt-1'\">\n      <small\n        *ngFor=\"let error of $any(control.errors) | keyvalue\"\n        class=\"d-block\"\n        >{{ $any(error.key) | vgError: label:$any(error.value) }}</small\n      >\n    </ngb-alert>\n  </ng-template>\n</p>\n", styles: [""], components: [{ type: i1$1.NgbAlert, selector: "ngb-alert", inputs: ["dismissible", "type", "animation"], outputs: ["closed"], exportAs: ["ngbAlert"] }], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "vgError": VgErrorMessagePipe, "keyvalue": i1.KeyValuePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgErrorSectionComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-error-section',
                    templateUrl: './vg-error-section.component.html',
                    styleUrls: ['./vg-error-section.component.scss'],
                }]
        }], propDecorators: { label: [{
                type: Input
            }], group: [{
                type: Input
            }], controlName: [{
                type: Input
            }], control: [{
                type: Input
            }] } });

class VgFileUtil {
    static getFileType(file) {
        switch (file === null || file === void 0 ? void 0 : file.type) {
            case 'audio/mpeg':
            case 'audio/x-m4a':
            case 'audio/flag':
            case 'audio/wave':
                return 'audio';
            case 'video/mp4':
            case 'video/x-matroska':
                return 'video';
            case 'image/jpeg':
            case 'image/png':
            case 'image/gif':
                return 'image';
            case 'application/msword':
            case 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':
                return 'word';
            case 'application/vnd.ms-excel':
            case 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':
                return 'excel';
            case 'application/pdf':
                return 'pdf';
            case 'text/plain':
                return 'text';
            case 'application/x-zip-compressed':
            case '':
                return 'archive';
            case 'application/json':
            case 'text/xml':
                return 'code';
            case 'application/x-msdownload':
                return 'binary';
            default:
                return 'generic';
        }
    }
}

class VgFileIconPipe {
    transform(value) {
        var _a;
        return (_a = VgFileIconPipe.FILE_TYPE_ICON_MAP[value]) !== null && _a !== void 0 ? _a : '';
    }
}
VgFileIconPipe.FILE_TYPE_ICON_MAP = {
    audio: 'bi bi-file-earmark-music',
    video: 'bi bi-file-earmark-play',
    image: 'bi bi-file-earmark-image',
    pdf: 'bi bi-file-earmark-pdf',
    word: 'bi bi-file-earmark-word',
    excel: 'bi bi-file-earmark-spreadsheet',
    powerpoint: 'bi bi-file-earmark-ppt',
    text: 'bi bi-file-earmark-text',
    archive: 'bi bi-file-earmark-zip',
    code: 'bi bi-file-earmark-code',
    binary: 'bi bi-file-earmark-binary',
    generic: 'bi bi-file-earmark',
};
VgFileIconPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFileIconPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
VgFileIconPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFileIconPipe, name: "vgFileIcon" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFileIconPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vgFileIcon',
                }]
        }] });

class VgFileInputComponent {
    constructor(inj, domSanitizer, http) {
        this.inj = inj;
        this.domSanitizer = domSanitizer;
        this.http = http;
        this.placeholder = 'Drop file here or click to browse a file';
        this.formData = new FormData();
        this.formDataFilePart = 'file';
        this.remoteFileType = 'generic';
        this.validateFn = () => true;
        this.metadataLoadedEvent = new EventEmitter();
        this.fileSelectedEvent = new EventEmitter();
        this.isDisabled = false;
        this.isReadonly = false;
        this.fileType = 'generic';
        this.fileReader = new FileReader();
        // eslint-disable-next-line
        this.onChange = (val) => {
            console.debug(val);
        };
        this.onTouched = () => {
            console.debug();
        };
        this.remoteLoaded = true;
    }
    ngOnInit() {
        this.ngControl = this.inj.get(NgControl);
        const initialFile = this.formData.get(this.formDataFilePart);
        if (initialFile) {
            this.processFile(initialFile);
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    writeValue(obj) {
        this.remoteFileSrc = obj;
        if (!this.remoteFileSrc)
            return;
        this.http
            .get(this.remoteFileSrc, {
            observe: 'response',
            responseType: 'blob',
        })
            .subscribe((response) => {
            var _a;
            const tmpFileType = (_a = response.body) === null || _a === void 0 ? void 0 : _a.type;
            if (tmpFileType !== 'application/octet-stream') {
                this.remoteFileType = VgFileUtil.getFileType(response.body);
            }
        }, (error) => {
            console.error(`Error: ${error.message}`);
        });
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    selectFile(event) {
        var _a;
        const target = event.target;
        if ((_a = target.files) === null || _a === void 0 ? void 0 : _a.length) {
            this.processFile(target.files[0]);
        }
    }
    onLoadedMetadata(event) {
        this.metadataLoadedEvent.emit(event);
    }
    dragover(event, dragZone) {
        event.preventDefault();
        dragZone.classList.add('file-dragover');
    }
    dragend(event, dragZone) {
        event.preventDefault();
        dragZone.classList.remove('file-dragover');
    }
    drop(event, dragZone) {
        var _a, _b;
        event.preventDefault();
        dragZone.classList.remove('file-dragover');
        if ((_b = (_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.files) === null || _b === void 0 ? void 0 : _b.length) {
            this.processFile(event.dataTransfer.files[0]);
        }
    }
    processFile(file) {
        if (this.isDisabled) {
            return;
        }
        const isValid = this.validateFn(file);
        if (!isValid)
            return;
        this.file = file;
        console.debug(file.type, typeof file.type, file.type === '');
        this.fileType = VgFileUtil.getFileType(this.file);
        if (this.fileType === 'audio' || this.fileType === 'video') {
            const url = URL.createObjectURL(this.file);
            this.fileSrc = this.domSanitizer.bypassSecurityTrustResourceUrl(url);
        }
        else {
            this.fileReader.readAsDataURL(this.file);
            this.fileReader.onload = (event) => {
                var _a;
                this.fileSrc = (_a = event.target) === null || _a === void 0 ? void 0 : _a.result;
            };
        }
        this.onTouched();
        this.formData.set(this.formDataFilePart, this.file);
        this.fileSelectedEvent.emit(file);
    }
    clearFile(event) {
        var _a;
        event.stopPropagation();
        this.file = null;
        this.fileType = 'generic';
        this.fileSrc = null;
        this.onChange((_a = this.remoteFileSrc) !== null && _a !== void 0 ? _a : null);
        this.onTouched();
        this.formData.delete(this.formDataFilePart);
    }
    resolveRemote(value) {
        this.remoteLoaded = value;
    }
    browseFile(fileInput) {
        if (this.isDisabled || this.isReadonly)
            return;
        fileInput.click();
    }
    onErrorLoad() {
        this.remoteFileSrc = null;
    }
}
VgFileInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFileInputComponent, deps: [{ token: i0.Injector }, { token: i1$2.DomSanitizer }, { token: i1$3.HttpClient }], target: i0.ɵɵFactoryTarget.Component });
VgFileInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgFileInputComponent, selector: "vg-file-input", inputs: { placeholder: "placeholder", formData: "formData", formDataFilePart: "formDataFilePart", remoteFileType: "remoteFileType", validateFn: "validateFn", isDisabled: "isDisabled", isReadonly: "isReadonly" }, outputs: { metadataLoadedEvent: "metadataLoadedEvent", fileSelectedEvent: "fileSelectedEvent" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => VgFileInputComponent),
            multi: true,
        },
    ], ngImport: i0, template: "<div class=\"form-group\">\n  <div\n    #dragZone\n    class=\"\n      file-drag-zone\n      d-flex\n      justify-content-center\n      align-items-center\n      flex-wrap\n    \"\n    draggable=\"true\"\n    [class.file-drag-zone-disabled]=\"isDisabled || isReadonly\"\n    (dragover)=\"dragover($event, dragZone)\"\n    (dragend)=\"dragend($event, dragZone)\"\n    (dragleave)=\"dragend($event, dragZone)\"\n    (dragexit)=\"dragend($event, dragZone)\"\n    (drop)=\"drop($event, dragZone)\"\n    (click)=\"browseFile(fileInput)\"\n  >\n    <i\n      *ngIf=\"file\"\n      class=\"bi bi-x-square-fill file-clear\"\n      (click)=\"clearFile($event)\"\n    ></i>\n    <ng-container\n      *ngIf=\"file; then hasFileBlock; else emptyFileBlock\"\n    ></ng-container>\n    <ng-template #hasFileBlock>\n      <ng-container\n        [ngTemplateOutlet]=\"filePreview\"\n        [ngTemplateOutletContext]=\"{\n          fileType: fileType,\n          fileSrc: fileSrc,\n          filePlaceholder: file?.name\n        }\"\n      ></ng-container>\n    </ng-template>\n    <ng-template #emptyFileBlock>\n      <ng-container\n        [ngTemplateOutlet]=\"filePreview\"\n        [ngTemplateOutletContext]=\"{\n          fileType: remoteFileType,\n          fileSrc: remoteFileSrc,\n          filePlaceholder: placeholder\n        }\"\n      >\n      </ng-container>\n    </ng-template>\n  </div>\n  <input\n    #fileInput\n    type=\"file\"\n    class=\"custom-file-input d-none\"\n    id=\"file\"\n    (change)=\"selectFile($event)\"\n  />\n</div>\n<ng-template\n  #filePreview\n  let-dropZonePlaceholder=\"filePlaceholder\"\n  let-src=\"fileSrc\"\n  let-type=\"fileType\"\n>\n  <div class=\"file-drag-zone-placeholder\" [hidden]=\"isDisabled\">\n    <span>{{ dropZonePlaceholder }}</span>\n  </div>\n  <ng-container [ngSwitch]=\"type\">\n    <ng-template ngSwitchCase=\"image\">\n      <div class=\"file-preview\">\n        <img\n          *ngIf=\"src; else fallbackIconImage\"\n          class=\"file-preview-image\"\n          [src]=\"src\"\n          alt=\"imagePreview\"\n          (loadedmetadata)=\"onLoadedMetadata($event)\"\n          (error)=\"onErrorLoad()\"\n        />\n        <ng-template #fallbackIconImage>\n          <i [className]=\"type | vgFileIcon\"></i>\n        </ng-template>\n      </div>\n    </ng-template>\n    <ng-template ngSwitchCase=\"audio\">\n      <div class=\"w-100\" *ngIf=\"src\" [hidden]=\"isDisabled\"></div>\n      <div class=\"file-preview-large\">\n        <audio\n          *ngIf=\"src; else fallbackIconAudio\"\n          class=\"file-preview-audio\"\n          [src]=\"src\"\n          (loadedmetadata)=\"onLoadedMetadata($event)\"\n          (error)=\"onErrorLoad()\"\n          controls\n        ></audio>\n        <ng-template #fallbackIconAudio>\n          <i [className]=\"type | vgFileIcon\"></i>\n        </ng-template>\n      </div>\n    </ng-template>\n    <ng-template ngSwitchCase=\"video\">\n      <div class=\"w-100\" *ngIf=\"src\" [hidden]=\"isDisabled\"></div>\n      <div class=\"file-preview-large\">\n        <video\n          *ngIf=\"src; else fallbackIconVideo\"\n          class=\"file-preview-video\"\n          [src]=\"src\"\n          (loadedmetadata)=\"onLoadedMetadata($event)\"\n          (error)=\"onErrorLoad()\"\n          controls\n        ></video>\n        <ng-template #fallbackIconVideo>\n          <i [className]=\"type | vgFileIcon\"></i>\n        </ng-template>\n      </div>\n    </ng-template>\n    <ng-template ngSwitchDefault>\n      <div class=\"file-preview\">\n        <i [className]=\"type | vgFileIcon\"></i>\n      </div>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: [".file-drag-zone{margin-top:1rem;border:1px solid black;min-width:80%;height:auto;min-height:5rem;position:relative}.file-drag-zone .file-drag-zone-placeholder{color:#1e90ff}.file-drag-zone:hover{cursor:pointer}.file-drag-zone-disabled,.file-drag-zone-disabled>*{background-color:#cdcdcd}.file-drag-zone-disabled:hover,.file-drag-zone-disabled>*:hover{cursor:auto}.file-dragover{border:2px dashed black}.file-clear{display:block;position:absolute;top:-.125em;right:0;font-size:1.2rem}.file-preview{display:flex;justify-content:center;align-items:center;width:50px;height:50px}.file-preview i{font-size:1.5rem}.file-preview .file-preview-image{height:100%;width:100%}.file-preview-large{display:block}.file-preview-large i{font-size:1.5rem}.file-preview-large .file-preview-audio{min-width:20rem;min-height:2rem;width:auto;height:auto;max-width:25rem;max-height:2.5rem}.file-preview-large .file-preview-video{min-width:25rem;min-height:10rem;width:auto;height:auto;max-width:30rem;max-height:12rem}.file-placeholder{display:flex;justify-content:center;align-items:center;width:80%;height:100%}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "vgFileIcon": VgFileIconPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFileInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-file-input',
                    templateUrl: './vg-file-input.component.html',
                    styleUrls: ['./vg-file-input.component.scss'],
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => VgFileInputComponent),
                            multi: true,
                        },
                    ],
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }, { type: i1$2.DomSanitizer }, { type: i1$3.HttpClient }]; }, propDecorators: { placeholder: [{
                type: Input
            }], formData: [{
                type: Input
            }], formDataFilePart: [{
                type: Input
            }], remoteFileType: [{
                type: Input
            }], validateFn: [{
                type: Input
            }], metadataLoadedEvent: [{
                type: Output
            }], fileSelectedEvent: [{
                type: Output
            }], isDisabled: [{
                type: Input
            }], isReadonly: [{
                type: Input
            }] } });

class VgTagInputComponent {
    constructor(inj) {
        this.inj = inj;
        // eslint-disable-next-line
        this.values = [];
        this.text = '';
        // eslint-disable-next-line
        this.onChange = (val) => {
            console.debug(val);
        };
        this.onTouched = () => {
            console.debug();
        };
        this.isReadonly = false;
        this.size = 'md';
        // eslint-disable-next-line
        this.modelToTextConverter = (model) => model.name;
        // eslint-disable-next-line
        this.textToModelConverter = (text) => {
            return {
                name: text,
            };
        };
    }
    ngOnInit() {
        this.ngControl = this.inj.get(NgControl);
    }
    ngAfterViewInit() {
        if (this.inputElement) {
            this.inputElement.nativeElement.classList.add(`form-control-${this.size}`);
        }
    }
    // eslint-disable-next-line
    writeValue(tagList) {
        this.values = tagList;
        this.text = Array.from(new Set(this.values.map((e) => this.modelToTextConverter(e)))).join(',');
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.isDisabled = isDisabled;
    }
    inputText(event) {
        const target = event.target;
        this.values = target.value
            .split(',')
            .map((e) => e.trim())
            .filter((e) => e !== '')
            .map((e) => this.textToModelConverter(e));
        this.onChange(this.values);
        this.onTouched();
    }
}
VgTagInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTagInputComponent, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
VgTagInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgTagInputComponent, selector: "vg-tag-input", inputs: { placeholder: "placeholder", isDisabled: "isDisabled", isReadonly: "isReadonly", size: "size", modelToTextConverter: "modelToTextConverter", textToModelConverter: "textToModelConverter" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => VgTagInputComponent),
            multi: true,
        },
    ], viewQueries: [{ propertyName: "inputElement", first: true, predicate: ["inputElement"], descendants: true }], ngImport: i0, template: "<input\n  #inputElement\n  type=\"text\"\n  class=\"form-control\"\n  [class.ng-invalid]=\"ngControl['invalid']\"\n  [value]=\"text\"\n  [placeholder]=\"placeholder\"\n  [disabled]=\"isDisabled\"\n  [readOnly]=\"isReadonly\"\n  vgDelayInput\n  (delayInput)=\"inputText($event)\"\n/>\n", styles: [""], directives: [{ type: VgDelayInputDirective, selector: "[vgDelayInput]", inputs: ["delayTime"], outputs: ["delayInput"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTagInputComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-tag-input',
                    templateUrl: './vg-tag-input.component.html',
                    styleUrls: ['./vg-tag-input.component.scss'],
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => VgTagInputComponent),
                            multi: true,
                        },
                    ],
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }]; }, propDecorators: { placeholder: [{
                type: Input
            }], isDisabled: [{
                type: Input
            }], isReadonly: [{
                type: Input
            }], size: [{
                type: Input
            }], modelToTextConverter: [{
                type: Input
            }], textToModelConverter: [{
                type: Input
            }], inputElement: [{
                type: ViewChild,
                args: ['inputElement']
            }] } });

class VgControlModule {
    static forRoot(loader) {
        return {
            ngModule: VgControlModule,
            providers: [loader],
        };
    }
}
VgControlModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgControlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgControlModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgControlModule, declarations: [VgAutoInputComponent,
        VgErrorSectionComponent,
        VgErrorMessagePipe,
        VgDelayInputDirective,
        VgFileInputComponent,
        VgFileIconPipe,
        VgPipeWrapperPipe,
        VgTagInputComponent], imports: [CommonModule, NgbTooltipModule, NgbAlertModule], exports: [VgAutoInputComponent,
        VgFileInputComponent,
        VgErrorSectionComponent,
        VgErrorMessagePipe,
        VgDelayInputDirective,
        VgTagInputComponent] });
VgControlModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgControlModule, providers: [VgErrorDictService], imports: [[CommonModule, NgbTooltipModule, NgbAlertModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgControlModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        VgAutoInputComponent,
                        VgErrorSectionComponent,
                        VgErrorMessagePipe,
                        VgDelayInputDirective,
                        VgFileInputComponent,
                        VgFileIconPipe,
                        VgPipeWrapperPipe,
                        VgTagInputComponent,
                    ],
                    imports: [CommonModule, NgbTooltipModule, NgbAlertModule],
                    exports: [
                        VgAutoInputComponent,
                        VgFileInputComponent,
                        VgErrorSectionComponent,
                        VgErrorMessagePipe,
                        VgDelayInputDirective,
                        VgTagInputComponent,
                    ],
                    providers: [VgErrorDictService],
                }]
        }] });

class VgTreeTableBlockConfigPipe {
    // eslint-disable-next-line
    transform(value, ...args) {
        return Object.assign(Object.assign({}, value), { [args[0]]: args[1] < args[2] });
    }
}
VgTreeTableBlockConfigPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableBlockConfigPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
VgTreeTableBlockConfigPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableBlockConfigPipe, name: "vgTreeTableBlock", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableBlockConfigPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vgTreeTableBlock',
                    pure: false,
                }]
        }] });

class VgTreeTableItemComponent {
    constructor(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
        this.checkEvent = new EventEmitter();
        // eslint-disable-next-line
        this.selectRowEvent = new EventEmitter();
    }
    ngOnInit() {
        this.viewContainerRef.createEmbeddedView(this.template);
    }
    expand(event, treeItem) {
        event.stopPropagation();
        treeItem.expanded = !treeItem.expanded;
    }
    check(event, key, config) {
        var _a;
        event.stopPropagation();
        const checked = (_a = event.target) === null || _a === void 0 ? void 0 : _a.checked;
        this.treeItem.data[key] = checked;
        if (config === null || config === void 0 ? void 0 : config.checkboxHorizontalCascade) {
            config.checkboxHorizontalCascade.forEach((cascade) => {
                if (checked) {
                    this.treeItem.data[cascade.key] = true;
                    this.treeItem.isDisabled[cascade.key] = true;
                }
                else {
                    this.treeItem.isDisabled[cascade.key] = false;
                }
                this.checkEvent.emit({
                    key: cascade.key,
                    checked: this.treeItem.data[cascade.key],
                    node: this.treeItem,
                });
            });
        }
        this.checkEvent.emit({
            key: key,
            checked: checked,
            node: this.treeItem,
        });
    }
    forwardCheck(event) {
        const config = this.treeTableConfig.columns.find((columnConfig) => columnConfig.key === event.key);
        if (config === null || config === void 0 ? void 0 : config.checkboxVerticalCascade) {
            this.treeItem.data[event.key] = this.treeItem.children.every((childNode) => childNode.data[event.key]);
        }
        this.checkEvent.emit(event);
    }
    selectRow(node) {
        this.selectRowEvent.emit(node);
    }
    forwardSelectRow(node) {
        this.selectRowEvent.emit(node);
    }
}
VgTreeTableItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableItemComponent, deps: [{ token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component });
VgTreeTableItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgTreeTableItemComponent, selector: "vg-tree-table-item", inputs: { treeTableConfig: "treeTableConfig", treeItem: "treeItem", paddingBlockConfig: "paddingBlockConfig" }, outputs: { checkEvent: "checkEvent", selectRowEvent: "selectRowEvent" }, viewQueries: [{ propertyName: "template", first: true, predicate: ["template"], descendants: true, static: true }], ngImport: i0, template: "<ng-template #template>\n  <tr (click)=\"selectRow(treeItem)\" tabindex=\"0\" (blur)=\"selectRow(null)\">\n    <td class=\"m-0\">\n      <span\n        *ngFor=\"\n          let metadata of paddingBlockConfig | keyvalue;\n          index as i;\n          count as size\n        \"\n        class=\"tree-table-space-block\"\n        [class.y-line]=\"metadata.value\"\n        [class.last-block]=\"i === size - 1\"\n      ></span>\n      <span\n        *ngIf=\"treeItem.children.length; else emptyBtn\"\n        (click)=\"expand($event, treeItem)\"\n        class=\"tree-table-space-block btn-toggle font-weight-bold\"\n      >\n        {{ treeItem.expanded ? \"-\" : \"+\" }}\n      </span>\n      <ng-template #emptyBtn>\n        <span class=\"tree-table-space-block btn-toggle\"></span>\n      </ng-template>\n    </td>\n    <td *ngFor=\"let columnConfig of treeTableConfig.columns\">\n      <div\n        [ngSwitch]=\"columnConfig.type\"\n        [className]=\"columnConfig.customClass ?? ''\"\n      >\n        <ng-container *ngSwitchCase=\"'CUSTOM'\">\n          <div\n            [ngTemplateOutlet]=\"columnConfig.templateRef ?? null\"\n            [ngTemplateOutletContext]=\"$any(treeItem.data) ?? null\"\n          ></div>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'CHECKBOX'\">\n          <label class=\"container\">\n            <input\n              type=\"checkbox\"\n              [disabled]=\"\n                treeItem.isDisabled\n                  ? treeItem.isDisabled[columnConfig.key]\n                  : false\n              \"\n              [checked]=\"$any(treeItem?.data)[columnConfig.key]\"\n              (change)=\"check($event, columnConfig.key, columnConfig)\"\n            />\n            <span class=\"checkmark\"></span>\n          </label>\n        </ng-container>\n        <ng-container *ngSwitchDefault>\n          <span>{{ $any(treeItem?.data)[columnConfig.key] }}</span>\n        </ng-container>\n      </div>\n    </td>\n  </tr>\n  <ng-container *ngIf=\"treeItem.expanded\">\n    <vg-tree-table-item\n      *ngFor=\"let item of treeItem.children; index as i\"\n      [treeTableConfig]=\"treeTableConfig\"\n      [treeItem]=\"item\"\n      [paddingBlockConfig]=\"\n        paddingBlockConfig\n          | vgTreeTableBlock: item.level:i:treeItem.children.length - 1\n      \"\n      (selectRowEvent)=\"forwardSelectRow($event)\"\n      (checkEvent)=\"forwardCheck($event)\"\n    >\n    </vg-tree-table-item>\n  </ng-container>\n</ng-template>\n", styles: ["tr:hover,tr:focus{cursor:pointer;background:darkgrey}.tree-table-space-block{border:3px solid transparent;display:inline-block;width:30px;height:20px;line-height:16px;text-align:center;vertical-align:top;position:relative;box-sizing:border-box;border-radius:50%}.tree-table-space-block.y-line:before{position:absolute;content:\"\";width:3px;height:45px;background:#d9d9d9;left:50%;top:-40px}.tree-table-space-block.last-block:before{position:absolute;content:\"\";width:3px;height:45px;background:#d9d9d9;left:50%;top:-40px}.tree-table-space-block.last-block:after{position:absolute;content:\"\";width:30px;height:3px;background:#d9d9d9;top:50%;margin-top:-1px}.tree-table-space-block.btn-toggle{border:3px solid #d9d9d9;position:relative;cursor:pointer;width:22px;height:22px;line-height:14px;z-index:1;background:white;left:6px;font-size:1.3rem}.tree-table-space-block.btn-toggle.first-child:before{display:none}.tree-table-space-block.btn-toggle:after{display:none}.tree-table-space-block.is-first-row:before{display:none!important}.container{display:block;position:relative;padding-left:35px;margin-bottom:12px;cursor:pointer;font-size:22px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}.checkmark{position:absolute;border-radius:3px;top:0;height:1.2rem;width:1.2rem;background-color:#eee}.container:hover input~.checkmark{background-color:#ccc}.container input:checked~.checkmark{background-color:#2196f3}.checkmark:after{content:\"\";position:absolute;display:none}.container input:checked~.checkmark:after{display:block}.container .checkmark:after{left:.5rem;top:.2rem;width:5px;height:10px;border:solid white;border-width:0 3px 3px 0;transform:rotate(45deg)}\n"], components: [{ type: VgTreeTableItemComponent, selector: "vg-tree-table-item", inputs: ["treeTableConfig", "treeItem", "paddingBlockConfig"], outputs: ["checkEvent", "selectRowEvent"] }], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "keyvalue": i1.KeyValuePipe, "vgTreeTableBlock": VgTreeTableBlockConfigPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableItemComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-tree-table-item',
                    templateUrl: './vg-tree-table-item.component.html',
                    styleUrls: ['./vg-tree-table-item.component.scss'],
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }]; }, propDecorators: { treeTableConfig: [{
                type: Input
            }], treeItem: [{
                type: Input
            }], paddingBlockConfig: [{
                type: Input
            }], checkEvent: [{
                type: Output
            }], selectRowEvent: [{
                type: Output
            }], template: [{
                type: ViewChild,
                args: ['template', { static: true }]
            }] } });

class VgTreeTableComponent {
    constructor() {
        this.treeItems = [];
        this.checkNodeEvent = new EventEmitter();
        this.selectRowEvent = new EventEmitter();
    }
    ngOnInit() {
        console.debug(this.treeItems);
    }
    check(event) {
        this.checkNodeEvent.emit(event);
    }
    selectRow(node) {
        this.selectedNode = node;
        this.selectRowEvent.emit(node);
    }
}
VgTreeTableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
VgTreeTableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgTreeTableComponent, selector: "vg-tree-table", inputs: { treeTableConfig: "treeTableConfig", treeItems: "treeItems" }, outputs: { checkNodeEvent: "checkNodeEvent", selectRowEvent: "selectRowEvent" }, ngImport: i0, template: "<table class=\"table table-bordered table-responsive-md\">\n  <thead>\n    <tr>\n      <td></td>\n      <td\n        *ngFor=\"let columnConfig of treeTableConfig.columns\"\n        class=\"text-center font-weight-bold\"\n      >\n        {{ columnConfig.title }}\n      </td>\n    </tr>\n  </thead>\n  <tbody>\n    <vg-tree-table-item\n      *ngFor=\"let treeItem of treeItems; index as i\"\n      [treeTableConfig]=\"treeTableConfig\"\n      [paddingBlockConfig]=\"\n        {} | vgTreeTableBlock: treeItem.level:i:treeItems.length - 1\n      \"\n      [treeItem]=\"treeItem\"\n      (selectRowEvent)=\"selectRow($event)\"\n      (checkEvent)=\"check($event)\"\n    >\n    </vg-tree-table-item>\n  </tbody>\n</table>\n", styles: [":host ::ng-deep tbody tr:nth-child(2) td:first-child span:first-child.tree-table-space-block:before{display:none!important}\n"], components: [{ type: VgTreeTableItemComponent, selector: "vg-tree-table-item", inputs: ["treeTableConfig", "treeItem", "paddingBlockConfig"], outputs: ["checkEvent", "selectRowEvent"] }], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "vgTreeTableBlock": VgTreeTableBlockConfigPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-tree-table',
                    templateUrl: './vg-tree-table.component.html',
                    styleUrls: ['./vg-tree-table.component.scss'],
                }]
        }], propDecorators: { treeTableConfig: [{
                type: Input
            }], treeItems: [{
                type: Input
            }], checkNodeEvent: [{
                type: Output
            }], selectRowEvent: [{
                type: Output
            }] } });

class VgHoverClassDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.hoverClass = '';
    }
    onMouseEnter() {
        if (this.focusedElement) {
            return;
        }
        this.elementRef.nativeElement.classList.add(this.hoverClass);
    }
    onMouseLeave() {
        if (this.focusedElement) {
            return;
        }
        this.elementRef.nativeElement.classList.remove(this.hoverClass);
    }
    onFocus() {
        this.elementRef.nativeElement.classList.add(this.hoverClass);
        this.focusedElement = this.elementRef;
    }
    onBlur() {
        this.elementRef.nativeElement.classList.remove(this.hoverClass);
        this.focusedElement = null;
    }
}
VgHoverClassDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHoverClassDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
VgHoverClassDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgHoverClassDirective, selector: "[vgHoverClass]", inputs: { hoverClass: "hoverClass" }, host: { listeners: { "mouseenter": "onMouseEnter()", "mouseleave": "onMouseLeave()", "focus": "onFocus()", "blur": "onBlur()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHoverClassDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgHoverClass]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { hoverClass: [{
                type: Input
            }], onMouseEnter: [{
                type: HostListener,
                args: ['mouseenter']
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }], onFocus: [{
                type: HostListener,
                args: ['focus']
            }], onBlur: [{
                type: HostListener,
                args: ['blur']
            }] } });

class VgTreeLevelArrayPipePipe {
    // eslint-disable-next-line
    transform(value) {
        return new Array(value + 1);
    }
}
VgTreeLevelArrayPipePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeLevelArrayPipePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
VgTreeLevelArrayPipePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeLevelArrayPipePipe, name: "vgTreeLevel", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeLevelArrayPipePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vgTreeLevel',
                    pure: false,
                }]
        }] });

class VgLightTreeTableComponent {
    constructor() {
        this.treeTableConfig = {
            columns: [],
        };
        // eslint-disable-next-line
        this.treeItems = [];
        this.idKey = 'id';
        this.parentIdKey = 'parent_id';
        this.rootId = 'root';
        // eslint-disable-next-line
        this.selectRowEvent = 
        // eslint-disable-next-line
        new EventEmitter();
        // eslint-disable-next-line
        this.sortedNodeList = [];
        // eslint-disable-next-line
        this.internalTreeMap = {};
        this.useInternalTreeMap = false;
    }
    ngOnChanges(changes) {
        if (changes.treeItems) {
            this.useInternalTreeMap = !this.treeMap;
            if (!this.useInternalTreeMap) {
                this.internalTreeMap = this.treeMap;
            }
            // eslint-disable-next-line
            const nodeList = [];
            const seqObj = { sequence: 0 };
            const initialPaddingBlock = { [0]: true };
            // eslint-disable-next-line
            const rootNode = {
                data: { id: this.rootId, parentId: null },
                children: [],
                level: -1,
                isDisabled: {},
                isFixed: {},
                sequence: -1,
                paddingBlock: {},
            };
            this.treeItems.forEach((node, i) => {
                if (node.data[this.parentIdKey] !== this.rootId) {
                    node.data[this.parentIdKey] = this.rootId;
                }
                rootNode.children.push(node);
                this.processTreeSequenceAndLevel(node, nodeList, seqObj, 0, Object.assign({}, initialPaddingBlock), i === this.treeItems.length - 1);
            });
            if (this.useInternalTreeMap) {
                this.internalTreeMap[this.rootId] = rootNode;
            }
            nodeList.sort((a, b) => a.sequence - b.sequence);
            this.sortedNodeList = nodeList;
        }
    }
    processTreeSequenceAndLevel(
    // eslint-disable-next-line
    node, 
    // eslint-disable-next-line
    nodeList, seqObj, level, paddingBlock, isLastChild) {
        seqObj.sequence++;
        node.sequence = seqObj.sequence;
        node.level = level;
        node.paddingBlock = paddingBlock;
        nodeList.push(node);
        if (this.useInternalTreeMap) {
            this.internalTreeMap[node.data[this.idKey]] = node;
        }
        node.children.forEach((childNode, i) => {
            this.processTreeSequenceAndLevel(childNode, nodeList, seqObj, level + 1, Object.assign(Object.assign({}, node.paddingBlock), { [node.level]: !isLastChild }), i === node.children.length - 1);
        });
    }
    // eslint-disable-next-line
    selectRow(event, treeItem) {
        event.stopPropagation();
        this.selectedNode = treeItem;
        this.selectRowEvent.emit(this.selectedNode);
    }
    // eslint-disable-next-line
    hideChildren(treeItem) {
        treeItem.hidden = true;
        treeItem.children.forEach((childNode) => {
            this.hideChildren(childNode);
        });
    }
    // eslint-disable-next-line
    showChildren(treeItem) {
        treeItem.hidden = false;
        if (treeItem.expanded) {
            treeItem.children.forEach((childNode) => {
                this.showChildren(childNode);
            });
        }
        else {
            treeItem.children.forEach((childNode) => {
                this.hideChildren(childNode);
            });
        }
    }
    // eslint-disable-next-line
    expand(event, treeItem) {
        event.stopPropagation();
        const expanded = !treeItem.expanded;
        treeItem.expanded = expanded;
        if (expanded) {
            treeItem.children.forEach((childNode) => {
                this.showChildren(childNode);
            });
        }
        else {
            treeItem.children.forEach((childNode) => {
                this.hideChildren(childNode);
            });
        }
    }
    // eslint-disable-next-line
    checkParents(treeItem, key) {
        // eslint-disable-next-line
        const parentNode = this.internalTreeMap[treeItem.data[this.parentIdKey]];
        if (parentNode) {
            parentNode.data[key] = parentNode.children.every((childNode) => childNode.data[key]);
            this.checkParents(parentNode, key);
        }
    }
    checkChildren(
    // eslint-disable-next-line
    treeItem, key, checked) {
        treeItem.data[key] = checked;
        treeItem.children.forEach((childNode) => {
            this.checkChildren(childNode, key, checked);
        });
    }
    check(event, columnConfig, 
    // eslint-disable-next-line
    node) {
        var _a;
        event.stopPropagation();
        const checked = (_a = event.target) === null || _a === void 0 ? void 0 : _a.checked;
        node.data[columnConfig.key] = checked;
        if (columnConfig === null || columnConfig === void 0 ? void 0 : columnConfig.checkboxVerticalCascade) {
            this.checkChildren(node, columnConfig.key, checked);
            this.checkParents(node, columnConfig.key);
        }
    }
    checkAll(event, columnConfig) {
        var _a;
        event.stopPropagation();
        const checked = (_a = event.target) === null || _a === void 0 ? void 0 : _a.checked;
        this.treeItems.forEach((node) => {
            this.checkChildren(node, columnConfig.key, checked);
        });
    }
}
VgLightTreeTableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLightTreeTableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
VgLightTreeTableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgLightTreeTableComponent, selector: "vg-light-tree-table", inputs: { treeTableConfig: "treeTableConfig", treeItems: "treeItems", treeMap: "treeMap", idKey: "idKey", parentIdKey: "parentIdKey", rootId: "rootId" }, outputs: { selectRowEvent: "selectRowEvent" }, usesOnChanges: true, ngImport: i0, template: "<table class=\"table table-bordered table-responsive-md\">\n  <thead>\n    <tr>\n      <th [style]=\"{ width: '30%' }\"></th>\n      <th\n        *ngFor=\"let columnConfig of treeTableConfig.columns\"\n        class=\"text-center font-weight-bold\"\n        [style]=\"{ width: columnConfig.width ? columnConfig.width : 'auto' }\"\n      >\n        <ng-container [ngSwitch]=\"columnConfig.type\">\n          <ng-container *ngSwitchCase=\"'CHECKBOX'\">\n            <span>{{ columnConfig.title }}</span>\n            <label class=\"container\">\n              <input\n                type=\"checkbox\"\n                [checked]=\"$any(internalTreeMap[rootId].data)[columnConfig.key]\"\n                (change)=\"checkAll($event, columnConfig)\"\n              />\n              <span class=\"checkmark\"></span>\n            </label>\n          </ng-container>\n          <ng-container *ngSwitchDefault>\n            {{ columnConfig.title }}\n          </ng-container>\n        </ng-container>\n      </th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr\n      *ngFor=\"let treeItem of sortedNodeList\"\n      tabindex=\"0\"\n      [class.d-none]=\"treeItem.hidden\"\n      (click)=\"selectRow($event, treeItem)\"\n      (blur)=\"selectRow($event)\"\n      vgHoverClass\n      [hoverClass]=\"'table-active'\"\n    >\n      <td class=\"m-0\" [style]=\"{ width: '30%' }\">\n        <span\n          *ngFor=\"\n            let item of treeItem.level | vgTreeLevel;\n            index as j;\n            count as size\n          \"\n          class=\"tree-table-space-block\"\n          [class.y-line]=\"treeItem.paddingBlock[j]\"\n          [class.last-block]=\"j === size - 1\"\n        >\n        </span>\n        <span\n          *ngIf=\"treeItem.children.length; else emptyBtn\"\n          (click)=\"expand($event, treeItem)\"\n          class=\"tree-table-space-block btn-toggle font-weight-bold\"\n        >\n          {{ treeItem.expanded ? \"-\" : \"+\" }}</span\n        >\n      </td>\n      <td\n        *ngFor=\"let columnConfig of treeTableConfig.columns\"\n        [style]=\"{ width: columnConfig.width ? columnConfig.width : 'auto' }\"\n      >\n        <div\n          [ngSwitch]=\"columnConfig.type\"\n          [className]=\"columnConfig.customClass ? columnConfig.customClass : ''\"\n        >\n          <ng-container\n            *ngSwitchCase=\"'CUSTOM'\"\n            [ngTemplateOutlet]=\"columnConfig.templateRef ?? null\"\n            [ngTemplateOutletContext]=\"{\n              columnConfig: columnConfig,\n              treeItem: treeItem\n            }\"\n          >\n          </ng-container>\n          <ng-container\n            *ngSwitchCase=\"'CHECKBOX'\"\n            [ngTemplateOutlet]=\"\n              treeItem.isFixed[columnConfig.key]\n                ? fixedCheckbox\n                : normalCheckbox\n            \"\n            [ngTemplateOutletContext]=\"{\n              columnConfig: columnConfig,\n              treeItem: treeItem\n            }\"\n          >\n          </ng-container>\n          <ng-container *ngSwitchDefault>\n            <span>{{ $any(treeItem?.data)[columnConfig.key] }}</span>\n          </ng-container>\n        </div>\n      </td>\n    </tr>\n  </tbody>\n</table>\n<ng-template\n  #normalCheckbox\n  let-columnConfig=\"columnConfig\"\n  let-treeItem=\"treeItem\"\n>\n  <label class=\"container\">\n    <input\n      type=\"checkbox\"\n      [disabled]=\"\n        treeItem.isDisabled[columnConfig.key] ||\n        treeItem?.data[columnConfig.checkboxHorizontalCascadedBy]\n      \"\n      [checked]=\"\n        treeItem?.data[columnConfig.key] ||\n        treeItem?.data[columnConfig.checkboxHorizontalCascadedBy]\n      \"\n      (change)=\"check($event, columnConfig, treeItem)\"\n    />\n    <span class=\"checkmark\"></span>\n  </label>\n</ng-template>\n<ng-template\n  #fixedCheckbox\n  let-columnConfig=\"columnConfig\"\n  let-treeItem=\"treeItem\"\n>\n  <label class=\"container\" *ngIf=\"treeItem.isFixed[columnConfig.key]\">\n    <input\n      type=\"checkbox\"\n      [disabled]=\"true\"\n      [checked]=\"treeItem?.data[columnConfig.key]\"\n    />\n    <span class=\"checkmark\"></span>\n  </label>\n</ng-template>\n<ng-template #emptyBtn>\n  <span class=\"tree-table-space-block btn-leaf\"></span>\n</ng-template>\n", styles: [":host ::ng-deep tbody tr:nth-child(1) td:first-child span:first-child.tree-table-space-block:before{display:none!important}tr:hover,tr:focus{cursor:pointer}.tree-table-space-block{border:2px solid transparent;display:inline-block;width:30px;height:20px;line-height:12px;text-align:center;vertical-align:top;position:relative;box-sizing:border-box}.tree-table-space-block.y-line:before{position:absolute;content:\"\";width:2px;height:46px;background:black;left:50%;top:-38px}.tree-table-space-block.last-block:before{position:absolute;content:\"\";width:2px;height:46px;background:black;left:50%;top:-38px}.tree-table-space-block.last-block:after{position:absolute;content:\"\";width:30px;height:2px;background:black;top:50%;margin-top:-1px}.tree-table-space-block.btn-toggle{border:2px solid black;position:relative;cursor:pointer;width:1rem;height:1rem;line-height:10px;z-index:1;background:white;top:.1rem;left:.5rem;font-size:1rem;color:#000}.tree-table-space-block.btn-leaf{border:2px solid black;position:relative;cursor:none;width:.5rem;height:.5rem;line-height:5px;z-index:1;background:white;top:.4rem;left:.5rem;font-size:.5rem;color:#000;border-radius:50%}.tree-table-space-block.btn-toggle.first-child:before{display:none}.tree-table-space-block.btn-toggle:after{display:none}.tree-table-space-block.is-first-row:before{display:none!important}.container{display:block;position:relative;padding-left:35px;margin-bottom:12px;cursor:pointer;font-size:22px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}.checkmark{position:absolute;border-radius:3px;top:30%;left:40%;height:1.2rem;width:1.2rem;background-color:#eee}.container:hover input~.checkmark{background-color:#ccc}.container input:checked~.checkmark{background-color:#000}.container input:disabled~.checkmark{background-color:#8b8a8a}.container input:checked:disabled~.checkmark{background-color:#5e5e5e}.checkmark:after{content:\"\";position:absolute;display:none}.container input:checked~.checkmark:after{display:block}.container .checkmark:after{left:.5rem;top:.2rem;width:5px;height:10px;border:solid white;border-width:0 3px 3px 0;transform:rotate(45deg)}\n"], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: VgHoverClassDirective, selector: "[vgHoverClass]", inputs: ["hoverClass"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "vgTreeLevel": VgTreeLevelArrayPipePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLightTreeTableComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-light-tree-table',
                    templateUrl: './vg-light-tree-table.component.html',
                    styleUrls: ['./vg-light-tree-table.component.scss'],
                }]
        }], propDecorators: { treeTableConfig: [{
                type: Input
            }], treeItems: [{
                type: Input
            }], treeMap: [{
                type: Input
            }], idKey: [{
                type: Input
            }], parentIdKey: [{
                type: Input
            }], rootId: [{
                type: Input
            }], selectRowEvent: [{
                type: Output
            }] } });

class VgTreeTableModule {
}
VgTreeTableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgTreeTableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableModule, declarations: [VgTreeTableComponent,
        VgTreeTableItemComponent,
        VgTreeTableBlockConfigPipe,
        VgLightTreeTableComponent,
        VgTreeLevelArrayPipePipe,
        VgHoverClassDirective], imports: [CommonModule], exports: [VgTreeTableComponent,
        VgTreeTableItemComponent,
        VgTreeTableBlockConfigPipe,
        VgLightTreeTableComponent,
        VgTreeLevelArrayPipePipe] });
VgTreeTableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgTreeTableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        VgTreeTableComponent,
                        VgTreeTableItemComponent,
                        VgTreeTableBlockConfigPipe,
                        VgLightTreeTableComponent,
                        VgTreeLevelArrayPipePipe,
                        VgHoverClassDirective,
                    ],
                    imports: [CommonModule],
                    exports: [
                        VgTreeTableComponent,
                        VgTreeTableItemComponent,
                        VgTreeTableBlockConfigPipe,
                        VgLightTreeTableComponent,
                        VgTreeLevelArrayPipePipe,
                    ],
                }]
        }] });

const TOAST_DATA = new InjectionToken('TOAST_DATA');
const TOAST_CONF = new InjectionToken('TOAST_CONF');
const TOAST_OVERLAY_REF = new InjectionToken('TOAST_OVERLAY_REF');
const RUNTIME_TOAST_CONF = new InjectionToken('RUNTIME_TOAST_CONF');
const TOAST_TYPE = {
    SUCCESS: {
        bgColor: '#51a351',
        textColor: 'black',
        iconClass: 'bi bi-check-circle-fill',
    },
    ERROR: {
        bgColor: '#bd362f',
        textColor: 'white',
        iconClass: 'bi bi-x-circle-fill',
    },
    WARNING: {
        bgColor: '#ffc107',
        textColor: 'black',
        iconClass: 'bi bi-exclamation-circle-fill',
    },
    INFO: {
        bgColor: '#2f96b4',
        textColor: 'white',
        iconClass: 'bi bi-question-circle-fill',
    },
    NORMAL: { bgColor: '#F8F8FF', textColor: 'black', iconClass: '' },
    CUSTOM: null,
};
const TOAST_POSITION = {
    TOP_LEFT: { top: '2rem', left: '2rem' },
    TOP_CENTER: { top: '2rem', horizontalAlignment: true },
    TOP_RIGHT: { top: '2rem', right: '2rem' },
    BOTTOM_LEFT: { bottom: '2rem', left: '2rem' },
    BOTTOM_CENTER: { bottom: '2rem', horizontalAlignment: true },
    BOTTOM_RIGHT: { bottom: '2rem', right: '2rem' },
    CENTER: { horizontalAlignment: true, verticalAlignment: true },
};
const TOAST_SIZE = {
    SMALL_DIALOG: { width: '25rem', height: '10rem' },
    MEDIUM_DIALOG: { width: '50vw', height: '20rem' },
    LARGE_DIALOG: { width: '75vw', height: '30rem' },
};
const TOAST_ANIMATION = {
    fadeToast: trigger('fadeAnimation', [
        state('in', style({ opacity: 1 })),
        transition('void => *', [style({ opacity: 0 }), animate('{{ fadeIn }}ms')]),
        transition('default => closing', animate('{{ fadeOut }}ms', style({ opacity: 0 }))),
    ]),
};

class VgToastOverlayRef {
    constructor(overlayRef, toastService, msg) {
        this.overlayRef = overlayRef;
        this.toastService = toastService;
        this.msg = msg;
    }
    close() {
        this.toastService.msgPool.delete(this.msg);
        this.overlayRef.dispose();
    }
    pushToastBeforeToLowerPosition() {
        if (this.toastOverlayRefBefore) {
            if (!this.toastOverlayRefBefore.isVisible()) {
                this.toastOverlayRefBefore = null;
                return;
            }
            const toastBeforePositionStrategy = this.toastOverlayRefBefore.overlayRef.getConfig()
                .positionStrategy;
            const currentPosition = this.toastOverlayRefBefore.getPosition();
            toastBeforePositionStrategy.top(currentPosition.top + currentPosition.height + 20 + 'px');
            this.toastOverlayRefBefore.overlayRef.updatePositionStrategy(toastBeforePositionStrategy);
            this.toastOverlayRefBefore.overlayRef.updatePosition();
            this.toastOverlayRefBefore.pushToastBeforeToLowerPosition();
        }
    }
    isVisible() {
        var _a;
        return this.overlayRef && ((_a = this.overlayRef) === null || _a === void 0 ? void 0 : _a.overlayElement);
    }
    getPosition() {
        var _a, _b;
        return (_b = (_a = this.overlayRef) === null || _a === void 0 ? void 0 : _a.overlayElement) === null || _b === void 0 ? void 0 : _b.getBoundingClientRect();
    }
}

class VgToastComponent {
    constructor(data, toastOverlayRef, conf, runtimeConf) {
        this.data = data;
        this.toastOverlayRef = toastOverlayRef;
        this.conf = conf;
        this.runtimeConf = runtimeConf;
        this.animationState = 'default';
        this.progress = 0;
        this.conf = Object.assign(Object.assign({}, this.conf), this.runtimeConf);
    }
    ngOnInit() {
        var _a;
        if ((_a = this.conf) === null || _a === void 0 ? void 0 : _a.duration) {
            this.progress = 0;
            this.intervalId = setInterval(() => {
                if (this.conf.duration && this.progress >= this.conf.duration) {
                    clearInterval(this.intervalId);
                    this.progress = 0;
                    this.animationState = 'closing';
                }
                else {
                    this.progress += 10;
                }
            }, 10);
        }
    }
    close() {
        if (!this.conf.duration) {
            this.toastOverlayRef.close();
        }
    }
    onFadeFinished(event) {
        const { toState } = event;
        const isFadeOut = toState === 'closing';
        const itFinished = this.animationState === 'closing';
        if (isFadeOut && itFinished) {
            this.toastOverlayRef.close();
        }
    }
    ngOnDestroy() {
        clearTimeout(this.intervalId);
    }
}
VgToastComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastComponent, deps: [{ token: TOAST_DATA, optional: true }, { token: TOAST_OVERLAY_REF, optional: true }, { token: TOAST_CONF, optional: true }, { token: RUNTIME_TOAST_CONF, optional: true }], target: i0.ɵɵFactoryTarget.Component });
VgToastComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgToastComponent, selector: "vg-toast", ngImport: i0, template: "<div\n  class=\"vg-toast-container m-0 p-0 rounded-lg\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: conf.animation?.fadeIn ?? 0,\n      fadeOut: conf.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': conf.type?.bgColor ?? 'white',\n    color: conf.type?.textColor ?? 'black',\n    width: conf.size?.width,\n    height: conf.size?.height\n  }\"\n  [ngClass]=\"conf.class ?? ''\"\n>\n  <div class=\"vg-toast-header\">\n    <h5>{{ data.title }}</h5>\n  </div>\n  <div\n    class=\"vg-toast-progress-bar-container\"\n    [ngStyle]=\"{ 'background-color': conf.type?.bgColor ?? 'white' }\"\n  >\n    <div\n      class=\"vg-toast-progress-bar\"\n      [ngStyle]=\"{\n        width: conf.duration ? (progress * 100) / conf.duration + '%' : 0\n      }\"\n    ></div>\n  </div>\n  <div class=\"vg-toast-body\" (click)=\"close()\">\n    <div\n      *ngIf=\"conf.type?.iconClass\"\n      [ngStyle]=\"{ width: '10%' }\"\n      class=\"d-inline-block d-flex justify-content-center\"\n    >\n      <i [className]=\"conf.type?.iconClass ?? ''\"></i>\n    </div>\n    <ng-container *ngIf=\"data.text; else templateReference\">\n      <p\n        [ngStyle]=\"{ width: conf.type?.iconClass ? '90%' : '100%' }\"\n        class=\"d-inline-block text-wrap text-truncate\"\n      >\n        {{ data.text }}\n      </p>\n    </ng-container>\n  </div>\n</div>\n\n<ng-template #templateReference>\n  <ng-container\n    [ngTemplateOutlet]=\"data.template || null\"\n    [ngTemplateOutletContext]=\"data.templateContext || null\"\n  >\n  </ng-container>\n</ng-template>\n<!--<div style=\"width: 20rem; height: 10rem; background-color: red; z-index: 1000000\">-->\n\n<!--</div>-->\n", styles: [".vg-toast-container{box-shadow:-5px 5px 10px 5px #0006}.vg-toast-header{width:100%;height:24%;position:relative;display:flex;align-items:center;justify-content:space-around;padding:.5rem;border-top-left-radius:.3rem!important;border-top-right-radius:.3rem!important;color:inherit;background-color:inherit;filter:brightness(85%)}.vg-toast-body{width:100%;height:74%;position:relative;display:flex;padding:.5rem;border-bottom-left-radius:.3rem!important;border-bottom-right-radius:.3rem!important;color:inherit;background-color:inherit}.vg-toast-progress-bar-container{padding:0;height:2%;background-color:inherit;filter:brightness(80%)}.vg-toast-progress-bar{width:20rem;height:100%;background-color:inherit;filter:brightness(50%)}\n"], directives: [{ type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [TOAST_ANIMATION.fadeToast] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-toast',
                    templateUrl: './vg-toast.component.html',
                    styleUrls: ['./vg-toast.component.scss'],
                    animations: [TOAST_ANIMATION.fadeToast],
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [TOAST_DATA]
                }] }, { type: VgToastOverlayRef, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [TOAST_OVERLAY_REF]
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [TOAST_CONF]
                }] }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [RUNTIME_TOAST_CONF]
                }] }]; } });

class VgSoundUtil {
    static initSound(soundCollection, label, path = 'assets/media/sound') {
        soundCollection.forEach((sound) => {
            const audioElement = document.createElement('audio');
            audioElement.id = `${label}_${sound}`; //Give it some ID
            const divsParent = document.getElementsByTagName('body')[0]; //get the element where you want to insert the div into
            divsParent.click();
            divsParent.appendChild(audioElement);
            audioElement.setAttribute('muted', 'muted');
            if (navigator.userAgent.match('Firefox/')) {
                audioElement.setAttribute('src', path + '/' + sound + '.ogg');
            }
            else {
                audioElement.setAttribute('src', path + '/' + sound + '.mp3');
            }
        });
    }
    static playSound(sound = 'default', path = 'assets/media/sound') {
        let audioElement = document.getElementById(sound);
        if (!audioElement) {
            audioElement = document.createElement('audio');
            audioElement.setAttribute('muted', 'muted');
            if (navigator.userAgent.match('Firefox/')) {
                audioElement.setAttribute('src', path + '/' + sound + '.ogg');
            }
            else {
                audioElement.setAttribute('src', path + '/' + sound + '.mp3');
            }
        }
        // audioElement.addEventListener('load', () => {
        //   audioElement.play().then(() => {
        //     console.debug(`Play ${sound}`);
        //   });
        // }, true);
        // audioElement.pause();
        audioElement.muted = false;
        audioElement
            .play()
            .then(() => {
            console.debug(`Play ${sound} success`);
        })
            .catch((err) => {
            console.error(`Play ${sound} failed`, err);
        });
    }
}

class VgToastService {
    constructor(overlay, parentInjector, toastConfig) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
        this.toastConfig = toastConfig;
        this.msgPool = new Set();
        this.initialToastSounds = [
            'default',
            'chord',
            'battery-critical',
            'error',
            'balloon',
        ];
        VgSoundUtil.initSound(this.initialToastSounds, 'toastSound');
    }
    show(data, runtimeConfig = { duration: 3000 }) {
        if (!(data === null || data === void 0 ? void 0 : data.text) || this.msgPool.has(data.text)) {
            return null;
        }
        else {
            this.msgPool.add(data.text);
        }
        const config = Object.assign(Object.assign({}, this.toastConfig), runtimeConfig);
        VgSoundUtil.playSound(config.sound);
        const positionStrategy = this.getPositionStrategy(config);
        const overlayRef = this.overlay.create({
            positionStrategy,
            // height: config.size.height,
            // width: config.size.width
        });
        const tmpToastOverlayRef = this.lastToast;
        const toastRef = new VgToastOverlayRef(overlayRef, this, data.text);
        this.lastToast = toastRef;
        this.lastToast.toastOverlayRefBefore = tmpToastOverlayRef;
        const injector = this.getInjector(data, toastRef, this.parentInjector, runtimeConfig);
        const toastPortal = new ComponentPortal(VgToastComponent, null, injector);
        const comp = overlayRef.attach(toastPortal);
        console.debug('Toast component: ', comp);
        this.lastToast.pushToastBeforeToLowerPosition();
        return this.lastToast;
    }
    getInjector(data, toastRef, parentInjector, runtimeConfig) {
        return Injector.create({
            providers: [
                { provide: TOAST_DATA, useValue: data },
                { provide: TOAST_OVERLAY_REF, useValue: toastRef },
                { provide: RUNTIME_TOAST_CONF, useValue: runtimeConfig },
            ],
            parent: parentInjector,
        });
    }
    getPositionStrategy(config = { duration: 3000 }) {
        const positionStrategy = this.overlay.position().global();
        if (config.position.top) {
            positionStrategy.top(config.position.top);
        }
        if (config.position.right) {
            positionStrategy.right(config.position.right);
        }
        if (config.position.bottom) {
            positionStrategy.bottom(config.position.bottom);
        }
        if (config.position.left) {
            positionStrategy.left(config.position.left);
        }
        if (config.position.horizontalAlignment) {
            positionStrategy.centerHorizontally();
        }
        if (config.position.verticalAlignment) {
            positionStrategy.centerVertically();
        }
        return positionStrategy;
    }
    success(data, runtimeConfig = { duration: 3000 }) {
        this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.SUCCESS, sound: 'chord' }));
    }
    error(data, runtimeConfig = { duration: 3000 }) {
        this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.ERROR, sound: 'battery-critical' }));
    }
    warning(data, runtimeConfig = { duration: 3000 }) {
        this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.WARNING, sound: 'error' }));
    }
    info(data, runtimeConfig = { duration: 3000 }) {
        this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.INFO, sound: 'balloon' }));
    }
}
VgToastService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastService, deps: [{ token: i1$4.Overlay }, { token: i0.Injector }, { token: TOAST_CONF }], target: i0.ɵɵFactoryTarget.Injectable });
VgToastService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1$4.Overlay }, { type: i0.Injector }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [TOAST_CONF]
                }] }]; } });

class VgToastModule {
    static forRoot(config) {
        const defaultToastConfig = {
            position: TOAST_POSITION.TOP_CENTER,
            size: TOAST_SIZE.SMALL_DIALOG,
            animation: {
                fadeOut: 2500,
                fadeIn: 300,
            },
            duration: 2000,
            type: TOAST_TYPE.NORMAL,
        };
        return {
            ngModule: VgToastModule,
            providers: [
                {
                    provide: TOAST_CONF,
                    useValue: Object.assign(Object.assign({}, defaultToastConfig), config),
                },
            ],
        };
    }
}
VgToastModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgToastModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastModule, declarations: [VgToastComponent], imports: [CommonModule, BrowserAnimationsModule, OverlayModule], exports: [VgToastComponent] });
VgToastModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastModule, providers: [VgToastService], imports: [[CommonModule, BrowserAnimationsModule, OverlayModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgToastModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [VgToastComponent],
                    imports: [CommonModule, BrowserAnimationsModule, OverlayModule],
                    exports: [VgToastComponent],
                    providers: [VgToastService],
                }]
        }] });

const DIALOG_DATA = new InjectionToken('DIALOG_DATA');
const DIALOG_OPTIONS = new InjectionToken('DIALOG_OPTIONS');
const DIALOG_TYPE = {
    SUCCESS: { bgColor: '#98FB98', textColor: 'black' },
    ERROR: { bgColor: '#FF6347', textColor: 'white' },
    WARNING: { bgColor: '#F0E68C', textColor: 'black' },
    INFO: { bgColor: '#87CEEB', textColor: 'white' },
    NORMAL: { bgColor: '#F8F8FF', textColor: 'black' },
    CUSTOM: null,
};
const DIALOG_POSITION = {
    TOP_LEFT: { top: '32', left: '32' },
    TOP_CENTER: { top: '32', horizontalAlignment: true },
    TOP_RIGHT: { top: '32', right: '32' },
    BOTTOM_LEFT: { bottom: '2rem', left: '2rem' },
    BOTTOM_CENTER: { bottom: '2rem', horizontalAlignment: true },
    BOTTOM_RIGHT: { bottom: '2rem', right: '2rem' },
    CENTER: { horizontalAlignment: true, verticalAlignment: true },
};
const DIALOG_SIZE = {
    SMALL_DIALOG: { width: '30vw', height: 'auto' },
    MEDIUM_DIALOG: { width: '60vw', height: 'auto' },
    LARGE_DIALOG: { width: '90vw', height: 'auto' },
};
const DIALOG_ANIMATION = {
    fadeDialog: trigger('fadeAnimation', [
        state('in', style({ opacity: 1 })),
        transition('void => *', [style({ opacity: 0 }), animate('{{ fadeIn }}ms')]),
        transition('default => closing', animate('{{ fadeOut }}ms', style({ opacity: 0 }))),
    ]),
};

// eslint-disable-next-line
const DIALOG_REF = new InjectionToken('DIALOG_REF');
class VgDialogOverlayRef {
    constructor(overlay) {
        this.overlay = overlay;
    }
    close() {
        this.overlay.dispose();
    }
    onClose() {
        return this.overlay.detachments();
    }
    isVisible() {
        return this.overlay && this.overlay.overlayElement;
    }
    getPosition() {
        return this.overlay.overlayElement.getBoundingClientRect();
    }
}

class VgConfirmDialogComponent {
    constructor(dialogOverlayRef, dialogData, dialogOptions) {
        this.dialogOverlayRef = dialogOverlayRef;
        this.dialogData = dialogData;
        this.dialogOptions = dialogOptions;
        this.onClose = new Subject();
        this.iconClass = '';
        this.cursor = 1;
        this.animationState = 'default';
    }
    onKeydownHandler(event) {
        event.preventDefault();
        if (event.shiftKey && event.key === 'Tab') {
            if (this.cursor === 0) {
                this.cursor = this.buttonCollection.length - 1;
            }
            else {
                this.cursor--;
            }
            this.buttonCollection[this.cursor].nativeElement.focus();
        }
        else {
            switch (event.key) {
                case 'Escape':
                    this.cancel();
                    break;
                case 'Tab':
                    if (this.cursor === this.buttonCollection.length - 1) {
                        this.cursor = 0;
                    }
                    else {
                        this.cursor++;
                    }
                    this.buttonCollection[this.cursor].nativeElement.focus();
                    break;
                case 'Enter':
                    if (this.cursor === 0) {
                        this.cancel();
                    }
                    else {
                        this.buttonCollection[this.cursor].nativeElement.click();
                    }
                    break;
            }
        }
    }
    confirm() {
        this.onClose.next(true);
        this.onClose.complete();
        this.dialogOverlayRef.close();
    }
    cancel() {
        this.onClose.next(false);
        this.onClose.complete();
        this.dialogOverlayRef.close();
    }
    ngOnInit() {
        const focusToConfirmButton = setTimeout(() => {
            this.cursor = 1;
            this.buttonCollection = this.buttonsQueryList.toArray();
            this.buttonCollection[this.cursor].nativeElement.focus();
            clearTimeout(focusToConfirmButton);
        }, 0);
    }
    // eslint-disable-next-line
    onFadeFinished(event) {
        const { toState } = event;
        const isFadeOut = toState === 'closing';
        const itFinished = this.animationState === 'closing';
        if (isFadeOut && itFinished) {
            this.dialogOverlayRef.close();
        }
    }
}
VgConfirmDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgConfirmDialogComponent, deps: [{ token: DIALOG_REF }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0.ɵɵFactoryTarget.Component });
VgConfirmDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgConfirmDialogComponent, selector: "vg-confirm-dialog", host: { listeners: { "document:keydown": "onKeydownHandler($event)" } }, viewQueries: [{ propertyName: "buttonsQueryList", predicate: ["confirmDialogButton"], descendants: true }], ngImport: i0, template: "<div\n  class=\"vg-dialog-container p-0 m-0 rounded-sm\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: dialogOptions.animation?.fadeIn ?? 0,\n      fadeOut: dialogOptions.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': 'default',\n    color: 'default',\n    width: dialogOptions?.size?.width,\n    height: dialogOptions?.size?.height\n  }\"\n  [ngClass]=\"dialogOptions.panelClass ?? ''\"\n>\n  <div class=\"modal-header\">\n    <h5 style=\"font-size: 1.3em; font-weight: bold\">{{ dialogData.title }}</h5>\n    <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"cancel()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <p class=\"text-center icon-default\">\n      <i *ngIf=\"iconClass\" class=\"{{ iconClass }}\"></i>\n    </p>\n    <p class=\"text-center\">{{ dialogData.message }}</p>\n  </div>\n  <div class=\"modal-footer d-flex justify-content-center\">\n    <button\n      type=\"button\"\n      #confirmDialogButton\n      class=\"btn btn-primary m-2 rounded-pill\"\n      style=\"min-width: 5rem\"\n      (click)=\"confirm()\"\n    >\n      {{ dialogData.buttons?.confirm?.label }}\n    </button>\n    <button\n      type=\"button\"\n      #confirmDialogButton\n      class=\"btn btn-secondary m-2 rounded-pill\"\n      style=\"min-width: 5rem\"\n      (click)=\"cancel()\"\n    >\n      {{ dialogData.buttons?.cancel?.label }}\n    </button>\n  </div>\n</div>\n", styles: [".icon-default{font-size:50px}.modal-header h5{margin-bottom:0!important}.modal-content{border:.1rem solid white}.modal-footer>*{margin-top:0!important;margin-bottom:0!important}.vg-dialog-container{background-color:#fff;box-shadow:-5px 5px 10px 5px #0006}\n"], directives: [{ type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [DIALOG_ANIMATION.fadeDialog] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgConfirmDialogComponent, decorators: [{
            type: Component,
            args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'vg-confirm-dialog',
                    templateUrl: 'vg-confirm-dialog.component.html',
                    styleUrls: ['vg-confirm-dialog.component.scss'],
                    animations: [DIALOG_ANIMATION.fadeDialog],
                }]
        }], ctorParameters: function () { return [{ type: VgDialogOverlayRef, decorators: [{
                    type: Inject,
                    args: [DIALOG_REF]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_DATA]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_OPTIONS]
                }] }]; }, propDecorators: { buttonsQueryList: [{
                type: ViewChildren,
                args: ['confirmDialogButton']
            }], onKeydownHandler: [{
                type: HostListener,
                args: ['document:keydown', ['$event']]
            }] } });

class VgMessageDialogComponent {
    constructor(dialogOverlayRef, dialogData, dialogOptions) {
        this.dialogOverlayRef = dialogOverlayRef;
        this.dialogData = dialogData;
        this.dialogOptions = dialogOptions;
        this.onClose = new Subject();
        this.icon = '';
        this.cursor = 1;
        this.animationState = 'default';
    }
    onKeydownHandler(event) {
        event.preventDefault();
        if (event.shiftKey && event.key === 'Tab') {
            if (this.cursor === 0) {
                this.cursor = this.buttonCollection.length - 1;
            }
            else {
                this.cursor--;
            }
            this.buttonCollection[this.cursor].nativeElement.focus();
        }
        else {
            switch (event.key) {
                case 'Escape':
                    this.ok();
                    break;
                case 'Tab':
                    if (this.cursor === this.buttonCollection.length - 1) {
                        this.cursor = 0;
                    }
                    else {
                        this.cursor++;
                    }
                    this.buttonCollection[this.cursor].nativeElement.focus();
                    break;
                case 'Enter':
                    this.ok();
                    break;
            }
        }
    }
    ngOnInit() {
        var _a;
        this.icon = ((_a = this.dialogData) === null || _a === void 0 ? void 0 : _a.iconClass)
            ? '<i class="' + this.dialogData.iconClass + '"></i>'
            : '';
        const focusToOkButton = setTimeout(() => {
            this.cursor = 0;
            this.buttonCollection = this.buttonsQueryList.toArray();
            this.buttonCollection[this.cursor].nativeElement.focus();
            clearTimeout(focusToOkButton);
        }, 0);
    }
    ok() {
        this.onClose.next(false);
        this.onClose.complete();
        this.dialogOverlayRef.close();
    }
    // eslint-disable-next-line
    onFadeFinished(event) {
        const { toState } = event;
        const isFadeOut = toState === 'closing';
        const itFinished = this.animationState === 'closing';
        if (isFadeOut && itFinished) {
            this.dialogOverlayRef.close();
        }
    }
}
VgMessageDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgMessageDialogComponent, deps: [{ token: DIALOG_REF }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0.ɵɵFactoryTarget.Component });
VgMessageDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgMessageDialogComponent, selector: "vg-message-dialog", host: { listeners: { "document:keydown": "onKeydownHandler($event)" } }, viewQueries: [{ propertyName: "buttonsQueryList", predicate: ["messageButton"], descendants: true }], ngImport: i0, template: "<div\n  class=\"vg-dialog-container p-0 m-0 rounded-sm\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: dialogOptions.animation?.fadeIn ?? 0,\n      fadeOut: dialogOptions.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': 'default',\n    color: 'default',\n    width: dialogOptions?.size?.width,\n    height: dialogOptions?.size?.height\n  }\"\n  [ngClass]=\"dialogOptions.panelClass ?? ''\"\n>\n  <div class=\"modal-header\">\n    <h5 style=\"font-size: 1.3em; font-weight: bold\">{{ dialogData.title }}</h5>\n    <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"ok()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <p class=\"text-center icon-default\" [innerHTML]=\"icon\"></p>\n    <p class=\"text-center\">\n      <img\n        *ngIf=\"imageUrl\"\n        src=\"{{ imageUrl }}\"\n        class=\"iconMessage\"\n        alt=\"message-image\"\n      />\n      <span class=\"d-block\" [innerHTML]=\"dialogData.message\"></span>\n    </p>\n  </div>\n  <div class=\"modal-footer d-flex justify-content-center\">\n    <button\n      #messageButton\n      (click)=\"ok()\"\n      class=\"btn btn-primary m-2 rounded-pill\"\n      style=\"min-width: 5rem !important\"\n    >\n      {{ dialogData.buttons?.confirm?.label }}\n    </button>\n  </div>\n</div>\n", styles: [".icon-default{font-size:2rem;margin-bottom:0}.modal-header h5{margin-bottom:0!important}.modal-content{border:.1rem solid white}.modal-footer>*{margin-top:0!important;margin-bottom:0!important}.vg-dialog-container{background-color:#fff;box-shadow:-5px 5px 10px 5px #0006}\n"], directives: [{ type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [DIALOG_ANIMATION.fadeDialog] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgMessageDialogComponent, decorators: [{
            type: Component,
            args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'vg-message-dialog',
                    templateUrl: 'vg-message-dialog.component.html',
                    styleUrls: ['vg-message-dialog.component.scss'],
                    animations: [DIALOG_ANIMATION.fadeDialog],
                }]
        }], ctorParameters: function () { return [{ type: VgDialogOverlayRef, decorators: [{
                    type: Inject,
                    args: [DIALOG_REF]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_DATA]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_OPTIONS]
                }] }]; }, propDecorators: { buttonsQueryList: [{
                type: ViewChildren,
                args: ['messageButton']
            }], onKeydownHandler: [{
                type: HostListener,
                args: ['document:keydown', ['$event']]
            }] } });

class VgDialogWrapperComponent {
    constructor(dialogOverlayRef, dialogData, dialogOptions) {
        this.dialogOverlayRef = dialogOverlayRef;
        this.dialogData = dialogData;
        this.dialogOptions = dialogOptions;
        this.title = '';
        this.disableClose = false;
        this.closeAction = new EventEmitter();
        this.animationState = 'default';
    }
    close() {
        this.closeAction.emit();
    }
    // eslint-disable-next-line
    onFadeFinished(event) {
        const { toState } = event;
        const isFadeOut = toState === 'closing';
        const itFinished = this.animationState === 'closing';
        if (isFadeOut && itFinished) {
            this.dialogOverlayRef.close();
        }
    }
}
VgDialogWrapperComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogWrapperComponent, deps: [{ token: DIALOG_REF }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0.ɵɵFactoryTarget.Component });
VgDialogWrapperComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgDialogWrapperComponent, selector: "vg-modal-wrapper", inputs: { title: "title", disableClose: "disableClose" }, outputs: { closeAction: "closeAction" }, viewQueries: [{ propertyName: "content", first: true, predicate: ["content"], descendants: true }], ngImport: i0, template: "<div\n  class=\"vg-dialog-container m-0 p-0 rounded-sm\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: dialogOptions.animation?.fadeIn ?? 0,\n      fadeOut: dialogOptions.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': 'default',\n    color: 'default',\n    width: dialogOptions?.size?.width,\n    height: dialogOptions?.size?.height\n  }\"\n  [ngClass]=\"dialogOptions.panelClass ?? ''\"\n>\n  <div class=\"modal-header\">\n    <h5 class=\"modal-title\" id=\"modal-basic-title\">{{ title }}</h5>\n    <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"close()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <ng-content select=\"[modalBody]\"></ng-content>\n  </div>\n  <div class=\"modal-footer d-flex justify-content-end\">\n    <ng-content select=\"[modalFooter]\"></ng-content>\n  </div>\n</div>\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='delete'\" class=\"btn btn-danger btn-sm m-2 rounded-circle\"><i class=\"fas fa-trash-alt\"></i></button>-->\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='create'\" class=\"btn btn-primary m-2 rounded-pill\">{{ title }}</button>-->\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='edit'\" class=\"btn btn-secondary m-2 btn-sm rounded-circle\"><i class=\"fas fa-edit\"></i></button>-->\n<!--<button ngbDropdownItem (click)=\"open(content, $event)\" *ngIf=\"action=='addToPlaylist'\" class=\"btn btn-primary btn-sm\"><i class=\"fas fa-plus mr-1\"></i>{{ 'Add to Playlist' | translate }}</button>-->\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='addToPlaylist_roundedBtn'\" class=\"btn btn-secondary btn-sm rounded-circle\"><i class=\"fas fa-plus\"></i></button>-->\n", styles: [".modal-header h5{margin-bottom:0!important}.modal-content{border:.1rem solid white}.modal-footer>*{margin-top:0!important;margin-bottom:0!important}.vg-dialog-container{background-color:#fff;box-shadow:-5px 5px 10px 5px #0006}\n"], directives: [{ type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], animations: [DIALOG_ANIMATION.fadeDialog], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogWrapperComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-modal-wrapper',
                    templateUrl: './vg-dialog-wrapper.component.html',
                    styleUrls: ['./vg-dialog-wrapper.component.scss'],
                    encapsulation: ViewEncapsulation.None,
                    animations: [DIALOG_ANIMATION.fadeDialog],
                }]
        }], ctorParameters: function () { return [{ type: VgDialogOverlayRef, decorators: [{
                    type: Inject,
                    args: [DIALOG_REF]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_DATA]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_OPTIONS]
                }] }]; }, propDecorators: { title: [{
                type: Input
            }], disableClose: [{
                type: Input
            }], closeAction: [{
                type: Output
            }], content: [{
                type: ViewChild,
                args: ['content']
            }] } });

class VgDialogService {
    constructor(parentInjector, overlay, dialogData, dialogOptions) {
        this.parentInjector = parentInjector;
        this.overlay = overlay;
        this.dialogData = dialogData;
        this.dialogOptions = dialogOptions;
        this.initialDialogSounds = [
            'info-bar',
            'exclamation',
            'critical-stop',
            'chimes',
            'notify',
        ];
        VgSoundUtil.initSound(this.initialDialogSounds, 'dialogSound');
    }
    showDialog(
    // eslint-disable-next-line
    content, dialogData, dialogOptions) {
        var _a, _b;
        const options = Object.assign(Object.assign({}, this.dialogOptions), dialogOptions);
        const positionStrategy = this.getPositionStrategy(options);
        const overlayRef = this.overlay.create({
            positionStrategy,
            panelClass: options.panelClass,
            backdropClass: options.backdropClass,
            hasBackdrop: options.hasBackdrop,
            width: (_a = options === null || options === void 0 ? void 0 : options.size) === null || _a === void 0 ? void 0 : _a.width,
            height: (_b = options === null || options === void 0 ? void 0 : options.size) === null || _b === void 0 ? void 0 : _b.height,
            disposeOnNavigation: options.disposeOnNavigation,
        });
        const dialogRef = new VgDialogOverlayRef(overlayRef);
        this.lastDialogRef = dialogRef;
        const data = Object.assign(Object.assign({}, this.dialogData), dialogData);
        const injector = this.getInjector(dialogRef, this.parentInjector, data);
        const dialogPortal = new ComponentPortal(content, null, injector);
        dialogRef.componentRef = overlayRef.attach(dialogPortal).instance;
        return dialogRef;
    }
    getInjector(dialogRef, parentInjector, dialogData, runtimeDialogOptions) {
        const dialogOptions = Object.assign(Object.assign({}, this.dialogOptions), runtimeDialogOptions);
        return Injector.create({
            providers: [
                { provide: DIALOG_REF, useValue: dialogRef },
                { provide: DIALOG_DATA, useValue: dialogData },
                { provide: DIALOG_OPTIONS, useValue: dialogOptions },
            ],
            parent: parentInjector,
        });
    }
    getPositionStrategy(dialogOptions) {
        return this.overlay
            .position()
            .global()
            .top(dialogOptions === null || dialogOptions === void 0 ? void 0 : dialogOptions.top)
            .centerHorizontally();
    }
    confirm(mainTitle = 'Dialog title', message = 'Dialog message', labelYes = 'Yes', labelNo = 'No', className) {
        const initialState = {
            title: mainTitle,
            message,
            buttons: {
                confirm: {
                    label: labelYes,
                    className: '',
                },
                cancel: {
                    label: labelNo,
                    className: '',
                },
            },
            iconClass: 'text-warning fa fa-question-circle',
        };
        VgSoundUtil.playSound('notify');
        this.lastDialogRef = this.showDialog(VgConfirmDialogComponent, initialState, {
            backdropClass: className,
            hasBackdrop: true,
            size: DIALOG_SIZE.SMALL_DIALOG,
            // keyboard: false,
        });
        return this.lastDialogRef.componentRef
            .onClose;
    }
    show(title = 'Dialog title', message = 'Dialog message', iconClass, className, imageUrl, sound = 'balloon') {
        const initialState = {
            title,
            message,
            buttons: {
                confirm: {
                    label: 'OK',
                    className: '',
                },
            },
            iconClass,
            imageUrl,
        };
        VgSoundUtil.playSound(sound);
        this.lastDialogRef = this.showDialog(VgMessageDialogComponent, initialState, {
            // keyboard: false,
            panelClass: className,
            hasBackdrop: true,
            size: DIALOG_SIZE.SMALL_DIALOG,
        });
        return this.lastDialogRef.componentRef
            .onClose;
    }
    info(title, message, className) {
        return this.show(title, message, 'text-info bi bi-question-circle-fill', className, undefined, 'info-bar');
    }
    warning(title, message, className) {
        return this.show(title, message, 'text-warning bi bi-exclamation-triangle-fill', className, undefined, 'exclamation');
    }
    error(title, message, className) {
        return this.show(title, message, 'text-danger bi bi-exclamation-circle-fill', className, undefined, 'critical-stop');
    }
    success(title, message, className) {
        return this.show(title, message, 'text-success bi bi-check-circle-fill', className, undefined, 'chimes');
    }
}
VgDialogService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogService, deps: [{ token: i0.Injector }, { token: i1$4.Overlay }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0.ɵɵFactoryTarget.Injectable });
VgDialogService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.Injector }, { type: i1$4.Overlay }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_DATA]
                }] }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [DIALOG_OPTIONS]
                }] }]; } });

class VgDialogModule {
    static forRoot(dialogData, dialogOptions) {
        const defaultDialogOptions = {
            hasBackdrop: true,
            size: DIALOG_SIZE.SMALL_DIALOG,
            top: '5rem',
            disposeOnNavigation: true,
            type: DIALOG_TYPE.NORMAL,
            animation: {
                fadeOut: 2500,
                fadeIn: 300,
            },
        };
        const defaultDialogData = {
            title: 'Default dialog',
            message: 'Hello World!',
            buttons: {
                confirm: {
                    label: 'Close',
                    className: 'btn btn-primary',
                },
            },
        };
        return {
            ngModule: VgDialogModule,
            providers: [
                {
                    provide: DIALOG_DATA,
                    useValue: Object.assign(Object.assign({}, defaultDialogData), dialogData),
                },
                {
                    provide: DIALOG_OPTIONS,
                    useValue: Object.assign(Object.assign({}, defaultDialogOptions), dialogOptions),
                },
            ],
        };
    }
}
VgDialogModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgDialogModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogModule, declarations: [VgDialogWrapperComponent,
        VgConfirmDialogComponent,
        VgMessageDialogComponent], imports: [CommonModule, OverlayModule], exports: [VgDialogWrapperComponent,
        VgConfirmDialogComponent,
        VgMessageDialogComponent] });
VgDialogModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogModule, providers: [VgDialogService], imports: [[CommonModule, OverlayModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDialogModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        VgDialogWrapperComponent,
                        VgConfirmDialogComponent,
                        VgMessageDialogComponent,
                    ],
                    imports: [CommonModule, OverlayModule],
                    providers: [VgDialogService],
                    exports: [
                        VgDialogWrapperComponent,
                        VgConfirmDialogComponent,
                        VgMessageDialogComponent,
                    ],
                }]
        }] });

class VgNumberOnlyDirective {
    constructor(renderer) {
        this.renderer = renderer;
        this.excludedCharsRegex = /[^+,?\d]/g;
        this.excludedNonLeadPlusMinusRegex = /(?<=[\d+]+)\+/g;
        this.onChange = (val) => {
            console.debug(val);
        };
        this.onTouched = () => {
            console.debug();
        };
    }
    writeValue(obj) {
        const numberVal = isNaN(Number(obj)) ? 0 : Number(obj);
        this.el.value = numberVal.toString();
        // setTimeout(() => {
        //   this.onChange(numberVal);
        // }, 0);
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    onInput(el) {
        var _a, _b;
        if (el.type !== 'text') {
            return;
        }
        let start = el.selectionStart || 0;
        const end = el.selectionEnd || 0;
        const originalNonDigitCount = ((_a = el.value.match(this.excludedCharsRegex)) === null || _a === void 0 ? void 0 : _a.length) || 0;
        const noDigitsString = el.value
            .toString()
            .replace(this.excludedCharsRegex, '');
        const newValue = noDigitsString
            .toString()
            .replace(this.excludedNonLeadPlusMinusRegex, '');
        const modifiedNonDigitCount = ((_b = newValue.substring(0, start).match(this.excludedCharsRegex)) === null || _b === void 0 ? void 0 : _b.length) || 0;
        el.value = newValue;
        start += modifiedNonDigitCount - originalNonDigitCount;
        this.renderer.setProperty(el, 'selectionStart', start);
        this.renderer.setProperty(el, 'selectionEnd', start > end ? start : end);
    }
}
VgNumberOnlyDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgNumberOnlyDirective, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
VgNumberOnlyDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgNumberOnlyDirective, selector: "[vgNumberOnly]", inputs: { excludedCharsRegex: "excludedCharsRegex", excludedNonLeadPlusMinusRegex: "excludedNonLeadPlusMinusRegex" }, host: { listeners: { "input": "onInput($event.target)" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => VgNumberOnlyDirective),
            multi: true,
        },
    ], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgNumberOnlyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgNumberOnly]',
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => VgNumberOnlyDirective),
                            multi: true,
                        },
                    ],
                }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { excludedCharsRegex: [{
                type: Input
            }], excludedNonLeadPlusMinusRegex: [{
                type: Input
            }], onInput: [{
                type: HostListener,
                args: ['input', ['$event.target']]
            }] } });

class VgCurrencyInputDirective {
    constructor(renderer, elementRef) {
        this.renderer = renderer;
        this.elementRef = elementRef;
        this.currentLocale = 'vi-VN';
        this.thousandSeparator = /(\.)/g;
        this.onChange = (val) => {
            console.debug(val);
        };
        this.onTouched = () => {
            console.debug();
        };
        this.el = elementRef.nativeElement;
    }
    writeValue(obj) {
        const numberVal = isNaN(Number(obj)) ? 0 : Number(obj);
        this.el.value = numberVal.toLocaleString(this.currentLocale);
        setTimeout(() => {
            this.onChange(numberVal);
        }, 0);
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    ngOnInit() {
        if (navigator.language) {
            this.currentLocale = navigator.language;
        }
        const testStr = 1000;
        const testFormattedStr = testStr.toLocaleString(this.currentLocale);
        if (testFormattedStr.match(/\./g)) {
            this.thousandSeparator = /\./g;
        }
        else {
            this.thousandSeparator = /,/g;
        }
    }
    // @HostListener('focusout', ['$event.target'])
    onInput(el) {
        this.renderUpdatedValue(el);
    }
    updateNumberValue(val) {
        this.onChange(val);
    }
    renderUpdatedValue(el) {
        if (el.type !== 'text') {
            return;
        }
        clearTimeout(this.delay);
        this.delay = setTimeout((el) => {
            var _a, _b;
            let start = el.selectionStart || 0;
            const end = el.selectionEnd || 0;
            const initialVal = el.value;
            const initialDotCount = ((_a = initialVal.substring(0, start).match(this.thousandSeparator)) === null || _a === void 0 ? void 0 : _a.length) || 0;
            const strWithNoComma = el.value
                .toString()
                .replace(this.thousandSeparator, '');
            const strDigitOnly = strWithNoComma.replace(/\D/g, '');
            const numberVal = Number(strDigitOnly);
            const newValue = numberVal.toLocaleString(this.currentLocale);
            const modifiedDotCount = ((_b = newValue.substring(0, start).match(this.thousandSeparator)) === null || _b === void 0 ? void 0 : _b.length) ||
                0;
            // console.debug(initialDotCount, modifiedDotCount, el.selectionStart, el.selectionEnd);
            el.value = newValue;
            start += modifiedDotCount - initialDotCount;
            this.renderer.setProperty(el, 'selectionStart', start);
            this.renderer.setProperty(el, 'selectionEnd', start > end ? start : end);
            this.updateNumberValue(numberVal);
            clearTimeout(this.delay);
        }, 200, el);
    }
}
VgCurrencyInputDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgCurrencyInputDirective, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
VgCurrencyInputDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgCurrencyInputDirective, selector: "[vgCurrencyInput]", inputs: { currentLocale: "currentLocale" }, host: { listeners: { "input": "onInput($event.target)" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => VgCurrencyInputDirective),
            multi: true,
        },
    ], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgCurrencyInputDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgCurrencyInput]',
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => VgCurrencyInputDirective),
                            multi: true,
                        },
                    ],
                }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }]; }, propDecorators: { currentLocale: [{
                type: Input
            }], 
        // @HostListener('focusout', ['$event.target'])
        onInput: [{
                type: HostListener,
                args: ['input', ['$event.target']]
            }] } });

class VgFocusFirstInvalidDirective {
    constructor(el) {
        this.el = el;
    }
    onFormSubmit() {
        if (this.form) {
            this.form.markAllAsTouched();
        }
        const invalidControls = this.el.nativeElement.querySelectorAll('input.ng-invalid');
        if (invalidControls.length) {
            invalidControls.item(0).focus();
            invalidControls.forEach((node) => {
                node.classList.add('ng-touched');
            });
        }
    }
}
VgFocusFirstInvalidDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFocusFirstInvalidDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
VgFocusFirstInvalidDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgFocusFirstInvalidDirective, selector: "[vgFocusFirstInvalid]", inputs: { form: "form" }, host: { listeners: { "submit": "onFormSubmit()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgFocusFirstInvalidDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgFocusFirstInvalid]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { form: [{
                type: Input
            }], onFormSubmit: [{
                type: HostListener,
                args: ['submit']
            }] } });

class VgDelayClickDirective {
    constructor() {
        this.delayTime = 1000;
        this.delayClick = new EventEmitter();
        this.clickSubject = new Subject();
    }
    ngOnInit() {
        this.subscription = this.clickSubject
            .pipe(debounceTime(this.delayTime))
            .subscribe((e) => this.delayClick.emit(e));
    }
    clickEvent(event) {
        event.preventDefault();
        event.stopPropagation();
        this.clickSubject.next(event);
    }
    ngOnDestroy() {
        this.subscription.unsubscribe();
    }
}
VgDelayClickDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDelayClickDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
VgDelayClickDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgDelayClickDirective, selector: "[vgDelayClick]", inputs: { delayTime: "delayTime" }, outputs: { delayClick: "delayClick" }, host: { listeners: { "click": "clickEvent($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDelayClickDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgDelayClick]',
                }]
        }], propDecorators: { delayTime: [{
                type: Input
            }], delayClick: [{
                type: Output
            }], clickEvent: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

const DROPPABLE_CLASS = 'vg-droppable';
const DRAGGING_CLASS = 'vg-dragging';
const DRAG_ENTER_CLASS = 'vg-drag-enter';
class VgSwappableBase {
    constructor(idAttr = 'id', refMap = {}, el) {
        this.idAttr = idAttr;
        this.refMap = refMap;
        this.el = el;
        this._collectionName = 'default';
        this.el.setAttribute('draggable', 'true');
        this.el.classList.add(DROPPABLE_CLASS);
    }
    onDrag(event) {
        // console.debug('drag', event);
    }
    onDragstart(event) {
        if (event.dataTransfer) {
            event.dataTransfer.setData(this.idAttr, this.el.getAttribute(this.idAttr));
            event.dataTransfer.dropEffect = 'move';
            const dragItem = event.currentTarget;
            dragItem.classList.remove(DROPPABLE_CLASS, DRAG_ENTER_CLASS);
            dragItem.classList.add(DRAGGING_CLASS);
            this.refMap[this._collectionName] = {
                dragItem: dragItem,
                dropItem: null,
            };
        }
    }
    onDragend(event) {
        // console.debug('drag end', event);
        const dropItem = this.refMap[this._collectionName].dropItem;
        dropItem === null || dropItem === void 0 ? void 0 : dropItem.classList.remove(DRAG_ENTER_CLASS);
        const dragItem = this.refMap[this._collectionName].dragItem;
        dragItem === null || dragItem === void 0 ? void 0 : dragItem.classList.remove(DRAGGING_CLASS);
        dragItem === null || dragItem === void 0 ? void 0 : dragItem.classList.add(DROPPABLE_CLASS);
        this.refMap[this._collectionName] = {};
    }
    onDragenter(event) {
        if (this.checkValidDrop(event)) {
            let dropItem = this.refMap[this._collectionName].dropItem;
            dropItem === null || dropItem === void 0 ? void 0 : dropItem.classList.remove(DRAG_ENTER_CLASS);
            dropItem = event.currentTarget;
            dropItem.classList.add(DRAG_ENTER_CLASS);
            this.refMap[this._collectionName].dropItem = dropItem;
            event.preventDefault();
        }
    }
    onDragleave(event) {
        if (this.checkValidDrop(event)) {
            const dropItem = this.refMap[this._collectionName].dropItem;
            if (!(dropItem === null || dropItem === void 0 ? void 0 : dropItem.contains(event.relatedTarget))) {
                dropItem === null || dropItem === void 0 ? void 0 : dropItem.classList.remove(DRAG_ENTER_CLASS);
            }
            event.preventDefault();
        }
    }
    onDragover(event) {
        if (this.checkValidDrop(event)) {
            event.preventDefault();
        }
    }
    onDrop(event) {
        event.preventDefault();
        this.swapEffect(event);
    }
    checkValidDrop(event) {
        var _a;
        const currentTarget = event.currentTarget;
        return (currentTarget.classList.contains(DROPPABLE_CLASS) &&
            ((_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.types.includes(this.idAttr)));
    }
}

const ID_ATTR$1 = 'id';
class VgSwappableElementDirective extends VgSwappableBase {
    constructor(ref) {
        super(ID_ATTR$1, VgSwappableElementDirective.REF_MAP, ref.nativeElement);
        this.ref = ref;
        this.swapEvent = new EventEmitter();
        this.animationTime = 0.4;
    }
    get collectionName() {
        return super._collectionName;
    }
    set collectionName(value) {
        super._collectionName = value;
    }
    ngOnChanges(changes) {
        if (changes.id) {
            this.el.setAttribute(ID_ATTR$1, String(this.id));
        }
    }
    onDrag(event) {
        super.onDrag(event);
    }
    onDragstart(event) {
        super.onDragstart(event);
    }
    onDragend(event) {
        super.onDragend(event);
    }
    onDragenter(event) {
        super.onDragenter(event);
    }
    onDragleave(event) {
        super.onDragleave(event);
    }
    onDragover(event) {
        super.onDragover(event);
    }
    onDrop(event) {
        super.onDrop(event);
    }
    swapEffect(event) {
        var _a;
        const dropItem = event.target;
        const dragTargetId = (_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.getData(ID_ATTR$1);
        const dragItem = document.getElementById(dragTargetId);
        if (dragItem && dropItem) {
            const animation = `dropIn ${this.animationTime}s ease none`;
            dragItem.style.animation = animation;
            dropItem.style.animation = animation;
            setTimeout(() => {
                dragItem.style.animation = '';
                dropItem.style.animation = '';
                const parent = dropItem.parentNode;
                const tmp = document.createElement('span');
                tmp.style.display = 'none';
                parent === null || parent === void 0 ? void 0 : parent.insertBefore(tmp, dropItem);
                parent === null || parent === void 0 ? void 0 : parent.replaceChild(dropItem, dragItem);
                parent === null || parent === void 0 ? void 0 : parent.replaceChild(dragItem, tmp);
                tmp.remove();
                this.swapEvent.emit({
                    source_id: dragTargetId,
                    target_id: dropItem.getAttribute(ID_ATTR$1),
                });
            }, this.animationTime * 1000);
        }
    }
}
VgSwappableElementDirective.REF_MAP = {};
VgSwappableElementDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgSwappableElementDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
VgSwappableElementDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgSwappableElementDirective, selector: "[vgSwappableElement]", inputs: { id: "id", collectionName: "collectionName", animationTime: "animationTime" }, outputs: { swapEvent: "swapEvent" }, host: { listeners: { "drag": "onDrag($event)", "dragstart": "onDragstart($event)", "dragend": "onDragend($event)", "dragenter": "onDragenter($event)", "dragleave": "onDragleave($event)", "dragover": "onDragover($event)", "drop": "onDrop($event)" } }, usesInheritance: true, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgSwappableElementDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgSwappableElement]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { id: [{
                type: Input
            }], swapEvent: [{
                type: Output
            }], collectionName: [{
                type: Input
            }], animationTime: [{
                type: Input
            }], onDrag: [{
                type: HostListener,
                args: ['drag', ['$event']]
            }], onDragstart: [{
                type: HostListener,
                args: ['dragstart', ['$event']]
            }], onDragend: [{
                type: HostListener,
                args: ['dragend', ['$event']]
            }], onDragenter: [{
                type: HostListener,
                args: ['dragenter', ['$event']]
            }], onDragleave: [{
                type: HostListener,
                args: ['dragleave', ['$event']]
            }], onDragover: [{
                type: HostListener,
                args: ['dragover', ['$event']]
            }], onDrop: [{
                type: HostListener,
                args: ['drop', ['$event']]
            }] } });

const ID_ATTR = 'vg-swap-item-id';
class VgSwappableListDirective extends VgSwappableBase {
    constructor(ref) {
        super(ID_ATTR, VgSwappableListDirective.REF_MAP, ref.nativeElement);
        this.ref = ref;
        this.dataList = [];
        this.animationTime = 0.4;
    }
    get collectionName() {
        return super._collectionName;
    }
    set collectionName(value) {
        super._collectionName = value;
    }
    ngOnChanges(changes) {
        if (changes.id) {
            this.el.setAttribute(ID_ATTR, String(this.id));
        }
    }
    onDrag(event) {
        super.onDrag(event);
    }
    onDragstart(event) {
        super.onDragstart(event);
    }
    onDragend(event) {
        super.onDragend(event);
    }
    onDragenter(event) {
        super.onDragenter(event);
    }
    onDragleave(event) {
        super.onDragleave(event);
    }
    onDragover(event) {
        super.onDragover(event);
    }
    onDrop(event) {
        super.onDrop(event);
    }
    swapEffect(event) {
        var _a;
        const dropItem = VgSwappableListDirective.REF_MAP[this._collectionName].dropItem;
        const dragItem = VgSwappableListDirective.REF_MAP[this._collectionName].dragItem;
        if (dragItem && dropItem) {
            const animation = `dropIn ${this.animationTime}s ease none`;
            dragItem.style.animation = animation;
            dropItem.style.animation = animation;
            const drop_target = event.currentTarget;
            const drag_target_id = (_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.getData(ID_ATTR);
            const sourceIndex = Number(drag_target_id);
            const targetIndex = Number(drop_target.getAttribute(ID_ATTR));
            setTimeout(() => {
                dragItem.style.animation = '';
                dropItem.style.animation = '';
                const tmp = this.dataList[targetIndex];
                this.dataList[targetIndex] = this.dataList[sourceIndex];
                this.dataList[sourceIndex] = tmp;
            }, this.animationTime * 1000);
        }
    }
}
VgSwappableListDirective.REF_MAP = {};
VgSwappableListDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgSwappableListDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
VgSwappableListDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgSwappableListDirective, selector: "[vgSwappableList]", inputs: { id: "id", dataList: "dataList", collectionName: "collectionName", animationTime: "animationTime" }, host: { listeners: { "drag": "onDrag($event)", "dragstart": "onDragstart($event)", "dragend": "onDragend($event)", "dragenter": "onDragenter($event)", "dragleave": "onDragleave($event)", "dragover": "onDragover($event)", "drop": "onDrop($event)" } }, usesInheritance: true, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgSwappableListDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[vgSwappableList]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { id: [{
                type: Input
            }], dataList: [{
                type: Input
            }], collectionName: [{
                type: Input
            }], animationTime: [{
                type: Input
            }], onDrag: [{
                type: HostListener,
                args: ['drag', ['$event']]
            }], onDragstart: [{
                type: HostListener,
                args: ['dragstart', ['$event']]
            }], onDragend: [{
                type: HostListener,
                args: ['dragend', ['$event']]
            }], onDragenter: [{
                type: HostListener,
                args: ['dragenter', ['$event']]
            }], onDragleave: [{
                type: HostListener,
                args: ['dragleave', ['$event']]
            }], onDragover: [{
                type: HostListener,
                args: ['dragover', ['$event']]
            }], onDrop: [{
                type: HostListener,
                args: ['drop', ['$event']]
            }] } });

class VgDirectivesModule {
}
VgDirectivesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDirectivesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgDirectivesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDirectivesModule, declarations: [VgNumberOnlyDirective,
        VgCurrencyInputDirective,
        VgFocusFirstInvalidDirective,
        VgDelayClickDirective,
        VgSwappableListDirective,
        VgSwappableElementDirective], imports: [CommonModule], exports: [VgNumberOnlyDirective,
        VgCurrencyInputDirective,
        VgFocusFirstInvalidDirective,
        VgDelayClickDirective,
        VgSwappableListDirective,
        VgSwappableElementDirective] });
VgDirectivesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDirectivesModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgDirectivesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        VgNumberOnlyDirective,
                        VgCurrencyInputDirective,
                        VgFocusFirstInvalidDirective,
                        VgDelayClickDirective,
                        VgSwappableListDirective,
                        VgSwappableElementDirective,
                    ],
                    exports: [
                        VgNumberOnlyDirective,
                        VgCurrencyInputDirective,
                        VgFocusFirstInvalidDirective,
                        VgDelayClickDirective,
                        VgSwappableListDirective,
                        VgSwappableElementDirective,
                    ],
                    imports: [CommonModule],
                }]
        }] });

class VgCustomCurrencyPipe {
    constructor() {
        this.currentLocale = 'vi-VN';
        if (navigator.language) {
            this.changeLocale(navigator.language);
        }
    }
    changeLocale(locale) {
        this.currentLocale = locale;
    }
    // eslint-disable-next-line
    transform(value, ...arg) {
        if (arg[0] && arg[0] !== this.currentLocale) {
            this.changeLocale(arg[0]);
        }
        const strWithNoComma = value.toString().replace(/(,|\.)/g, '');
        const strDigitOnly = strWithNoComma.replace(/\D/g, '');
        if (Number(strDigitOnly)) {
            return Number(strDigitOnly).toLocaleString(this.currentLocale);
        }
        else {
            return strDigitOnly.replace(/\D/g, '');
        }
    }
}
VgCustomCurrencyPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgCustomCurrencyPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
VgCustomCurrencyPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgCustomCurrencyPipe, name: "vgCurrency" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgCustomCurrencyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'vgCurrency',
                }]
        }], ctorParameters: function () { return []; } });

class VgPipeModule {
}
VgPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeModule, declarations: [VgCustomCurrencyPipe], imports: [CommonModule], exports: [VgCustomCurrencyPipe] });
VgPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [VgCustomCurrencyPipe],
                    imports: [CommonModule],
                    exports: [VgCustomCurrencyPipe],
                }]
        }] });

class VgLoaderService {
    constructor() {
        this.loadingSubject$ = new BehaviorSubject(false);
    }
    loading(value = false) {
        this.loadingSubject$.next(value);
    }
    getLoader() {
        return this.loadingSubject$;
    }
}
VgLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
VgLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderService, decorators: [{
            type: Injectable
        }] });

class VgLoaderComponent {
    constructor(loaderService) {
        this.loaderService = loaderService;
        this.loading$ = this.loaderService.getLoader();
    }
}
VgLoaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderComponent, deps: [{ token: VgLoaderService }], target: i0.ɵɵFactoryTarget.Component });
VgLoaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgLoaderComponent, selector: "vg-loader", ngImport: i0, template: "<div\n  class=\"loading-bar loading-bar--active\"\n  [hidden]=\"(loading$ | async) === false\"\n></div>\n", styles: [".loading-bar{position:fixed;top:0;left:0;width:100%;height:5px;background-color:transparent;overflow:hidden;z-index:100000000}.loading-bar--active:after{content:\"\";position:absolute;top:0;left:0;width:40%;height:5px;background-color:#001aff;border-radius:10%;box-shadow:10px 0 30px 15px #010491,-10px 0 30px 15px #010491;-webkit-animation:moveLoadBar 2s cubic-bezier(.09,.89,.7,.71) infinite;animation:moveLoadBar 2s cubic-bezier(.09,.89,.7,.71) infinite}@-webkit-keyframes moveLoadBar{0%{left:-10%}to{left:110%}}@keyframes moveLoadBar{0%{left:-10%}to{left:110%}}\n"], pipes: { "async": i1.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-loader',
                    templateUrl: './vg-loader.component.html',
                    styleUrls: ['./vg-loader.component.scss'],
                }]
        }], ctorParameters: function () { return [{ type: VgLoaderService }]; } });

class VgLoaderModule {
}
VgLoaderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgLoaderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderModule, declarations: [VgLoaderComponent], imports: [CommonModule], exports: [VgLoaderComponent] });
VgLoaderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderModule, providers: [VgLoaderService], imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLoaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [VgLoaderComponent],
                    imports: [CommonModule],
                    providers: [VgLoaderService],
                    exports: [VgLoaderComponent],
                }]
        }] });

class VgUploadProgressComponent {
    constructor() {
        this.successMsg = 'Upload successfully';
        this.failureMsg = '';
        // eslint-disable-next-line
        this.successEvent = new EventEmitter();
        // eslint-disable-next-line
        this.failureEvent = new EventEmitter();
        this.completeEvent = new EventEmitter();
        this.subscription = new Subscription();
        this.responseData = {
            type: 'info',
            data: 0,
            progress: 0,
        };
    }
    ngOnChanges(changes) {
        if (changes.httpObs && this.httpObs) {
            if (this.subscription && !this.subscription.closed) {
                this.subscription.unsubscribe();
            }
            this.responseData = {
                type: 'info',
                data: 0,
                progress: 0,
            };
            this.subscription = this.httpObs.subscribe(
            // eslint-disable-next-line
            (event) => {
                switch (event.type) {
                    case HttpEventType.Sent:
                        console.debug('Request has been made!');
                        break;
                    case HttpEventType.ResponseHeader:
                        console.debug('Response header has been received!');
                        break;
                    case HttpEventType.UploadProgress:
                        this.responseData.progress = Math.round((event.loaded / (event.total || 1)) * 100);
                        this.responseData.data = this.responseData.progress;
                        console.debug(`Uploaded! ${this.responseData.data}%`);
                        break;
                    case HttpEventType.Response:
                        console.debug('Successfully created!', event.body);
                        this.responseData.data = 0;
                        setTimeout(() => {
                            this.successEvent.emit(event.body);
                            this.responseData = {
                                type: 'success',
                                data: this.successMsg,
                                progress: 100,
                            };
                        }, 1500);
                }
            }, (error) => {
                var _a;
                console.error(error);
                this.failureEvent.emit(error);
                this.responseData = {
                    type: 'danger',
                    data: (_a = this.failureMsg) !== null && _a !== void 0 ? _a : error === null || error === void 0 ? void 0 : error.message,
                    progress: 100,
                };
            }, () => {
                console.debug('Complete!');
                this.completeEvent.emit();
            });
        }
    }
    ngOnDestroy() {
        if (!this.subscription.closed) {
            this.subscription.unsubscribe();
        }
    }
}
VgUploadProgressComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgUploadProgressComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
VgUploadProgressComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgUploadProgressComponent, selector: "vg-upload-progress", inputs: { httpObs: "httpObs", successMsg: "successMsg", failureMsg: "failureMsg" }, outputs: { successEvent: "successEvent", failureEvent: "failureEvent", completeEvent: "completeEvent" }, usesOnChanges: true, ngImport: i0, template: "<ngb-progressbar\n  *ngIf=\"httpObs\"\n  [type]=\"responseData.type\"\n  [value]=\"responseData.progress\"\n  [striped]=\"true\"\n  [animated]=\"true\"\n>\n  {{ responseData.data }}{{ responseData.type === \"info\" ? \"%\" : \"\" }}\n</ngb-progressbar>\n", styles: [""], components: [{ type: i1$1.NgbProgressbar, selector: "ngb-progressbar", inputs: ["value", "max", "animated", "striped", "textType", "type", "showValue", "height"] }], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgUploadProgressComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-upload-progress',
                    templateUrl: './vg-upload-progress.component.html',
                    styleUrls: ['./vg-upload-progress.component.scss'],
                }]
        }], propDecorators: { httpObs: [{
                type: Input
            }], successMsg: [{
                type: Input
            }], failureMsg: [{
                type: Input
            }], successEvent: [{
                type: Output
            }], failureEvent: [{
                type: Output
            }], completeEvent: [{
                type: Output
            }] } });

class VgIdleTimer {
    constructor(timeout = 30, onTimeout = () => {
        console.debug('Interaction Timeout!');
    }) {
        this.timeout = timeout;
        this.onTimeout = onTimeout;
        this.eventHandler = this.updateExpiredTime.bind(this);
        this.tracker();
        this.startInterval();
    }
    startInterval() {
        this.updateExpiredTime();
        this.interval = setInterval(() => {
            const expiredTime = parseInt(localStorage.getItem('_expiredTime'), 10);
            if (expiredTime < Date.now()) {
                if (this.onTimeout) {
                    this.onTimeout();
                    this.cleanUp();
                }
            }
        }, 1000);
    }
    updateExpiredTime() {
        if (this.timeoutTracker) {
            clearTimeout(this.timeoutTracker);
        }
        this.timeoutTracker = setTimeout(() => {
            localStorage.setItem('_expiredTime', String(Date.now() + this.timeout * 1000));
        }, 300);
    }
    tracker() {
        window.addEventListener('mousemove', this.eventHandler);
        window.addEventListener('scroll', this.eventHandler);
        window.addEventListener('keydown', this.eventHandler);
    }
    cleanUp() {
        clearInterval(this.interval);
        window.removeEventListener('mousemove', this.eventHandler);
        window.removeEventListener('scroll', this.eventHandler);
        window.removeEventListener('keydown', this.eventHandler);
    }
}

class VgHerokuWakeupComponent {
    constructor(http) {
        this.http = http;
        this.configList = {};
        this.delayRetry = 10000;
        this.maxRetries = 3;
        this.interactTimeout = 30000;
        this.pingSuccess = null;
        this.setupAwake = () => __awaiter(this, void 0, void 0, function* () {
            if (this.isTriggerReady) {
                try {
                    this.isTriggerReady = false;
                    document.removeEventListener('click', this.setupAwake, {
                        capture: true,
                    });
                    yield this.ping();
                    this.timer = new VgIdleTimer(this.interactTimeout, this.trigger);
                }
                catch (e) {
                    console.error(e);
                }
            }
        });
        this.trigger = () => {
            console.debug('Time out, ready to trigger ping!');
            this.isTriggerReady = true;
            document.addEventListener('click', this.setupAwake, { capture: true });
        };
    }
    ngOnInit() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.ping();
            this.timer = new VgIdleTimer(this.interactTimeout, this.trigger);
        });
    }
    ping() {
        return __awaiter(this, void 0, void 0, function* () {
            console.debug('Start ping services');
            this.pingSuccess = 0;
            // setTimeout(() => {
            //   console.log('simulate ping success');
            //   this.pingSuccess = 1;
            // }, 5000);
            let successCount = 0;
            try {
                let retries = 0;
                let i = 0;
                while (i < Object.keys(this.configList).length) {
                    const isSuccess = yield this.processLevel(this.configList[`${i}`]);
                    if (isSuccess) {
                        i++;
                        successCount++;
                    }
                    else if (retries >= this.maxRetries) {
                        i++;
                        retries = 0;
                    }
                    else {
                        retries++;
                        yield of().pipe(delay(this.delayRetry)).toPromise();
                    }
                }
            }
            catch (e) {
                console.error('Error while pinging services!', e);
            }
            finally {
                if (successCount === Object.keys(this.configList).length) {
                    this.pingSuccess = 1;
                }
                console.debug(`Ping service ${this.pingSuccess ? 'success' : 'failed'}!`);
            }
        });
    }
    processLevel(serviceConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const obsMap = {};
                Object.keys(serviceConfig).forEach((key) => {
                    obsMap[key] = this.http
                        .head(serviceConfig[key].url + 'ping')
                        .pipe(map(() => {
                        serviceConfig[key].status = 'success';
                        return true;
                    }), catchError((e) => {
                        console.error(e);
                        serviceConfig[key].status = 'failed';
                        return of(false);
                    }));
                    serviceConfig[key].status = 'loading';
                    serviceConfig[key].obs = obsMap[key];
                });
                const result = yield forkJoin(obsMap).toPromise();
                console.debug(result);
                return Object.keys(serviceConfig)
                    .map((key) => serviceConfig[key].status)
                    .every((status) => status === 'success');
            }
            catch (e) {
                console.debug(e);
                return false;
            }
        });
    }
}
VgHerokuWakeupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupComponent, deps: [{ token: i1$3.HttpClient }], target: i0.ɵɵFactoryTarget.Component });
VgHerokuWakeupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgHerokuWakeupComponent, selector: "vg-heroku-wakeup", inputs: { configList: "configList", delayRetry: "delayRetry", maxRetries: "maxRetries", templateRef: "templateRef", interactTimeout: "interactTimeout" }, ngImport: i0, template: "<ng-container\n  [ngTemplateOutlet]=\"templateRef\"\n  *ngIf=\"pingSuccess; else loadingDiv\"\n></ng-container>\n<ng-template #loadingDiv>\n  <div class=\"h-100 w-100 d-flex justify-content-center align-items-center\">\n    <div class=\"w-25 h-50\">\n      <div *ngFor=\"let servicePriority of $any(configList) | keyvalue\">\n        <h5>Priority: {{ servicePriority.key }}</h5>\n        <ul class=\"list-group\">\n          <li\n            *ngFor=\"let service of $any(servicePriority.value) | keyvalue\"\n            class=\"list-group-item d-flex justify-content-around\"\n          >\n            <div class=\"d-inline-block\">\n              {{ service.key }}\n            </div>\n            <div class=\"d-inline-block\">\n              <ng-container [ngSwitch]=\"$any(service.value).status\">\n                <div *ngSwitchCase=\"'success'\" class=\"text-success text-center\">\n                  <i class=\"bi bi-check-circle\"></i>\n                </div>\n                <div *ngSwitchCase=\"'failed'\" class=\"text-danger text-center\">\n                  <i class=\"bi bi-x-circle\"></i>\n                </div>\n                <div\n                  *ngSwitchCase=\"'loading'\"\n                  class=\"spinner-border spinner-border-sm text-info ms-auto\"\n                  role=\"status\"\n                  aria-hidden=\"true\"\n                ></div>\n                <div *ngSwitchDefault class=\"text-secondary text-center\">\n                  <i class=\"bi bi-clock\"></i>\n                </div>\n              </ng-container>\n            </div>\n          </li>\n        </ul>\n      </div>\n    </div>\n  </div>\n</ng-template>\n", styles: [":host{position:absolute;top:0;bottom:0;right:0;left:0}\n"], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "keyvalue": i1.KeyValuePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-heroku-wakeup',
                    templateUrl: './vg-heroku-wakeup.component.html',
                    styleUrls: ['./vg-heroku-wakeup.component.scss'],
                }]
        }], ctorParameters: function () { return [{ type: i1$3.HttpClient }]; }, propDecorators: { configList: [{
                type: Input
            }], delayRetry: [{
                type: Input
            }], maxRetries: [{
                type: Input
            }], templateRef: [{
                type: Input
            }], interactTimeout: [{
                type: Input
            }] } });

class VgHerokuWakeupService {
    constructor() {
        this.trackRequest = new BehaviorSubject(true);
    }
}
VgHerokuWakeupService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
VgHerokuWakeupService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class VgHerokuWakeupNewComponent {
    constructor(http, herokuWakeupService) {
        this.http = http;
        this.herokuWakeupService = herokuWakeupService;
        this.configList = {};
        this.delayRetry = 10000;
        this.maxRetries = 3;
        this.interactTimeout = 30000; // seconds
        this.pingSuccess = null;
        this.setupAwake = () => __awaiter(this, void 0, void 0, function* () {
            if (this.isTriggerReady) {
                try {
                    this.isTriggerReady = false;
                    document.removeEventListener('click', this.setupAwake, {
                        capture: true,
                    });
                    document.removeEventListener('input', this.setupAwake, {
                        capture: true,
                    });
                    document.removeEventListener('scroll', this.setupAwake, {
                        capture: true,
                    });
                    yield this.ping();
                }
                catch (e) {
                    console.error(e);
                }
            }
        });
        this.sub = this.herokuWakeupService.trackRequest.subscribe((isFirstTime) => {
            if (isFirstTime) {
                console.debug(isFirstTime);
                if (this.timer) {
                    clearTimeout(this.timer);
                }
                this.isTriggerReady = true;
                this.setupAwake().finally();
            }
            else {
                if (this.timer) {
                    clearTimeout(this.timer);
                }
                this.timer = setTimeout(() => {
                    console.debug('Time out, ready to trigger ping!');
                    this.isTriggerReady = true;
                    document.addEventListener('click', this.setupAwake, {
                        capture: true,
                    });
                    document.addEventListener('input', this.setupAwake, {
                        capture: true,
                    });
                    document.addEventListener('scroll', this.setupAwake, {
                        capture: true,
                    });
                }, this.interactTimeout);
            }
        });
    }
    ping() {
        return __awaiter(this, void 0, void 0, function* () {
            console.debug('Start ping services');
            this.pingSuccess = 0;
            // setTimeout(() => {
            //   console.log('simulate ping success');
            //   this.pingSuccess = 1;
            // }, 5000);
            let successCount = 0;
            try {
                let retries = 0;
                let i = 0;
                while (i < Object.keys(this.configList).length) {
                    const isSuccess = yield this.processLevel(this.configList[`${i}`]);
                    if (isSuccess) {
                        i++;
                        successCount++;
                    }
                    else if (retries >= this.maxRetries) {
                        i++;
                        retries = 0;
                    }
                    else {
                        retries++;
                        yield of().pipe(delay(this.delayRetry)).toPromise();
                    }
                }
            }
            catch (e) {
                console.error('Error while pinging services!', e);
            }
            finally {
                if (successCount === Object.keys(this.configList).length) {
                    this.pingSuccess = 1;
                }
                console.debug(`Ping service ${this.pingSuccess ? 'success' : 'failed'}!`);
            }
        });
    }
    ngOnInit() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.ping();
        });
    }
    processLevel(serviceConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const obsMap = {};
                Object.keys(serviceConfig).forEach((key) => {
                    obsMap[key] = this.http
                        .head(serviceConfig[key].url + 'ping')
                        .pipe(map(() => {
                        serviceConfig[key].status = 'success';
                        return true;
                    }), catchError((e) => {
                        console.error(e);
                        serviceConfig[key].status = 'failed';
                        return of(false);
                    }));
                    serviceConfig[key].status = 'loading';
                    serviceConfig[key].obs = obsMap[key];
                });
                const result = yield forkJoin(obsMap).toPromise();
                console.debug(result);
                return Object.keys(serviceConfig)
                    .map((key) => serviceConfig[key].status)
                    .every((status) => status === 'success');
            }
            catch (e) {
                console.debug(e);
                return false;
            }
        });
    }
    ngOnDestroy() {
        this.sub.unsubscribe();
    }
}
VgHerokuWakeupNewComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupNewComponent, deps: [{ token: i1$3.HttpClient }, { token: VgHerokuWakeupService }], target: i0.ɵɵFactoryTarget.Component });
VgHerokuWakeupNewComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgHerokuWakeupNewComponent, selector: "vg-heroku-wakeup-new", inputs: { configList: "configList", delayRetry: "delayRetry", maxRetries: "maxRetries", templateRef: "templateRef", interactTimeout: "interactTimeout" }, ngImport: i0, template: "<ng-container\n  [ngTemplateOutlet]=\"templateRef\"\n  *ngIf=\"pingSuccess; else loadingDiv\"\n></ng-container>\n<ng-template #loadingDiv>\n  <div class=\"h-100 w-100 d-flex justify-content-center align-items-center\">\n    <div class=\"w-25 h-50\">\n      <div *ngFor=\"let servicePriority of $any(configList) | keyvalue\">\n        <h5>Priority: {{ servicePriority.key }}</h5>\n        <ul class=\"list-group\">\n          <li\n            *ngFor=\"let service of $any(servicePriority.value) | keyvalue\"\n            class=\"list-group-item d-flex justify-content-around\"\n          >\n            <div class=\"d-inline-block\">\n              {{ service.key }}\n            </div>\n            <div class=\"d-inline-block\">\n              <ng-container [ngSwitch]=\"$any(service.value).status\">\n                <div *ngSwitchCase=\"'success'\" class=\"text-success text-center\">\n                  <i class=\"bi bi-check-circle\"></i>\n                </div>\n                <div *ngSwitchCase=\"'failed'\" class=\"text-danger text-center\">\n                  <i class=\"bi bi-x-circle\"></i>\n                </div>\n                <div\n                  *ngSwitchCase=\"'loading'\"\n                  class=\"spinner-border spinner-border-sm text-info ms-auto\"\n                  role=\"status\"\n                  aria-hidden=\"true\"\n                ></div>\n                <div *ngSwitchDefault class=\"text-secondary text-center\">\n                  <i class=\"bi bi-clock\"></i>\n                </div>\n              </ng-container>\n            </div>\n          </li>\n        </ul>\n      </div>\n    </div>\n  </div>\n</ng-template>\n", styles: [""], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "keyvalue": i1.KeyValuePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgHerokuWakeupNewComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-heroku-wakeup-new',
                    templateUrl: './vg-heroku-wakeup-new.component.html',
                    styleUrls: ['./vg-heroku-wakeup-new.component.scss'],
                }]
        }], ctorParameters: function () { return [{ type: i1$3.HttpClient }, { type: VgHerokuWakeupService }]; }, propDecorators: { configList: [{
                type: Input
            }], delayRetry: [{
                type: Input
            }], maxRetries: [{
                type: Input
            }], templateRef: [{
                type: Input
            }], interactTimeout: [{
                type: Input
            }] } });

class VgUtilModule {
}
VgUtilModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgUtilModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgUtilModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgUtilModule, declarations: [VgUploadProgressComponent,
        VgHerokuWakeupComponent,
        VgHerokuWakeupNewComponent], imports: [CommonModule, NgbAlertModule, NgbProgressbarModule], exports: [VgUploadProgressComponent,
        VgHerokuWakeupComponent,
        VgHerokuWakeupNewComponent] });
VgUtilModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgUtilModule, imports: [[CommonModule, NgbAlertModule, NgbProgressbarModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgUtilModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        VgUploadProgressComponent,
                        VgHerokuWakeupComponent,
                        VgHerokuWakeupNewComponent,
                    ],
                    imports: [CommonModule, NgbAlertModule, NgbProgressbarModule],
                    exports: [
                        VgUploadProgressComponent,
                        VgHerokuWakeupComponent,
                        VgHerokuWakeupNewComponent,
                    ],
                }]
        }] });

class VgScrollDataSource extends DataSource {
    constructor(itemService, http, url, params, pageSize, mapper, sizeParamName, pageParamName) {
        super();
        this.itemService = itemService;
        this.http = http;
        this.url = url;
        this.params = params;
        this.pageSize = pageSize;
        this.mapper = mapper;
        this.sizeParamName = sizeParamName;
        this.pageParamName = pageParamName;
        this.lastPage = 0;
        this.cachedItems = Array.from({ length: 0 });
        this.dataStream = new BehaviorSubject(this.cachedItems);
        this.subscription = new Subscription();
        // Start with some data.
        this.fetchItemPage(0);
    }
    fetchItemPage(page) {
        this.http
            .get(this.url, {
            params: Object.assign(Object.assign({}, this.params), { [this.pageParamName]: page, [this.sizeParamName]: this.pageSize }),
        })
            .subscribe((next) => {
            this.cachedItems = this.cachedItems.concat(this.mapper(next).content);
            this.dataStream.next(this.cachedItems);
        });
    }
    getPageForIndex(i) {
        return Math.floor(i / this.pageSize);
    }
    manualFetch() {
        this.fetchItemPage(this.lastPage + 1);
    }
    connect(collectionViewer) {
        this.subscription.add(collectionViewer.viewChange.subscribe((range) => {
            const currentPage = this.getPageForIndex(range.end);
            if (currentPage > this.lastPage) {
                this.lastPage = currentPage;
                this.fetchItemPage(currentPage);
            }
        }));
        return this.dataStream;
    }
    disconnect(collectionViewer) {
        console.debug(collectionViewer);
        this.subscription.unsubscribe();
    }
}

class VgScrollerService {
    constructor(http) {
        this.http = http;
    }
    getRandomFact() {
        const month = Math.floor(Math.random() * 11) + 1;
        let maxDay = 30;
        if (month === 2) {
            maxDay = 27;
        }
        else if ([4, 6, 9, 11].includes(month)) {
            maxDay = 29;
        }
        const day = Math.floor(Math.random() * maxDay) + 1;
        return this.http.get(`http://numbersapi.com/${month}/${day}/date?json`);
    }
}
VgScrollerService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgScrollerService, deps: [{ token: i1$3.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
VgScrollerService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgScrollerService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgScrollerService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1$3.HttpClient }]; } });

class VgScrollerComponent {
    constructor(factService, http) {
        this.factService = factService;
        this.http = http;
        this.minBufferPx = 50;
        this.maxBufferPx = 100;
        this.itemSize = 44;
        this.pageSize = 20;
        this.url = '';
        this.params = {};
        this.mapper = (response) => ({
            content: response,
            totalPages: response.length,
        });
        this.sizeParamName = 'size';
        this.pageParamName = 'page';
    }
    ngOnInit() {
        this.dataSource = new VgScrollDataSource(this.factService, this.http, this.url, this.params, this.pageSize, this.mapper, this.sizeParamName, this.pageParamName);
    }
    fetch() {
        this.dataSource.manualFetch();
    }
}
VgScrollerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgScrollerComponent, deps: [{ token: VgScrollerService }, { token: i1$3.HttpClient }], target: i0.ɵɵFactoryTarget.Component });
VgScrollerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgScrollerComponent, selector: "vg-scroller", inputs: { minBufferPx: "minBufferPx", maxBufferPx: "maxBufferPx", itemSize: "itemSize", pageSize: "pageSize", url: "url", params: "params", mapper: "mapper", sizeParamName: "sizeParamName", pageParamName: "pageParamName", customTemplate: "customTemplate" }, ngImport: i0, template: "<cdk-virtual-scroll-viewport\n  *ngIf=\"dataSource\"\n  [itemSize]=\"itemSize\"\n  [minBufferPx]=\"minBufferPx\"\n  [maxBufferPx]=\"maxBufferPx\"\n  class=\"item-scroll-viewport\"\n>\n  <ng-container *ngIf=\"dataSource.cachedItems.length; else noDataTmpl\">\n    <li *cdkVirtualFor=\"let item of dataSource\">\n      <ng-container\n        [ngTemplateOutlet]=\"customTemplate ? customTemplate : defaultItemTmpl\"\n        [ngTemplateOutletContext]=\"{ item: item }\"\n      >\n      </ng-container>\n    </li>\n  </ng-container>\n</cdk-virtual-scroll-viewport>\n<ng-template #defaultItemTmpl let-item=\"item\">\n  <div *ngIf=\"item\" class=\"list-group-item\">\n    <div class=\"text-dark\">{{ item.name }}</div>\n  </div>\n</ng-template>\n<ng-template #noDataTmpl>\n  <div>No data found</div>\n</ng-template>\n", styles: [".item-scroll-viewport{height:100%;width:100%}cdk-virtual-scroll-viewport{border:1px solid black}cdk-virtual-scroll-viewport li{list-style:none}::-webkit-scrollbar{width:.5rem}::-webkit-scrollbar-track{background:#f1f1f1;border-radius:.2rem}::-webkit-scrollbar-thumb{background:#888;border-radius:.2rem}::-webkit-scrollbar-thumb:hover{background:#555}\n"], components: [{ type: i3.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }], directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3.CdkFixedSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "minBufferPx", "maxBufferPx"] }, { type: i3.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgScrollerComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'vg-scroller',
                    templateUrl: './vg-scroller.component.html',
                    styleUrls: ['./vg-scroller.component.scss'],
                }]
        }], ctorParameters: function () { return [{ type: VgScrollerService }, { type: i1$3.HttpClient }]; }, propDecorators: { minBufferPx: [{
                type: Input
            }], maxBufferPx: [{
                type: Input
            }], itemSize: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], url: [{
                type: Input
            }], params: [{
                type: Input
            }], mapper: [{
                type: Input
            }], sizeParamName: [{
                type: Input
            }], pageParamName: [{
                type: Input
            }], customTemplate: [{
                type: Input
            }] } });

class VgLayoutModule {
}
VgLayoutModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLayoutModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VgLayoutModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLayoutModule, declarations: [VgScrollerComponent], imports: [CommonModule, ScrollingModule], exports: [VgScrollerComponent] });
VgLayoutModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLayoutModule, providers: [VgScrollerService], imports: [[CommonModule, ScrollingModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0, type: VgLayoutModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [VgScrollerComponent],
                    imports: [CommonModule, ScrollingModule],
                    exports: [VgScrollerComponent],
                    providers: [VgScrollerService],
                }]
        }] });

/*
 * Public API Surface of ngx-vengeance-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DIALOG_ANIMATION, DIALOG_DATA, DIALOG_OPTIONS, DIALOG_POSITION, DIALOG_REF, DIALOG_SIZE, DIALOG_TYPE, RUNTIME_TOAST_CONF, TOAST_ANIMATION, TOAST_CONF, TOAST_DATA, TOAST_OVERLAY_REF, TOAST_POSITION, TOAST_SIZE, TOAST_TYPE, VgAutoInputComponent, VgConfirmDialogComponent, VgControlModule, VgCurrencyInputDirective, VgCustomCurrencyPipe, VgDelayClickDirective, VgDelayInputDirective, VgDialogModule, VgDialogOverlayRef, VgDialogService, VgDialogWrapperComponent, VgDirectivesModule, VgErrorDictService, VgErrorMessagePipe, VgErrorSectionComponent, VgFileIconPipe, VgFileInputComponent, VgFocusFirstInvalidDirective, VgHerokuWakeupComponent, VgHerokuWakeupNewComponent, VgHerokuWakeupService, VgIdleTimer, VgLayoutModule, VgLightTreeTableComponent, VgLoaderComponent, VgLoaderModule, VgLoaderService, VgMessageDialogComponent, VgNumberOnlyDirective, VgPipeModule, VgPipeWrapperPipe, VgScrollDataSource, VgScrollerComponent, VgScrollerService, VgSwappableElementDirective, VgSwappableListDirective, VgTagInputComponent, VgToastComponent, VgToastModule, VgToastOverlayRef, VgToastService, VgTreeLevelArrayPipePipe, VgTreeTableBlockConfigPipe, VgTreeTableComponent, VgTreeTableItemComponent, VgTreeTableModule, VgUploadProgressComponent, VgUtilModule };
//# sourceMappingURL=ngx-vengeance-lib.js.map
