import { EventEmitter, Injector, OnInit } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { FileType } from '../../util/vg-file.util';
import { DomSanitizer, SafeResourceUrl } from '@angular/platform-browser';
import { HttpClient } from '@angular/common/http';
import * as i0 from "@angular/core";
export declare class VgFileInputComponent implements OnInit, ControlValueAccessor {
    private inj;
    private domSanitizer;
    private http;
    placeholder: string;
    formData: FormData;
    formDataFilePart: string;
    remoteFileType: FileType;
    validateFn: (file: File) => boolean;
    metadataLoadedEvent: EventEmitter<Event>;
    fileSelectedEvent: EventEmitter<File>;
    isDisabled: boolean;
    isReadonly: boolean;
    remoteFileSrc: string | SafeResourceUrl | null;
    fileType: FileType;
    file: File | null;
    fileSrc: string | SafeResourceUrl | null;
    fileReader: FileReader;
    ngControl: NgControl;
    onChange: (val: any) => void;
    onTouched: () => void;
    remoteLoaded: boolean;
    constructor(inj: Injector, domSanitizer: DomSanitizer, http: HttpClient);
    ngOnInit(): void;
    registerOnChange(fn: never): void;
    registerOnTouched(fn: never): void;
    writeValue(obj: never): void;
    setDisabledState(isDisabled: boolean): void;
    selectFile(event: Event): void;
    onLoadedMetadata(event: Event): void;
    dragover(event: DragEvent, dragZone: HTMLDivElement): void;
    dragend(event: Event, dragZone: HTMLDivElement): void;
    drop(event: DragEvent, dragZone: HTMLDivElement): void;
    processFile(file: File): void;
    clearFile(event: Event): void;
    resolveRemote(value: boolean): void;
    browseFile(fileInput: HTMLInputElement): void;
    onErrorLoad(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<VgFileInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<VgFileInputComponent, "vg-file-input", never, { "placeholder": "placeholder"; "formData": "formData"; "formDataFilePart": "formDataFilePart"; "remoteFileType": "remoteFileType"; "validateFn": "validateFn"; "isDisabled": "isDisabled"; "isReadonly": "isReadonly"; }, { "metadataLoadedEvent": "metadataLoadedEvent"; "fileSelectedEvent": "fileSelectedEvent"; }, never, never>;
}
