import { InjectionToken } from '@angular/core';
import { AnimationTriggerMetadata } from '@angular/animations';
export declare const DIALOG_DATA: InjectionToken<VgDialogData>;
export declare const DIALOG_OPTIONS: InjectionToken<VgDialogOptions>;
export declare const DIALOG_TYPE: {
    SUCCESS: {
        bgColor: string;
        textColor: string;
    };
    ERROR: {
        bgColor: string;
        textColor: string;
    };
    WARNING: {
        bgColor: string;
        textColor: string;
    };
    INFO: {
        bgColor: string;
        textColor: string;
    };
    NORMAL: {
        bgColor: string;
        textColor: string;
    };
    CUSTOM: null;
};
export declare const DIALOG_POSITION: {
    TOP_LEFT: {
        top: string;
        left: string;
    };
    TOP_CENTER: {
        top: string;
        horizontalAlignment: boolean;
    };
    TOP_RIGHT: {
        top: string;
        right: string;
    };
    BOTTOM_LEFT: {
        bottom: string;
        left: string;
    };
    BOTTOM_CENTER: {
        bottom: string;
        horizontalAlignment: boolean;
    };
    BOTTOM_RIGHT: {
        bottom: string;
        right: string;
    };
    CENTER: {
        horizontalAlignment: boolean;
        verticalAlignment: boolean;
    };
};
export declare const DIALOG_SIZE: {
    SMALL_DIALOG: {
        width: string;
        height: string;
    };
    MEDIUM_DIALOG: {
        width: string;
        height: string;
    };
    LARGE_DIALOG: {
        width: string;
        height: string;
    };
};
export interface VgDialogOptions {
    panelClass?: string | string[];
    hasBackdrop?: boolean;
    backdropClass?: string | string[];
    disposeOnNavigation?: boolean;
    top?: string;
    size: {
        width?: number | string;
        height?: number | string;
    };
    type?: {
        bgColor?: string;
        textColor?: string;
    };
    animation?: {
        fadeOut: number;
        fadeIn: number;
    };
}
export interface VgDialogButton {
    label: string;
    className: string;
}
export interface VgDialogButtons {
    confirm?: VgDialogButton;
    cancel?: VgDialogButton;
}
export declare type VgDialogAnimationState = 'default' | 'closing';
export interface VgDialogData {
    title?: string;
    message?: string;
    buttons?: VgDialogButtons;
    imageUrl?: string;
    iconClass?: string;
    sound?: string;
}
export declare const DIALOG_ANIMATION: {
    readonly fadeDialog: AnimationTriggerMetadata;
};
