import { Injector } from '@angular/core';
import { Observable } from 'rxjs';
import { ComponentType } from '@angular/cdk/portal';
import { Overlay, PositionStrategy } from '@angular/cdk/overlay';
import { VgDialogOverlayRef } from './vg-dialog-overlay-ref';
import { VgDialogData, VgDialogOptions } from './vg-dialog-config';
import * as i0 from "@angular/core";
export declare class VgDialogService {
    private parentInjector;
    private overlay;
    private dialogData;
    private dialogOptions;
    private lastDialogRef;
    initialDialogSounds: string[];
    constructor(parentInjector: Injector, overlay: Overlay, dialogData: VgDialogData, dialogOptions: VgDialogOptions);
    showDialog(content: ComponentType<any>, dialogData?: VgDialogData, dialogOptions?: VgDialogOptions): VgDialogOverlayRef;
    getInjector(dialogRef: VgDialogOverlayRef, parentInjector: Injector, dialogData?: VgDialogData, runtimeDialogOptions?: VgDialogOptions): Injector;
    getPositionStrategy(dialogOptions?: VgDialogOptions): PositionStrategy;
    confirm(mainTitle?: string, message?: string, labelYes?: string, labelNo?: string, className?: string): Observable<boolean>;
    show(title?: string, message?: string, iconClass?: string, className?: string, imageUrl?: string, sound?: string): Observable<boolean>;
    info(title?: string, message?: string, className?: string): Observable<boolean>;
    warning(title?: string, message?: string, className?: string): Observable<boolean>;
    error(title?: string, message?: string, className?: string): Observable<boolean>;
    success(title?: string, message?: string, className?: string): Observable<boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<VgDialogService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<VgDialogService>;
}
