import { ElementRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { VgSwappableBase } from './vg-swappable-base';
import * as i0 from "@angular/core";
export declare type SwapEvent = {
    source_id: string;
    target_id: string;
};
export declare class VgSwappableElementDirective extends VgSwappableBase implements OnChanges {
    private ref;
    id: string;
    swapEvent: EventEmitter<SwapEvent>;
    get collectionName(): string;
    set collectionName(value: string);
    animationTime: number;
    static readonly REF_MAP: {
        [key: string]: {
            dragItem?: HTMLElement | null;
            dropItem?: HTMLElement | null;
        };
    };
    constructor(ref: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    onDrag(event: DragEvent): void;
    onDragstart(event: DragEvent): void;
    onDragend(event: DragEvent): void;
    onDragenter(event: DragEvent): void;
    onDragleave(event: DragEvent): void;
    onDragover(event: DragEvent): void;
    onDrop(event: DragEvent): void;
    protected swapEffect(event: DragEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<VgSwappableElementDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<VgSwappableElementDirective, "[vgSwappableElement]", never, { "id": "id"; "collectionName": "collectionName"; "animationTime": "animationTime"; }, { "swapEvent": "swapEvent"; }, never>;
}
