import { CollectionViewer, DataSource } from '@angular/cdk/collections';
import { Observable } from 'rxjs';
import { VgScrollerService } from './vg-scroller.service';
import { HttpClient } from '@angular/common/http';
import { VgPage } from '../../model/vg-page';
export declare class VgScrollDataSource extends DataSource<any | undefined> {
    private itemService;
    private http;
    private url;
    private params;
    private pageSize;
    private mapper;
    private sizeParamName;
    private pageParamName;
    private lastPage;
    cachedItems: any[];
    private dataStream;
    private subscription;
    constructor(itemService: VgScrollerService, http: HttpClient, url: string, params: {
        [key: string]: string | number;
    }, pageSize: number, mapper: (response: any) => VgPage<any>, sizeParamName: string, pageParamName: string);
    private fetchItemPage;
    private getPageForIndex;
    manualFetch(): void;
    connect(collectionViewer: CollectionViewer): Observable<(any | undefined)[] | ReadonlyArray<any | undefined>>;
    disconnect(collectionViewer: CollectionViewer): void;
}
