import { InjectionToken, TemplateRef } from '@angular/core';
import { AnimationTriggerMetadata } from '@angular/animations';
export declare const TOAST_DATA: InjectionToken<VgToastData>;
export declare const TOAST_CONF: InjectionToken<VgToastData>;
export declare const TOAST_OVERLAY_REF: InjectionToken<VgToastData>;
export declare const RUNTIME_TOAST_CONF: InjectionToken<VgToastData>;
export declare const TOAST_TYPE: {
    SUCCESS: {
        bgColor: string;
        textColor: string;
        iconClass: string;
    };
    ERROR: {
        bgColor: string;
        textColor: string;
        iconClass: string;
    };
    WARNING: {
        bgColor: string;
        textColor: string;
        iconClass: string;
    };
    INFO: {
        bgColor: string;
        textColor: string;
        iconClass: string;
    };
    NORMAL: {
        bgColor: string;
        textColor: string;
        iconClass: string;
    };
    CUSTOM: null;
};
export declare const TOAST_POSITION: {
    TOP_LEFT: {
        top: string;
        left: string;
    };
    TOP_CENTER: {
        top: string;
        horizontalAlignment: boolean;
    };
    TOP_RIGHT: {
        top: string;
        right: string;
    };
    BOTTOM_LEFT: {
        bottom: string;
        left: string;
    };
    BOTTOM_CENTER: {
        bottom: string;
        horizontalAlignment: boolean;
    };
    BOTTOM_RIGHT: {
        bottom: string;
        right: string;
    };
    CENTER: {
        horizontalAlignment: boolean;
        verticalAlignment: boolean;
    };
};
export declare const TOAST_SIZE: {
    SMALL_DIALOG: {
        width: string;
        height: string;
    };
    MEDIUM_DIALOG: {
        width: string;
        height: string;
    };
    LARGE_DIALOG: {
        width: string;
        height: string;
    };
};
export declare type VgToastAnimationState = 'default' | 'closing';
export declare const TOAST_ANIMATION: {
    readonly fadeToast: AnimationTriggerMetadata;
};
export interface VgToastData {
    title?: string;
    text?: string;
    template?: TemplateRef<any>;
    templateContext?: never | null;
}
export interface VgToastConfig {
    position?: any;
    size?: any;
    animation?: {
        fadeOut: number;
        fadeIn: number;
    };
    duration?: number;
    type?: {
        bgColor: string;
        textColor: string;
        iconClass?: string;
    };
    class?: string | string[] | Set<string> | {
        [klass: string]: never;
    };
    sound?: string;
}
