import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { VgTreeTableColumnConfig, VgTreeTableConfig } from '../../model/vg-tree-table.config';
import { VgTreeNode } from '../../model/vg-tree-node';
import * as i0 from "@angular/core";
export declare class VgLightTreeTableComponent implements OnChanges {
    treeTableConfig: VgTreeTableConfig;
    treeItems: VgTreeNode<any>[];
    treeMap: {
        [key: string]: VgTreeNode<any>;
    };
    idKey: string;
    parentIdKey: string;
    rootId: string;
    selectRowEvent: EventEmitter<VgTreeNode<any> | undefined>;
    sortedNodeList: VgTreeNode<any>[];
    selectedNode: VgTreeNode<any> | undefined;
    internalTreeMap: {
        [key: string]: VgTreeNode<any>;
    };
    useInternalTreeMap: boolean;
    ngOnChanges(changes: SimpleChanges): void;
    processTreeSequenceAndLevel(node: VgTreeNode<any>, nodeList: VgTreeNode<any>[], seqObj: {
        sequence: number;
    }, level: number, paddingBlock: {
        [key: string]: boolean;
    }, isLastChild: boolean): void;
    selectRow(event: Event, treeItem?: VgTreeNode<any>): void;
    hideChildren(treeItem: VgTreeNode<any>): void;
    showChildren(treeItem: VgTreeNode<any>): void;
    expand(event: Event, treeItem: VgTreeNode<any>): void;
    checkParents(treeItem: VgTreeNode<any>, key: string): void;
    checkChildren(treeItem: VgTreeNode<any>, key: string, checked: boolean): void;
    check(event: Event, columnConfig: VgTreeTableColumnConfig, node: VgTreeNode<any>): void;
    checkAll(event: Event, columnConfig: VgTreeTableColumnConfig): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<VgLightTreeTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<VgLightTreeTableComponent, "vg-light-tree-table", never, { "treeTableConfig": "treeTableConfig"; "treeItems": "treeItems"; "treeMap": "treeMap"; "idKey": "idKey"; "parentIdKey": "parentIdKey"; "rootId": "rootId"; }, { "selectRowEvent": "selectRowEvent"; }, never, never>;
}
