(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('rxjs'), require('rxjs/operators'), require('@ng-bootstrap/ng-bootstrap'), require('@angular/platform-browser'), require('@angular/common/http'), require('@angular/animations'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('@angular/platform-browser/animations'), require('@angular/cdk/collections'), require('@angular/cdk/scrolling')) :
    typeof define === 'function' && define.amd ? define('ngx-vengeance-lib', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'rxjs', 'rxjs/operators', '@ng-bootstrap/ng-bootstrap', '@angular/platform-browser', '@angular/common/http', '@angular/animations', '@angular/cdk/portal', '@angular/cdk/overlay', '@angular/platform-browser/animations', '@angular/cdk/collections', '@angular/cdk/scrolling'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-vengeance-lib'] = {}, global.ng.core, global.ng.common, global.ng.forms, global.rxjs, global.rxjs.operators, global.i1$1, global.ng.platformBrowser, global.ng.common.http, global.ng.animations, global.ng.cdk.portal, global.ng.cdk.overlay, global.ng.platformBrowser.animations, global.ng.cdk.collections, global.ng.cdk.scrolling));
}(this, (function (exports, i0, i1, forms, rxjs, operators, i1$1, i1$2, i1$3, animations, portal, i1$4, animations$1, collections, i3) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i1__namespace$1 = /*#__PURE__*/_interopNamespace(i1$1);
    var i1__namespace$2 = /*#__PURE__*/_interopNamespace(i1$2);
    var i1__namespace$3 = /*#__PURE__*/_interopNamespace(i1$3);
    var i1__namespace$4 = /*#__PURE__*/_interopNamespace(i1$4);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);

    var VgDelayInputDirective = /** @class */ (function () {
        function VgDelayInputDirective() {
            this.delayTime = 1000;
            this.delayInput = new i0.EventEmitter();
            this.inputSubject = new rxjs.Subject();
        }
        VgDelayInputDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription = this.inputSubject
                .pipe(operators.debounceTime(this.delayTime))
                .subscribe(function (e) { return _this.delayInput.emit(e); });
        };
        VgDelayInputDirective.prototype.clickEvent = function (event) {
            event.preventDefault();
            event.stopPropagation();
            this.inputSubject.next(event);
        };
        VgDelayInputDirective.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        return VgDelayInputDirective;
    }());
    VgDelayInputDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDelayInputDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgDelayInputDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgDelayInputDirective, selector: "[vgDelayInput]", inputs: { delayTime: "delayTime" }, outputs: { delayInput: "delayInput" }, host: { listeners: { "input": "clickEvent($event)" } }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDelayInputDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgDelayInput]',
                    }]
            }], propDecorators: { delayTime: [{
                    type: i0.Input
                }], delayInput: [{
                    type: i0.Output
                }], clickEvent: [{
                    type: i0.HostListener,
                    args: ['input', ['$event']]
                }] } });

    var VgPipeWrapperPipe = /** @class */ (function () {
        function VgPipeWrapperPipe() {
        }
        // eslint-disable-next-line
        VgPipeWrapperPipe.prototype.transform = function (value) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var _a;
            // eslint-disable-next-line
            var convertFunc = (_a = args[0]) !== null && _a !== void 0 ? _a : (function (val) { return val; });
            return convertFunc(value);
        };
        return VgPipeWrapperPipe;
    }());
    VgPipeWrapperPipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeWrapperPipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    VgPipeWrapperPipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeWrapperPipe, name: "vgPipeWrapper", pure: false });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeWrapperPipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'vgPipeWrapper',
                        pure: false,
                    }]
            }] });

    var VgAutoInputComponent = /** @class */ (function () {
        function VgAutoInputComponent(inj) {
            this.inj = inj;
            this.text = '';
            // eslint-disable-next-line
            this.value = null;
            this.isFocused = false;
            // eslint-disable-next-line
            this.modelToTextMapper = function (obj) { return obj['name']; };
            // eslint-disable-next-line
            this.resultToModelMapper = function (obj) { return obj; };
            // eslint-disable-next-line
            this.modelToImgSrcMapper = function (obj) { return obj['url']; };
            this.size = 'md';
            this.isDisabled = false;
            this.isReadonly = false;
            // eslint-disable-next-line
            this.searchResults = [];
            this.limit = 10;
            this.placeholder = '';
            // eslint-disable-next-line
            this.itemTemplateCtx = null;
            this.changeTextEvent = new i0.EventEmitter();
            // eslint-disable-next-line
            this.changeValueEvent =
                // eslint-disable-next-line
                new i0.EventEmitter();
            this.status = 'VALID';
            // eslint-disable-next-line
            this.onChange = function (val) {
                console.debug(val);
            };
            this.onTouched = function () {
                console.debug();
            };
        }
        VgAutoInputComponent.prototype.ngOnInit = function () {
            this.ngControl = this.inj.get(forms.NgControl);
        };
        VgAutoInputComponent.prototype.ngAfterViewInit = function () {
            if (this.inputElement) {
                this.inputElement.nativeElement.classList.add("form-control-" + this.size);
            }
        };
        VgAutoInputComponent.prototype.ngOnChanges = function (changes) {
            if (changes.searchResults) {
                this.searchResults = this.searchResults.slice(0, this.limit - 1);
            }
        };
        // eslint-disable-next-line
        VgAutoInputComponent.prototype.selectResult = function (event, result) {
            this.value = this.resultToModelMapper(result);
            this.text = this.modelToTextMapper(result);
            this.inputElement.nativeElement.value = this.text;
            this.changeTextEvent.emit(this.text);
            this.changeValueEvent.emit(this.value);
            this.onChange(this.value);
            this.onTouched();
            this.isFocused = false;
        };
        VgAutoInputComponent.prototype.inputText = function (event) {
            if (this.isDisabled) {
                return;
            }
            if (!this.isFocused) {
                this.isFocused = true;
            }
            this.text = event.target.value;
            this.changeTextEvent.emit(this.text);
            this.onChange(null);
            this.onTouched();
        };
        VgAutoInputComponent.prototype.focus = function () {
            if (this.isDisabled) {
                return;
            }
            this.isFocused = true;
            this.inputElement.nativeElement.focus();
        };
        VgAutoInputComponent.prototype.blur = function () {
            if (this.isDisabled) {
                return;
            }
            this.isFocused = false;
        };
        VgAutoInputComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        VgAutoInputComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        VgAutoInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
        };
        // eslint-disable-next-line
        VgAutoInputComponent.prototype.writeValue = function (obj) {
            this.value = obj;
            this.text = this.modelToTextMapper(obj);
            this.changeValueEvent.emit(this.value);
        };
        return VgAutoInputComponent;
    }());
    VgAutoInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgAutoInputComponent, deps: [{ token: i0__namespace.Injector }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgAutoInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgAutoInputComponent, selector: "vg-auto-input", inputs: { modelToTextMapper: "modelToTextMapper", resultToModelMapper: "resultToModelMapper", modelToImgSrcMapper: "modelToImgSrcMapper", size: "size", isDisabled: "isDisabled", isReadonly: "isReadonly", searchResults: "searchResults", limit: "limit", placeholder: "placeholder", itemTemplateRef: "itemTemplateRef", itemTemplateCtx: "itemTemplateCtx" }, outputs: { changeTextEvent: "changeTextEvent", changeValueEvent: "changeValueEvent" }, providers: [
            {
                provide: forms.NG_VALUE_ACCESSOR,
                useExisting: i0.forwardRef(function () { return VgAutoInputComponent; }),
                multi: true,
            },
        ], viewQueries: [{ propertyName: "inputElement", first: true, predicate: ["inputElement"], descendants: true }], usesOnChanges: true, ngImport: i0__namespace, template: "<div class=\"autocomplete\" (focusin)=\"focus()\" (focusout)=\"blur()\">\n  <input\n    #inputElement\n    type=\"text\"\n    class=\"form-control\"\n    [class.ng-invalid]=\"ngControl['invalid']\"\n    [value]=\"text\"\n    [placeholder]=\"placeholder\"\n    [disabled]=\"isDisabled\"\n    [readOnly]=\"isReadonly\"\n    vgDelayInput\n    (delayInput)=\"inputText($event)\"\n  />\n  <ng-container\n    *ngIf=\"itemTemplateRef; then templateBlock; else noTemplateBlock\"\n  >\n  </ng-container>\n  <ng-template #templateBlock>\n    <div\n      class=\"autocomplete-items\"\n      *ngIf=\"itemTemplateRef; else noTemplateBlock\"\n      [hidden]=\"!isFocused\"\n    >\n      <div\n        *ngFor=\"let result of searchResults\"\n        [ngbTooltip]=\"result | vgPipeWrapper: modelToTextMapper\"\n        (mousedown)=\"$event.preventDefault()\"\n        (click)=\"selectResult($event, result)\"\n      >\n        <ng-container\n          [ngTemplateOutlet]=\"itemTemplateRef\"\n          [ngTemplateOutletContext]=\"{ item: result }\"\n        ></ng-container>\n      </div>\n    </div>\n  </ng-template>\n  <ng-template #noTemplateBlock>\n    <div\n      class=\"autocomplete-items\"\n      *ngIf=\"modelToImgSrcMapper; else noImageBlock\"\n      [hidden]=\"!isFocused\"\n    >\n      <div\n        *ngFor=\"let result of searchResults\"\n        [ngbTooltip]=\"result | vgPipeWrapper: modelToTextMapper\"\n        (mousedown)=\"$event.preventDefault()\"\n        (click)=\"selectResult($event, result)\"\n      >\n        <img\n          class=\"d-inline-block autocomplete-thumb\"\n          [src]=\"result | vgPipeWrapper: modelToImgSrcMapper\"\n          [alt]=\"result | vgPipeWrapper: modelToTextMapper\"\n        />\n        <small class=\"d-inline-block w-75 text-truncate pl-1\">{{\n          result | vgPipeWrapper: modelToTextMapper\n        }}</small>\n      </div>\n    </div>\n  </ng-template>\n  <ng-template #noImageBlock>\n    <div class=\"autocomplete-items\" [hidden]=\"!isFocused\">\n      <div\n        *ngFor=\"let result of searchResults\"\n        [ngbTooltip]=\"result | vgPipeWrapper: modelToTextMapper\"\n        (mousedown)=\"$event.preventDefault()\"\n        (click)=\"selectResult($event, result)\"\n      >\n        <small class=\"d-inline-block w-100 text-truncate pl-1\">{{\n          result | vgPipeWrapper: modelToTextMapper\n        }}</small>\n      </div>\n    </div>\n  </ng-template>\n</div>\n", styles: [":host{display:block}.autocomplete{position:relative;display:inline-block;width:100%;color:#000}.autocomplete-items{position:absolute;border:1px solid #d4d4d4;border-bottom:none;border-top:none;z-index:99;top:100%;left:0;right:0}.autocomplete-items>div{display:flex;align-items:center;padding:.5rem;cursor:pointer;background-color:#fff;border-bottom:1px solid #d4d4d4;box-sizing:content-box}.autocomplete-items.auto-with-thumb>div>img{width:25%}.autocomplete-items.auto-no-thumb>div>img{display:none}.autocomplete-items.auto-with-thumb>div>small{width:75%}.autocomplete-items.auto-no-thumb>div>small{width:100%}.autocomplete-items div:hover{background-color:#e9e9e9}.autocomplete-active{background-color:#1e90ff!important;color:#fff}.autocomplete-thumb{max-height:3rem;max-width:3rem}:host{--lh: 1.4rem;--max-lines: 3}.truncate-overflow{line-height:var(--lh);max-height:calc(var(--lh) * var(--max-lines));overflow:hidden}.truncate-overflow:before{content:\"...\";position:absolute;bottom:0;right:0}\n"], directives: [{ type: VgDelayInputDirective, selector: "[vgDelayInput]", inputs: ["delayTime"], outputs: ["delayInput"] }, { type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1__namespace$1.NgbTooltip, selector: "[ngbTooltip]", inputs: ["animation", "autoClose", "placement", "triggers", "container", "disableTooltip", "tooltipClass", "openDelay", "closeDelay", "ngbTooltip"], outputs: ["shown", "hidden"], exportAs: ["ngbTooltip"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "vgPipeWrapper": VgPipeWrapperPipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgAutoInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-auto-input',
                        templateUrl: './vg-auto-input.component.html',
                        styleUrls: ['./vg-auto-input.component.scss'],
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: i0.forwardRef(function () { return VgAutoInputComponent; }),
                                multi: true,
                            },
                        ],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }]; }, propDecorators: { modelToTextMapper: [{
                    type: i0.Input
                }], resultToModelMapper: [{
                    type: i0.Input
                }], modelToImgSrcMapper: [{
                    type: i0.Input
                }], size: [{
                    type: i0.Input
                }], isDisabled: [{
                    type: i0.Input
                }], isReadonly: [{
                    type: i0.Input
                }], searchResults: [{
                    type: i0.Input
                }], limit: [{
                    type: i0.Input
                }], placeholder: [{
                    type: i0.Input
                }], itemTemplateRef: [{
                    type: i0.Input
                }], itemTemplateCtx: [{
                    type: i0.Input
                }], changeTextEvent: [{
                    type: i0.Output
                }], changeValueEvent: [{
                    type: i0.Output
                }], inputElement: [{
                    type: i0.ViewChild,
                    args: ['inputElement']
                }] } });

    var VgErrorDictService = /** @class */ (function () {
        function VgErrorDictService() {
            this.messagePrefix = '';
        }
        VgErrorDictService.prototype.register = function (messagePrefix, 
        // eslint-disable-next-line
        service, translateFuncName) {
            this.messagePrefix = messagePrefix;
            this.translateService = service;
            this.translateFuncName = translateFuncName;
        };
        // eslint-disable-next-line
        VgErrorDictService.prototype.translate = function (key, label, argsObj) {
            return this.translateService[this.translateFuncName]("" + this.messagePrefix + key, Object.assign({ label: label }, argsObj));
        };
        return VgErrorDictService;
    }());
    VgErrorDictService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorDictService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    VgErrorDictService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorDictService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorDictService, decorators: [{
                type: i0.Injectable
            }] });

    var VgErrorMessagePipe = /** @class */ (function () {
        function VgErrorMessagePipe(vgErrorDictService) {
            this.vgErrorDictService = vgErrorDictService;
        }
        // eslint-disable-next-line
        VgErrorMessagePipe.prototype.transform = function (value) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return this.vgErrorDictService.translate(value, args[0], args[1]);
        };
        return VgErrorMessagePipe;
    }());
    VgErrorMessagePipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorMessagePipe, deps: [{ token: VgErrorDictService }], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    VgErrorMessagePipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorMessagePipe, name: "vgError", pure: false });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorMessagePipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'vgError',
                        pure: false,
                    }]
            }], ctorParameters: function () { return [{ type: VgErrorDictService }]; } });

    var VgErrorSectionComponent = /** @class */ (function () {
        function VgErrorSectionComponent() {
            this.label = 'Label';
        }
        VgErrorSectionComponent.prototype.ngOnInit = function () {
            if (!this.control) {
                this.control = this.group.get(this.controlName);
            }
        };
        return VgErrorSectionComponent;
    }());
    VgErrorSectionComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorSectionComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgErrorSectionComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgErrorSectionComponent, selector: "vg-error-section", inputs: { label: "label", group: "group", controlName: "controlName", control: "control" }, ngImport: i0__namespace, template: "<p *ngIf=\"control && control.touched && control.errors\">\n  <ng-container *ngIf=\"control.errors?.required; else notRequiredBlock\">\n    <ngb-alert [type]=\"'danger'\" [dismissible]=\"false\" [ngClass]=\"'mt-1'\">\n      <small>{{ \"required\" | vgError: label:control.errors.required }}</small>\n    </ngb-alert>\n  </ng-container>\n  <ng-template #notRequiredBlock>\n    <ngb-alert [type]=\"'danger'\" [dismissible]=\"false\" [ngClass]=\"'mt-1'\">\n      <small\n        *ngFor=\"let error of $any(control.errors) | keyvalue\"\n        class=\"d-block\"\n        >{{ $any(error.key) | vgError: label:$any(error.value) }}</small\n      >\n    </ngb-alert>\n  </ng-template>\n</p>\n", styles: [""], components: [{ type: i1__namespace$1.NgbAlert, selector: "ngb-alert", inputs: ["dismissible", "type", "animation"], outputs: ["closed"], exportAs: ["ngbAlert"] }], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "vgError": VgErrorMessagePipe, "keyvalue": i1__namespace.KeyValuePipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgErrorSectionComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-error-section',
                        templateUrl: './vg-error-section.component.html',
                        styleUrls: ['./vg-error-section.component.scss'],
                    }]
            }], propDecorators: { label: [{
                    type: i0.Input
                }], group: [{
                    type: i0.Input
                }], controlName: [{
                    type: i0.Input
                }], control: [{
                    type: i0.Input
                }] } });

    var VgFileUtil = /** @class */ (function () {
        function VgFileUtil() {
        }
        VgFileUtil.getFileType = function (file) {
            switch (file === null || file === void 0 ? void 0 : file.type) {
                case 'audio/mpeg':
                case 'audio/x-m4a':
                case 'audio/flag':
                case 'audio/wave':
                    return 'audio';
                case 'video/mp4':
                case 'video/x-matroska':
                    return 'video';
                case 'image/jpeg':
                case 'image/png':
                case 'image/gif':
                    return 'image';
                case 'application/msword':
                case 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':
                    return 'word';
                case 'application/vnd.ms-excel':
                case 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':
                    return 'excel';
                case 'application/pdf':
                    return 'pdf';
                case 'text/plain':
                    return 'text';
                case 'application/x-zip-compressed':
                case '':
                    return 'archive';
                case 'application/json':
                case 'text/xml':
                    return 'code';
                case 'application/x-msdownload':
                    return 'binary';
                default:
                    return 'generic';
            }
        };
        return VgFileUtil;
    }());

    var VgFileIconPipe = /** @class */ (function () {
        function VgFileIconPipe() {
        }
        VgFileIconPipe.prototype.transform = function (value) {
            var _a;
            return (_a = VgFileIconPipe.FILE_TYPE_ICON_MAP[value]) !== null && _a !== void 0 ? _a : '';
        };
        return VgFileIconPipe;
    }());
    VgFileIconPipe.FILE_TYPE_ICON_MAP = {
        audio: 'bi bi-file-earmark-music',
        video: 'bi bi-file-earmark-play',
        image: 'bi bi-file-earmark-image',
        pdf: 'bi bi-file-earmark-pdf',
        word: 'bi bi-file-earmark-word',
        excel: 'bi bi-file-earmark-spreadsheet',
        powerpoint: 'bi bi-file-earmark-ppt',
        text: 'bi bi-file-earmark-text',
        archive: 'bi bi-file-earmark-zip',
        code: 'bi bi-file-earmark-code',
        binary: 'bi bi-file-earmark-binary',
        generic: 'bi bi-file-earmark',
    };
    VgFileIconPipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFileIconPipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    VgFileIconPipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFileIconPipe, name: "vgFileIcon" });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFileIconPipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'vgFileIcon',
                    }]
            }] });

    var VgFileInputComponent = /** @class */ (function () {
        function VgFileInputComponent(inj, domSanitizer, http) {
            this.inj = inj;
            this.domSanitizer = domSanitizer;
            this.http = http;
            this.placeholder = 'Drop file here or click to browse a file';
            this.formData = new FormData();
            this.formDataFilePart = 'file';
            this.remoteFileType = 'generic';
            this.validateFn = function () { return true; };
            this.metadataLoadedEvent = new i0.EventEmitter();
            this.fileSelectedEvent = new i0.EventEmitter();
            this.isDisabled = false;
            this.isReadonly = false;
            this.fileType = 'generic';
            this.fileReader = new FileReader();
            // eslint-disable-next-line
            this.onChange = function (val) {
                console.debug(val);
            };
            this.onTouched = function () {
                console.debug();
            };
            this.remoteLoaded = true;
        }
        VgFileInputComponent.prototype.ngOnInit = function () {
            this.ngControl = this.inj.get(forms.NgControl);
            var initialFile = this.formData.get(this.formDataFilePart);
            if (initialFile) {
                this.processFile(initialFile);
            }
        };
        VgFileInputComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        VgFileInputComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        VgFileInputComponent.prototype.writeValue = function (obj) {
            var _this = this;
            this.remoteFileSrc = obj;
            if (!this.remoteFileSrc)
                return;
            this.http
                .get(this.remoteFileSrc, {
                observe: 'response',
                responseType: 'blob',
            })
                .subscribe(function (response) {
                var _a;
                var tmpFileType = (_a = response.body) === null || _a === void 0 ? void 0 : _a.type;
                if (tmpFileType !== 'application/octet-stream') {
                    _this.remoteFileType = VgFileUtil.getFileType(response.body);
                }
            }, function (error) {
                console.error("Error: " + error.message);
            });
        };
        VgFileInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
        };
        VgFileInputComponent.prototype.selectFile = function (event) {
            var _a;
            var target = event.target;
            if ((_a = target.files) === null || _a === void 0 ? void 0 : _a.length) {
                this.processFile(target.files[0]);
            }
        };
        VgFileInputComponent.prototype.onLoadedMetadata = function (event) {
            this.metadataLoadedEvent.emit(event);
        };
        VgFileInputComponent.prototype.dragover = function (event, dragZone) {
            event.preventDefault();
            dragZone.classList.add('file-dragover');
        };
        VgFileInputComponent.prototype.dragend = function (event, dragZone) {
            event.preventDefault();
            dragZone.classList.remove('file-dragover');
        };
        VgFileInputComponent.prototype.drop = function (event, dragZone) {
            var _a, _b;
            event.preventDefault();
            dragZone.classList.remove('file-dragover');
            if ((_b = (_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.files) === null || _b === void 0 ? void 0 : _b.length) {
                this.processFile(event.dataTransfer.files[0]);
            }
        };
        VgFileInputComponent.prototype.processFile = function (file) {
            var _this = this;
            if (this.isDisabled) {
                return;
            }
            var isValid = this.validateFn(file);
            if (!isValid)
                return;
            this.file = file;
            console.debug(file.type, typeof file.type, file.type === '');
            this.fileType = VgFileUtil.getFileType(this.file);
            if (this.fileType === 'audio' || this.fileType === 'video') {
                var url = URL.createObjectURL(this.file);
                this.fileSrc = this.domSanitizer.bypassSecurityTrustResourceUrl(url);
            }
            else {
                this.fileReader.readAsDataURL(this.file);
                this.fileReader.onload = function (event) {
                    var _a;
                    _this.fileSrc = (_a = event.target) === null || _a === void 0 ? void 0 : _a.result;
                };
            }
            this.onTouched();
            this.formData.set(this.formDataFilePart, this.file);
            this.fileSelectedEvent.emit(file);
        };
        VgFileInputComponent.prototype.clearFile = function (event) {
            var _a;
            event.stopPropagation();
            this.file = null;
            this.fileType = 'generic';
            this.fileSrc = null;
            this.onChange((_a = this.remoteFileSrc) !== null && _a !== void 0 ? _a : null);
            this.onTouched();
            this.formData.delete(this.formDataFilePart);
        };
        VgFileInputComponent.prototype.resolveRemote = function (value) {
            this.remoteLoaded = value;
        };
        VgFileInputComponent.prototype.browseFile = function (fileInput) {
            if (this.isDisabled || this.isReadonly)
                return;
            fileInput.click();
        };
        VgFileInputComponent.prototype.onErrorLoad = function () {
            this.remoteFileSrc = null;
        };
        return VgFileInputComponent;
    }());
    VgFileInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFileInputComponent, deps: [{ token: i0__namespace.Injector }, { token: i1__namespace$2.DomSanitizer }, { token: i1__namespace$3.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgFileInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgFileInputComponent, selector: "vg-file-input", inputs: { placeholder: "placeholder", formData: "formData", formDataFilePart: "formDataFilePart", remoteFileType: "remoteFileType", validateFn: "validateFn", isDisabled: "isDisabled", isReadonly: "isReadonly" }, outputs: { metadataLoadedEvent: "metadataLoadedEvent", fileSelectedEvent: "fileSelectedEvent" }, providers: [
            {
                provide: forms.NG_VALUE_ACCESSOR,
                useExisting: i0.forwardRef(function () { return VgFileInputComponent; }),
                multi: true,
            },
        ], ngImport: i0__namespace, template: "<div class=\"form-group\">\n  <div\n    #dragZone\n    class=\"\n      file-drag-zone\n      d-flex\n      justify-content-center\n      align-items-center\n      flex-wrap\n    \"\n    draggable=\"true\"\n    [class.file-drag-zone-disabled]=\"isDisabled || isReadonly\"\n    (dragover)=\"dragover($event, dragZone)\"\n    (dragend)=\"dragend($event, dragZone)\"\n    (dragleave)=\"dragend($event, dragZone)\"\n    (dragexit)=\"dragend($event, dragZone)\"\n    (drop)=\"drop($event, dragZone)\"\n    (click)=\"browseFile(fileInput)\"\n  >\n    <i\n      *ngIf=\"file\"\n      class=\"bi bi-x-square-fill file-clear\"\n      (click)=\"clearFile($event)\"\n    ></i>\n    <ng-container\n      *ngIf=\"file; then hasFileBlock; else emptyFileBlock\"\n    ></ng-container>\n    <ng-template #hasFileBlock>\n      <ng-container\n        [ngTemplateOutlet]=\"filePreview\"\n        [ngTemplateOutletContext]=\"{\n          fileType: fileType,\n          fileSrc: fileSrc,\n          filePlaceholder: file?.name\n        }\"\n      ></ng-container>\n    </ng-template>\n    <ng-template #emptyFileBlock>\n      <ng-container\n        [ngTemplateOutlet]=\"filePreview\"\n        [ngTemplateOutletContext]=\"{\n          fileType: remoteFileType,\n          fileSrc: remoteFileSrc,\n          filePlaceholder: placeholder\n        }\"\n      >\n      </ng-container>\n    </ng-template>\n  </div>\n  <input\n    #fileInput\n    type=\"file\"\n    class=\"custom-file-input d-none\"\n    id=\"file\"\n    (change)=\"selectFile($event)\"\n  />\n</div>\n<ng-template\n  #filePreview\n  let-dropZonePlaceholder=\"filePlaceholder\"\n  let-src=\"fileSrc\"\n  let-type=\"fileType\"\n>\n  <div class=\"file-drag-zone-placeholder\" [hidden]=\"isDisabled\">\n    <span>{{ dropZonePlaceholder }}</span>\n  </div>\n  <ng-container [ngSwitch]=\"type\">\n    <ng-template ngSwitchCase=\"image\">\n      <div class=\"file-preview\">\n        <img\n          *ngIf=\"src; else fallbackIconImage\"\n          class=\"file-preview-image\"\n          [src]=\"src\"\n          alt=\"imagePreview\"\n          (loadedmetadata)=\"onLoadedMetadata($event)\"\n          (error)=\"onErrorLoad()\"\n        />\n        <ng-template #fallbackIconImage>\n          <i [className]=\"type | vgFileIcon\"></i>\n        </ng-template>\n      </div>\n    </ng-template>\n    <ng-template ngSwitchCase=\"audio\">\n      <div class=\"w-100\" *ngIf=\"src\" [hidden]=\"isDisabled\"></div>\n      <div class=\"file-preview-large\">\n        <audio\n          *ngIf=\"src; else fallbackIconAudio\"\n          class=\"file-preview-audio\"\n          [src]=\"src\"\n          (loadedmetadata)=\"onLoadedMetadata($event)\"\n          (error)=\"onErrorLoad()\"\n          controls\n        ></audio>\n        <ng-template #fallbackIconAudio>\n          <i [className]=\"type | vgFileIcon\"></i>\n        </ng-template>\n      </div>\n    </ng-template>\n    <ng-template ngSwitchCase=\"video\">\n      <div class=\"w-100\" *ngIf=\"src\" [hidden]=\"isDisabled\"></div>\n      <div class=\"file-preview-large\">\n        <video\n          *ngIf=\"src; else fallbackIconVideo\"\n          class=\"file-preview-video\"\n          [src]=\"src\"\n          (loadedmetadata)=\"onLoadedMetadata($event)\"\n          (error)=\"onErrorLoad()\"\n          controls\n        ></video>\n        <ng-template #fallbackIconVideo>\n          <i [className]=\"type | vgFileIcon\"></i>\n        </ng-template>\n      </div>\n    </ng-template>\n    <ng-template ngSwitchDefault>\n      <div class=\"file-preview\">\n        <i [className]=\"type | vgFileIcon\"></i>\n      </div>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: [".file-drag-zone{margin-top:1rem;border:1px solid black;min-width:80%;height:auto;min-height:5rem;position:relative}.file-drag-zone .file-drag-zone-placeholder{color:#1e90ff}.file-drag-zone:hover{cursor:pointer}.file-drag-zone-disabled,.file-drag-zone-disabled>*{background-color:#cdcdcd}.file-drag-zone-disabled:hover,.file-drag-zone-disabled>*:hover{cursor:auto}.file-dragover{border:2px dashed black}.file-clear{display:block;position:absolute;top:-.125em;right:0;font-size:1.2rem}.file-preview{display:flex;justify-content:center;align-items:center;width:50px;height:50px}.file-preview i{font-size:1.5rem}.file-preview .file-preview-image{height:100%;width:100%}.file-preview-large{display:block}.file-preview-large i{font-size:1.5rem}.file-preview-large .file-preview-audio{min-width:20rem;min-height:2rem;width:auto;height:auto;max-width:25rem;max-height:2.5rem}.file-preview-large .file-preview-video{min-width:25rem;min-height:10rem;width:auto;height:auto;max-width:30rem;max-height:12rem}.file-placeholder{display:flex;justify-content:center;align-items:center;width:80%;height:100%}\n"], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1__namespace.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "vgFileIcon": VgFileIconPipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFileInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-file-input',
                        templateUrl: './vg-file-input.component.html',
                        styleUrls: ['./vg-file-input.component.scss'],
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: i0.forwardRef(function () { return VgFileInputComponent; }),
                                multi: true,
                            },
                        ],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }, { type: i1__namespace$2.DomSanitizer }, { type: i1__namespace$3.HttpClient }]; }, propDecorators: { placeholder: [{
                    type: i0.Input
                }], formData: [{
                    type: i0.Input
                }], formDataFilePart: [{
                    type: i0.Input
                }], remoteFileType: [{
                    type: i0.Input
                }], validateFn: [{
                    type: i0.Input
                }], metadataLoadedEvent: [{
                    type: i0.Output
                }], fileSelectedEvent: [{
                    type: i0.Output
                }], isDisabled: [{
                    type: i0.Input
                }], isReadonly: [{
                    type: i0.Input
                }] } });

    var VgTagInputComponent = /** @class */ (function () {
        function VgTagInputComponent(inj) {
            this.inj = inj;
            // eslint-disable-next-line
            this.values = [];
            this.text = '';
            // eslint-disable-next-line
            this.onChange = function (val) {
                console.debug(val);
            };
            this.onTouched = function () {
                console.debug();
            };
            this.isReadonly = false;
            this.size = 'md';
            // eslint-disable-next-line
            this.modelToTextConverter = function (model) { return model.name; };
            // eslint-disable-next-line
            this.textToModelConverter = function (text) {
                return {
                    name: text,
                };
            };
        }
        VgTagInputComponent.prototype.ngOnInit = function () {
            this.ngControl = this.inj.get(forms.NgControl);
        };
        VgTagInputComponent.prototype.ngAfterViewInit = function () {
            if (this.inputElement) {
                this.inputElement.nativeElement.classList.add("form-control-" + this.size);
            }
        };
        // eslint-disable-next-line
        VgTagInputComponent.prototype.writeValue = function (tagList) {
            var _this = this;
            this.values = tagList;
            this.text = Array.from(new Set(this.values.map(function (e) { return _this.modelToTextConverter(e); }))).join(',');
        };
        VgTagInputComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        VgTagInputComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        VgTagInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.isDisabled = isDisabled;
        };
        VgTagInputComponent.prototype.inputText = function (event) {
            var _this = this;
            var target = event.target;
            this.values = target.value
                .split(',')
                .map(function (e) { return e.trim(); })
                .filter(function (e) { return e !== ''; })
                .map(function (e) { return _this.textToModelConverter(e); });
            this.onChange(this.values);
            this.onTouched();
        };
        return VgTagInputComponent;
    }());
    VgTagInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTagInputComponent, deps: [{ token: i0__namespace.Injector }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgTagInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgTagInputComponent, selector: "vg-tag-input", inputs: { placeholder: "placeholder", isDisabled: "isDisabled", isReadonly: "isReadonly", size: "size", modelToTextConverter: "modelToTextConverter", textToModelConverter: "textToModelConverter" }, providers: [
            {
                provide: forms.NG_VALUE_ACCESSOR,
                useExisting: i0.forwardRef(function () { return VgTagInputComponent; }),
                multi: true,
            },
        ], viewQueries: [{ propertyName: "inputElement", first: true, predicate: ["inputElement"], descendants: true }], ngImport: i0__namespace, template: "<input\n  #inputElement\n  type=\"text\"\n  class=\"form-control\"\n  [class.ng-invalid]=\"ngControl['invalid']\"\n  [value]=\"text\"\n  [placeholder]=\"placeholder\"\n  [disabled]=\"isDisabled\"\n  [readOnly]=\"isReadonly\"\n  vgDelayInput\n  (delayInput)=\"inputText($event)\"\n/>\n", styles: [""], directives: [{ type: VgDelayInputDirective, selector: "[vgDelayInput]", inputs: ["delayTime"], outputs: ["delayInput"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTagInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-tag-input',
                        templateUrl: './vg-tag-input.component.html',
                        styleUrls: ['./vg-tag-input.component.scss'],
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: i0.forwardRef(function () { return VgTagInputComponent; }),
                                multi: true,
                            },
                        ],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }]; }, propDecorators: { placeholder: [{
                    type: i0.Input
                }], isDisabled: [{
                    type: i0.Input
                }], isReadonly: [{
                    type: i0.Input
                }], size: [{
                    type: i0.Input
                }], modelToTextConverter: [{
                    type: i0.Input
                }], textToModelConverter: [{
                    type: i0.Input
                }], inputElement: [{
                    type: i0.ViewChild,
                    args: ['inputElement']
                }] } });

    var VgControlModule = /** @class */ (function () {
        function VgControlModule() {
        }
        VgControlModule.forRoot = function (loader) {
            return {
                ngModule: VgControlModule,
                providers: [loader],
            };
        };
        return VgControlModule;
    }());
    VgControlModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgControlModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgControlModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgControlModule, declarations: [VgAutoInputComponent,
            VgErrorSectionComponent,
            VgErrorMessagePipe,
            VgDelayInputDirective,
            VgFileInputComponent,
            VgFileIconPipe,
            VgPipeWrapperPipe,
            VgTagInputComponent], imports: [i1.CommonModule, i1$1.NgbTooltipModule, i1$1.NgbAlertModule], exports: [VgAutoInputComponent,
            VgFileInputComponent,
            VgErrorSectionComponent,
            VgErrorMessagePipe,
            VgDelayInputDirective,
            VgTagInputComponent] });
    VgControlModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgControlModule, providers: [VgErrorDictService], imports: [[i1.CommonModule, i1$1.NgbTooltipModule, i1$1.NgbAlertModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgControlModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            VgAutoInputComponent,
                            VgErrorSectionComponent,
                            VgErrorMessagePipe,
                            VgDelayInputDirective,
                            VgFileInputComponent,
                            VgFileIconPipe,
                            VgPipeWrapperPipe,
                            VgTagInputComponent,
                        ],
                        imports: [i1.CommonModule, i1$1.NgbTooltipModule, i1$1.NgbAlertModule],
                        exports: [
                            VgAutoInputComponent,
                            VgFileInputComponent,
                            VgErrorSectionComponent,
                            VgErrorMessagePipe,
                            VgDelayInputDirective,
                            VgTagInputComponent,
                        ],
                        providers: [VgErrorDictService],
                    }]
            }] });

    var VgTreeTableBlockConfigPipe = /** @class */ (function () {
        function VgTreeTableBlockConfigPipe() {
        }
        // eslint-disable-next-line
        VgTreeTableBlockConfigPipe.prototype.transform = function (value) {
            var _a;
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return Object.assign(Object.assign({}, value), (_a = {}, _a[args[0]] = args[1] < args[2], _a));
        };
        return VgTreeTableBlockConfigPipe;
    }());
    VgTreeTableBlockConfigPipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableBlockConfigPipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    VgTreeTableBlockConfigPipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableBlockConfigPipe, name: "vgTreeTableBlock", pure: false });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableBlockConfigPipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'vgTreeTableBlock',
                        pure: false,
                    }]
            }] });

    var VgTreeTableItemComponent = /** @class */ (function () {
        function VgTreeTableItemComponent(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
            this.checkEvent = new i0.EventEmitter();
            // eslint-disable-next-line
            this.selectRowEvent = new i0.EventEmitter();
        }
        VgTreeTableItemComponent.prototype.ngOnInit = function () {
            this.viewContainerRef.createEmbeddedView(this.template);
        };
        VgTreeTableItemComponent.prototype.expand = function (event, treeItem) {
            event.stopPropagation();
            treeItem.expanded = !treeItem.expanded;
        };
        VgTreeTableItemComponent.prototype.check = function (event, key, config) {
            var _this = this;
            var _a;
            event.stopPropagation();
            var checked = (_a = event.target) === null || _a === void 0 ? void 0 : _a.checked;
            this.treeItem.data[key] = checked;
            if (config === null || config === void 0 ? void 0 : config.checkboxHorizontalCascade) {
                config.checkboxHorizontalCascade.forEach(function (cascade) {
                    if (checked) {
                        _this.treeItem.data[cascade.key] = true;
                        _this.treeItem.isDisabled[cascade.key] = true;
                    }
                    else {
                        _this.treeItem.isDisabled[cascade.key] = false;
                    }
                    _this.checkEvent.emit({
                        key: cascade.key,
                        checked: _this.treeItem.data[cascade.key],
                        node: _this.treeItem,
                    });
                });
            }
            this.checkEvent.emit({
                key: key,
                checked: checked,
                node: this.treeItem,
            });
        };
        VgTreeTableItemComponent.prototype.forwardCheck = function (event) {
            var config = this.treeTableConfig.columns.find(function (columnConfig) { return columnConfig.key === event.key; });
            if (config === null || config === void 0 ? void 0 : config.checkboxVerticalCascade) {
                this.treeItem.data[event.key] = this.treeItem.children.every(function (childNode) { return childNode.data[event.key]; });
            }
            this.checkEvent.emit(event);
        };
        VgTreeTableItemComponent.prototype.selectRow = function (node) {
            this.selectRowEvent.emit(node);
        };
        VgTreeTableItemComponent.prototype.forwardSelectRow = function (node) {
            this.selectRowEvent.emit(node);
        };
        return VgTreeTableItemComponent;
    }());
    VgTreeTableItemComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableItemComponent, deps: [{ token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgTreeTableItemComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgTreeTableItemComponent, selector: "vg-tree-table-item", inputs: { treeTableConfig: "treeTableConfig", treeItem: "treeItem", paddingBlockConfig: "paddingBlockConfig" }, outputs: { checkEvent: "checkEvent", selectRowEvent: "selectRowEvent" }, viewQueries: [{ propertyName: "template", first: true, predicate: ["template"], descendants: true, static: true }], ngImport: i0__namespace, template: "<ng-template #template>\n  <tr (click)=\"selectRow(treeItem)\" tabindex=\"0\" (blur)=\"selectRow(null)\">\n    <td class=\"m-0\">\n      <span\n        *ngFor=\"\n          let metadata of paddingBlockConfig | keyvalue;\n          index as i;\n          count as size\n        \"\n        class=\"tree-table-space-block\"\n        [class.y-line]=\"metadata.value\"\n        [class.last-block]=\"i === size - 1\"\n      ></span>\n      <span\n        *ngIf=\"treeItem.children.length; else emptyBtn\"\n        (click)=\"expand($event, treeItem)\"\n        class=\"tree-table-space-block btn-toggle font-weight-bold\"\n      >\n        {{ treeItem.expanded ? \"-\" : \"+\" }}\n      </span>\n      <ng-template #emptyBtn>\n        <span class=\"tree-table-space-block btn-toggle\"></span>\n      </ng-template>\n    </td>\n    <td *ngFor=\"let columnConfig of treeTableConfig.columns\">\n      <div\n        [ngSwitch]=\"columnConfig.type\"\n        [className]=\"columnConfig.customClass ?? ''\"\n      >\n        <ng-container *ngSwitchCase=\"'CUSTOM'\">\n          <div\n            [ngTemplateOutlet]=\"columnConfig.templateRef ?? null\"\n            [ngTemplateOutletContext]=\"$any(treeItem.data) ?? null\"\n          ></div>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'CHECKBOX'\">\n          <label class=\"container\">\n            <input\n              type=\"checkbox\"\n              [disabled]=\"\n                treeItem.isDisabled\n                  ? treeItem.isDisabled[columnConfig.key]\n                  : false\n              \"\n              [checked]=\"$any(treeItem?.data)[columnConfig.key]\"\n              (change)=\"check($event, columnConfig.key, columnConfig)\"\n            />\n            <span class=\"checkmark\"></span>\n          </label>\n        </ng-container>\n        <ng-container *ngSwitchDefault>\n          <span>{{ $any(treeItem?.data)[columnConfig.key] }}</span>\n        </ng-container>\n      </div>\n    </td>\n  </tr>\n  <ng-container *ngIf=\"treeItem.expanded\">\n    <vg-tree-table-item\n      *ngFor=\"let item of treeItem.children; index as i\"\n      [treeTableConfig]=\"treeTableConfig\"\n      [treeItem]=\"item\"\n      [paddingBlockConfig]=\"\n        paddingBlockConfig\n          | vgTreeTableBlock: item.level:i:treeItem.children.length - 1\n      \"\n      (selectRowEvent)=\"forwardSelectRow($event)\"\n      (checkEvent)=\"forwardCheck($event)\"\n    >\n    </vg-tree-table-item>\n  </ng-container>\n</ng-template>\n", styles: ["tr:hover,tr:focus{cursor:pointer;background:darkgrey}.tree-table-space-block{border:3px solid transparent;display:inline-block;width:30px;height:20px;line-height:16px;text-align:center;vertical-align:top;position:relative;box-sizing:border-box;border-radius:50%}.tree-table-space-block.y-line:before{position:absolute;content:\"\";width:3px;height:45px;background:#d9d9d9;left:50%;top:-40px}.tree-table-space-block.last-block:before{position:absolute;content:\"\";width:3px;height:45px;background:#d9d9d9;left:50%;top:-40px}.tree-table-space-block.last-block:after{position:absolute;content:\"\";width:30px;height:3px;background:#d9d9d9;top:50%;margin-top:-1px}.tree-table-space-block.btn-toggle{border:3px solid #d9d9d9;position:relative;cursor:pointer;width:22px;height:22px;line-height:14px;z-index:1;background:white;left:6px;font-size:1.3rem}.tree-table-space-block.btn-toggle.first-child:before{display:none}.tree-table-space-block.btn-toggle:after{display:none}.tree-table-space-block.is-first-row:before{display:none!important}.container{display:block;position:relative;padding-left:35px;margin-bottom:12px;cursor:pointer;font-size:22px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}.checkmark{position:absolute;border-radius:3px;top:0;height:1.2rem;width:1.2rem;background-color:#eee}.container:hover input~.checkmark{background-color:#ccc}.container input:checked~.checkmark{background-color:#2196f3}.checkmark:after{content:\"\";position:absolute;display:none}.container input:checked~.checkmark:after{display:block}.container .checkmark:after{left:.5rem;top:.2rem;width:5px;height:10px;border:solid white;border-width:0 3px 3px 0;transform:rotate(45deg)}\n"], components: [{ type: VgTreeTableItemComponent, selector: "vg-tree-table-item", inputs: ["treeTableConfig", "treeItem", "paddingBlockConfig"], outputs: ["checkEvent", "selectRowEvent"] }], directives: [{ type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1__namespace.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "keyvalue": i1__namespace.KeyValuePipe, "vgTreeTableBlock": VgTreeTableBlockConfigPipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableItemComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-tree-table-item',
                        templateUrl: './vg-tree-table-item.component.html',
                        styleUrls: ['./vg-tree-table-item.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ViewContainerRef }]; }, propDecorators: { treeTableConfig: [{
                    type: i0.Input
                }], treeItem: [{
                    type: i0.Input
                }], paddingBlockConfig: [{
                    type: i0.Input
                }], checkEvent: [{
                    type: i0.Output
                }], selectRowEvent: [{
                    type: i0.Output
                }], template: [{
                    type: i0.ViewChild,
                    args: ['template', { static: true }]
                }] } });

    var VgTreeTableComponent = /** @class */ (function () {
        function VgTreeTableComponent() {
            this.treeItems = [];
            this.checkNodeEvent = new i0.EventEmitter();
            this.selectRowEvent = new i0.EventEmitter();
        }
        VgTreeTableComponent.prototype.ngOnInit = function () {
            console.debug(this.treeItems);
        };
        VgTreeTableComponent.prototype.check = function (event) {
            this.checkNodeEvent.emit(event);
        };
        VgTreeTableComponent.prototype.selectRow = function (node) {
            this.selectedNode = node;
            this.selectRowEvent.emit(node);
        };
        return VgTreeTableComponent;
    }());
    VgTreeTableComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgTreeTableComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgTreeTableComponent, selector: "vg-tree-table", inputs: { treeTableConfig: "treeTableConfig", treeItems: "treeItems" }, outputs: { checkNodeEvent: "checkNodeEvent", selectRowEvent: "selectRowEvent" }, ngImport: i0__namespace, template: "<table class=\"table table-bordered table-responsive-md\">\n  <thead>\n    <tr>\n      <td></td>\n      <td\n        *ngFor=\"let columnConfig of treeTableConfig.columns\"\n        class=\"text-center font-weight-bold\"\n      >\n        {{ columnConfig.title }}\n      </td>\n    </tr>\n  </thead>\n  <tbody>\n    <vg-tree-table-item\n      *ngFor=\"let treeItem of treeItems; index as i\"\n      [treeTableConfig]=\"treeTableConfig\"\n      [paddingBlockConfig]=\"\n        {} | vgTreeTableBlock: treeItem.level:i:treeItems.length - 1\n      \"\n      [treeItem]=\"treeItem\"\n      (selectRowEvent)=\"selectRow($event)\"\n      (checkEvent)=\"check($event)\"\n    >\n    </vg-tree-table-item>\n  </tbody>\n</table>\n", styles: [":host ::ng-deep tbody tr:nth-child(2) td:first-child span:first-child.tree-table-space-block:before{display:none!important}\n"], components: [{ type: VgTreeTableItemComponent, selector: "vg-tree-table-item", inputs: ["treeTableConfig", "treeItem", "paddingBlockConfig"], outputs: ["checkEvent", "selectRowEvent"] }], directives: [{ type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], pipes: { "vgTreeTableBlock": VgTreeTableBlockConfigPipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-tree-table',
                        templateUrl: './vg-tree-table.component.html',
                        styleUrls: ['./vg-tree-table.component.scss'],
                    }]
            }], propDecorators: { treeTableConfig: [{
                    type: i0.Input
                }], treeItems: [{
                    type: i0.Input
                }], checkNodeEvent: [{
                    type: i0.Output
                }], selectRowEvent: [{
                    type: i0.Output
                }] } });

    var VgHoverClassDirective = /** @class */ (function () {
        function VgHoverClassDirective(elementRef) {
            this.elementRef = elementRef;
            this.hoverClass = '';
        }
        VgHoverClassDirective.prototype.onMouseEnter = function () {
            if (this.focusedElement) {
                return;
            }
            this.elementRef.nativeElement.classList.add(this.hoverClass);
        };
        VgHoverClassDirective.prototype.onMouseLeave = function () {
            if (this.focusedElement) {
                return;
            }
            this.elementRef.nativeElement.classList.remove(this.hoverClass);
        };
        VgHoverClassDirective.prototype.onFocus = function () {
            this.elementRef.nativeElement.classList.add(this.hoverClass);
            this.focusedElement = this.elementRef;
        };
        VgHoverClassDirective.prototype.onBlur = function () {
            this.elementRef.nativeElement.classList.remove(this.hoverClass);
            this.focusedElement = null;
        };
        return VgHoverClassDirective;
    }());
    VgHoverClassDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHoverClassDirective, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgHoverClassDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgHoverClassDirective, selector: "[vgHoverClass]", inputs: { hoverClass: "hoverClass" }, host: { listeners: { "mouseenter": "onMouseEnter()", "mouseleave": "onMouseLeave()", "focus": "onFocus()", "blur": "onBlur()" } }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHoverClassDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgHoverClass]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { hoverClass: [{
                    type: i0.Input
                }], onMouseEnter: [{
                    type: i0.HostListener,
                    args: ['mouseenter']
                }], onMouseLeave: [{
                    type: i0.HostListener,
                    args: ['mouseleave']
                }], onFocus: [{
                    type: i0.HostListener,
                    args: ['focus']
                }], onBlur: [{
                    type: i0.HostListener,
                    args: ['blur']
                }] } });

    var VgTreeLevelArrayPipePipe = /** @class */ (function () {
        function VgTreeLevelArrayPipePipe() {
        }
        // eslint-disable-next-line
        VgTreeLevelArrayPipePipe.prototype.transform = function (value) {
            return new Array(value + 1);
        };
        return VgTreeLevelArrayPipePipe;
    }());
    VgTreeLevelArrayPipePipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeLevelArrayPipePipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    VgTreeLevelArrayPipePipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeLevelArrayPipePipe, name: "vgTreeLevel", pure: false });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeLevelArrayPipePipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'vgTreeLevel',
                        pure: false,
                    }]
            }] });

    var VgLightTreeTableComponent = /** @class */ (function () {
        function VgLightTreeTableComponent() {
            this.treeTableConfig = {
                columns: [],
            };
            // eslint-disable-next-line
            this.treeItems = [];
            this.idKey = 'id';
            this.parentIdKey = 'parent_id';
            this.rootId = 'root';
            // eslint-disable-next-line
            this.selectRowEvent =
                // eslint-disable-next-line
                new i0.EventEmitter();
            // eslint-disable-next-line
            this.sortedNodeList = [];
            // eslint-disable-next-line
            this.internalTreeMap = {};
            this.useInternalTreeMap = false;
        }
        VgLightTreeTableComponent.prototype.ngOnChanges = function (changes) {
            var _b;
            var _this = this;
            if (changes.treeItems) {
                this.useInternalTreeMap = !this.treeMap;
                if (!this.useInternalTreeMap) {
                    this.internalTreeMap = this.treeMap;
                }
                // eslint-disable-next-line
                var nodeList_1 = [];
                var seqObj_1 = { sequence: 0 };
                var initialPaddingBlock_1 = (_b = {}, _b[0] = true, _b);
                // eslint-disable-next-line
                var rootNode_1 = {
                    data: { id: this.rootId, parentId: null },
                    children: [],
                    level: -1,
                    isDisabled: {},
                    isFixed: {},
                    sequence: -1,
                    paddingBlock: {},
                };
                this.treeItems.forEach(function (node, i) {
                    if (node.data[_this.parentIdKey] !== _this.rootId) {
                        node.data[_this.parentIdKey] = _this.rootId;
                    }
                    rootNode_1.children.push(node);
                    _this.processTreeSequenceAndLevel(node, nodeList_1, seqObj_1, 0, Object.assign({}, initialPaddingBlock_1), i === _this.treeItems.length - 1);
                });
                if (this.useInternalTreeMap) {
                    this.internalTreeMap[this.rootId] = rootNode_1;
                }
                nodeList_1.sort(function (a, b) { return a.sequence - b.sequence; });
                this.sortedNodeList = nodeList_1;
            }
        };
        VgLightTreeTableComponent.prototype.processTreeSequenceAndLevel = function (
        // eslint-disable-next-line
        node, 
        // eslint-disable-next-line
        nodeList, seqObj, level, paddingBlock, isLastChild) {
            var _this = this;
            seqObj.sequence++;
            node.sequence = seqObj.sequence;
            node.level = level;
            node.paddingBlock = paddingBlock;
            nodeList.push(node);
            if (this.useInternalTreeMap) {
                this.internalTreeMap[node.data[this.idKey]] = node;
            }
            node.children.forEach(function (childNode, i) {
                var _b;
                _this.processTreeSequenceAndLevel(childNode, nodeList, seqObj, level + 1, Object.assign(Object.assign({}, node.paddingBlock), (_b = {}, _b[node.level] = !isLastChild, _b)), i === node.children.length - 1);
            });
        };
        // eslint-disable-next-line
        VgLightTreeTableComponent.prototype.selectRow = function (event, treeItem) {
            event.stopPropagation();
            this.selectedNode = treeItem;
            this.selectRowEvent.emit(this.selectedNode);
        };
        // eslint-disable-next-line
        VgLightTreeTableComponent.prototype.hideChildren = function (treeItem) {
            var _this = this;
            treeItem.hidden = true;
            treeItem.children.forEach(function (childNode) {
                _this.hideChildren(childNode);
            });
        };
        // eslint-disable-next-line
        VgLightTreeTableComponent.prototype.showChildren = function (treeItem) {
            var _this = this;
            treeItem.hidden = false;
            if (treeItem.expanded) {
                treeItem.children.forEach(function (childNode) {
                    _this.showChildren(childNode);
                });
            }
            else {
                treeItem.children.forEach(function (childNode) {
                    _this.hideChildren(childNode);
                });
            }
        };
        // eslint-disable-next-line
        VgLightTreeTableComponent.prototype.expand = function (event, treeItem) {
            var _this = this;
            event.stopPropagation();
            var expanded = !treeItem.expanded;
            treeItem.expanded = expanded;
            if (expanded) {
                treeItem.children.forEach(function (childNode) {
                    _this.showChildren(childNode);
                });
            }
            else {
                treeItem.children.forEach(function (childNode) {
                    _this.hideChildren(childNode);
                });
            }
        };
        // eslint-disable-next-line
        VgLightTreeTableComponent.prototype.checkParents = function (treeItem, key) {
            // eslint-disable-next-line
            var parentNode = this.internalTreeMap[treeItem.data[this.parentIdKey]];
            if (parentNode) {
                parentNode.data[key] = parentNode.children.every(function (childNode) { return childNode.data[key]; });
                this.checkParents(parentNode, key);
            }
        };
        VgLightTreeTableComponent.prototype.checkChildren = function (
        // eslint-disable-next-line
        treeItem, key, checked) {
            var _this = this;
            treeItem.data[key] = checked;
            treeItem.children.forEach(function (childNode) {
                _this.checkChildren(childNode, key, checked);
            });
        };
        VgLightTreeTableComponent.prototype.check = function (event, columnConfig, 
        // eslint-disable-next-line
        node) {
            var _a;
            event.stopPropagation();
            var checked = (_a = event.target) === null || _a === void 0 ? void 0 : _a.checked;
            node.data[columnConfig.key] = checked;
            if (columnConfig === null || columnConfig === void 0 ? void 0 : columnConfig.checkboxVerticalCascade) {
                this.checkChildren(node, columnConfig.key, checked);
                this.checkParents(node, columnConfig.key);
            }
        };
        VgLightTreeTableComponent.prototype.checkAll = function (event, columnConfig) {
            var _this = this;
            var _a;
            event.stopPropagation();
            var checked = (_a = event.target) === null || _a === void 0 ? void 0 : _a.checked;
            this.treeItems.forEach(function (node) {
                _this.checkChildren(node, columnConfig.key, checked);
            });
        };
        return VgLightTreeTableComponent;
    }());
    VgLightTreeTableComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLightTreeTableComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgLightTreeTableComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgLightTreeTableComponent, selector: "vg-light-tree-table", inputs: { treeTableConfig: "treeTableConfig", treeItems: "treeItems", treeMap: "treeMap", idKey: "idKey", parentIdKey: "parentIdKey", rootId: "rootId" }, outputs: { selectRowEvent: "selectRowEvent" }, usesOnChanges: true, ngImport: i0__namespace, template: "<table class=\"table table-bordered table-responsive-md\">\n  <thead>\n    <tr>\n      <th [style]=\"{ width: '30%' }\"></th>\n      <th\n        *ngFor=\"let columnConfig of treeTableConfig.columns\"\n        class=\"text-center font-weight-bold\"\n        [style]=\"{ width: columnConfig.width ? columnConfig.width : 'auto' }\"\n      >\n        <ng-container [ngSwitch]=\"columnConfig.type\">\n          <ng-container *ngSwitchCase=\"'CHECKBOX'\">\n            <span>{{ columnConfig.title }}</span>\n            <label class=\"container\">\n              <input\n                type=\"checkbox\"\n                [checked]=\"$any(internalTreeMap[rootId].data)[columnConfig.key]\"\n                (change)=\"checkAll($event, columnConfig)\"\n              />\n              <span class=\"checkmark\"></span>\n            </label>\n          </ng-container>\n          <ng-container *ngSwitchDefault>\n            {{ columnConfig.title }}\n          </ng-container>\n        </ng-container>\n      </th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr\n      *ngFor=\"let treeItem of sortedNodeList\"\n      tabindex=\"0\"\n      [class.d-none]=\"treeItem.hidden\"\n      (click)=\"selectRow($event, treeItem)\"\n      (blur)=\"selectRow($event)\"\n      vgHoverClass\n      [hoverClass]=\"'table-active'\"\n    >\n      <td class=\"m-0\" [style]=\"{ width: '30%' }\">\n        <span\n          *ngFor=\"\n            let item of treeItem.level | vgTreeLevel;\n            index as j;\n            count as size\n          \"\n          class=\"tree-table-space-block\"\n          [class.y-line]=\"treeItem.paddingBlock[j]\"\n          [class.last-block]=\"j === size - 1\"\n        >\n        </span>\n        <span\n          *ngIf=\"treeItem.children.length; else emptyBtn\"\n          (click)=\"expand($event, treeItem)\"\n          class=\"tree-table-space-block btn-toggle font-weight-bold\"\n        >\n          {{ treeItem.expanded ? \"-\" : \"+\" }}</span\n        >\n      </td>\n      <td\n        *ngFor=\"let columnConfig of treeTableConfig.columns\"\n        [style]=\"{ width: columnConfig.width ? columnConfig.width : 'auto' }\"\n      >\n        <div\n          [ngSwitch]=\"columnConfig.type\"\n          [className]=\"columnConfig.customClass ? columnConfig.customClass : ''\"\n        >\n          <ng-container\n            *ngSwitchCase=\"'CUSTOM'\"\n            [ngTemplateOutlet]=\"columnConfig.templateRef ?? null\"\n            [ngTemplateOutletContext]=\"{\n              columnConfig: columnConfig,\n              treeItem: treeItem\n            }\"\n          >\n          </ng-container>\n          <ng-container\n            *ngSwitchCase=\"'CHECKBOX'\"\n            [ngTemplateOutlet]=\"\n              treeItem.isFixed[columnConfig.key]\n                ? fixedCheckbox\n                : normalCheckbox\n            \"\n            [ngTemplateOutletContext]=\"{\n              columnConfig: columnConfig,\n              treeItem: treeItem\n            }\"\n          >\n          </ng-container>\n          <ng-container *ngSwitchDefault>\n            <span>{{ $any(treeItem?.data)[columnConfig.key] }}</span>\n          </ng-container>\n        </div>\n      </td>\n    </tr>\n  </tbody>\n</table>\n<ng-template\n  #normalCheckbox\n  let-columnConfig=\"columnConfig\"\n  let-treeItem=\"treeItem\"\n>\n  <label class=\"container\">\n    <input\n      type=\"checkbox\"\n      [disabled]=\"\n        treeItem.isDisabled[columnConfig.key] ||\n        treeItem?.data[columnConfig.checkboxHorizontalCascadedBy]\n      \"\n      [checked]=\"\n        treeItem?.data[columnConfig.key] ||\n        treeItem?.data[columnConfig.checkboxHorizontalCascadedBy]\n      \"\n      (change)=\"check($event, columnConfig, treeItem)\"\n    />\n    <span class=\"checkmark\"></span>\n  </label>\n</ng-template>\n<ng-template\n  #fixedCheckbox\n  let-columnConfig=\"columnConfig\"\n  let-treeItem=\"treeItem\"\n>\n  <label class=\"container\" *ngIf=\"treeItem.isFixed[columnConfig.key]\">\n    <input\n      type=\"checkbox\"\n      [disabled]=\"true\"\n      [checked]=\"treeItem?.data[columnConfig.key]\"\n    />\n    <span class=\"checkmark\"></span>\n  </label>\n</ng-template>\n<ng-template #emptyBtn>\n  <span class=\"tree-table-space-block btn-leaf\"></span>\n</ng-template>\n", styles: [":host ::ng-deep tbody tr:nth-child(1) td:first-child span:first-child.tree-table-space-block:before{display:none!important}tr:hover,tr:focus{cursor:pointer}.tree-table-space-block{border:2px solid transparent;display:inline-block;width:30px;height:20px;line-height:12px;text-align:center;vertical-align:top;position:relative;box-sizing:border-box}.tree-table-space-block.y-line:before{position:absolute;content:\"\";width:2px;height:46px;background:black;left:50%;top:-38px}.tree-table-space-block.last-block:before{position:absolute;content:\"\";width:2px;height:46px;background:black;left:50%;top:-38px}.tree-table-space-block.last-block:after{position:absolute;content:\"\";width:30px;height:2px;background:black;top:50%;margin-top:-1px}.tree-table-space-block.btn-toggle{border:2px solid black;position:relative;cursor:pointer;width:1rem;height:1rem;line-height:10px;z-index:1;background:white;top:.1rem;left:.5rem;font-size:1rem;color:#000}.tree-table-space-block.btn-leaf{border:2px solid black;position:relative;cursor:none;width:.5rem;height:.5rem;line-height:5px;z-index:1;background:white;top:.4rem;left:.5rem;font-size:.5rem;color:#000;border-radius:50%}.tree-table-space-block.btn-toggle.first-child:before{display:none}.tree-table-space-block.btn-toggle:after{display:none}.tree-table-space-block.is-first-row:before{display:none!important}.container{display:block;position:relative;padding-left:35px;margin-bottom:12px;cursor:pointer;font-size:22px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}.checkmark{position:absolute;border-radius:3px;top:30%;left:40%;height:1.2rem;width:1.2rem;background-color:#eee}.container:hover input~.checkmark{background-color:#ccc}.container input:checked~.checkmark{background-color:#000}.container input:disabled~.checkmark{background-color:#8b8a8a}.container input:checked:disabled~.checkmark{background-color:#5e5e5e}.checkmark:after{content:\"\";position:absolute;display:none}.container input:checked~.checkmark:after{display:block}.container .checkmark:after{left:.5rem;top:.2rem;width:5px;height:10px;border:solid white;border-width:0 3px 3px 0;transform:rotate(45deg)}\n"], directives: [{ type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1__namespace.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: VgHoverClassDirective, selector: "[vgHoverClass]", inputs: ["hoverClass"] }, { type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "vgTreeLevel": VgTreeLevelArrayPipePipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLightTreeTableComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-light-tree-table',
                        templateUrl: './vg-light-tree-table.component.html',
                        styleUrls: ['./vg-light-tree-table.component.scss'],
                    }]
            }], propDecorators: { treeTableConfig: [{
                    type: i0.Input
                }], treeItems: [{
                    type: i0.Input
                }], treeMap: [{
                    type: i0.Input
                }], idKey: [{
                    type: i0.Input
                }], parentIdKey: [{
                    type: i0.Input
                }], rootId: [{
                    type: i0.Input
                }], selectRowEvent: [{
                    type: i0.Output
                }] } });

    var VgTreeTableModule = /** @class */ (function () {
        function VgTreeTableModule() {
        }
        return VgTreeTableModule;
    }());
    VgTreeTableModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgTreeTableModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableModule, declarations: [VgTreeTableComponent,
            VgTreeTableItemComponent,
            VgTreeTableBlockConfigPipe,
            VgLightTreeTableComponent,
            VgTreeLevelArrayPipePipe,
            VgHoverClassDirective], imports: [i1.CommonModule], exports: [VgTreeTableComponent,
            VgTreeTableItemComponent,
            VgTreeTableBlockConfigPipe,
            VgLightTreeTableComponent,
            VgTreeLevelArrayPipePipe] });
    VgTreeTableModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableModule, imports: [[i1.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgTreeTableModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            VgTreeTableComponent,
                            VgTreeTableItemComponent,
                            VgTreeTableBlockConfigPipe,
                            VgLightTreeTableComponent,
                            VgTreeLevelArrayPipePipe,
                            VgHoverClassDirective,
                        ],
                        imports: [i1.CommonModule],
                        exports: [
                            VgTreeTableComponent,
                            VgTreeTableItemComponent,
                            VgTreeTableBlockConfigPipe,
                            VgLightTreeTableComponent,
                            VgTreeLevelArrayPipePipe,
                        ],
                    }]
            }] });

    var TOAST_DATA = new i0.InjectionToken('TOAST_DATA');
    var TOAST_CONF = new i0.InjectionToken('TOAST_CONF');
    var TOAST_OVERLAY_REF = new i0.InjectionToken('TOAST_OVERLAY_REF');
    var RUNTIME_TOAST_CONF = new i0.InjectionToken('RUNTIME_TOAST_CONF');
    var TOAST_TYPE = {
        SUCCESS: {
            bgColor: '#51a351',
            textColor: 'black',
            iconClass: 'bi bi-check-circle-fill',
        },
        ERROR: {
            bgColor: '#bd362f',
            textColor: 'white',
            iconClass: 'bi bi-x-circle-fill',
        },
        WARNING: {
            bgColor: '#ffc107',
            textColor: 'black',
            iconClass: 'bi bi-exclamation-circle-fill',
        },
        INFO: {
            bgColor: '#2f96b4',
            textColor: 'white',
            iconClass: 'bi bi-question-circle-fill',
        },
        NORMAL: { bgColor: '#F8F8FF', textColor: 'black', iconClass: '' },
        CUSTOM: null,
    };
    var TOAST_POSITION = {
        TOP_LEFT: { top: '2rem', left: '2rem' },
        TOP_CENTER: { top: '2rem', horizontalAlignment: true },
        TOP_RIGHT: { top: '2rem', right: '2rem' },
        BOTTOM_LEFT: { bottom: '2rem', left: '2rem' },
        BOTTOM_CENTER: { bottom: '2rem', horizontalAlignment: true },
        BOTTOM_RIGHT: { bottom: '2rem', right: '2rem' },
        CENTER: { horizontalAlignment: true, verticalAlignment: true },
    };
    var TOAST_SIZE = {
        SMALL_DIALOG: { width: '25rem', height: '10rem' },
        MEDIUM_DIALOG: { width: '50vw', height: '20rem' },
        LARGE_DIALOG: { width: '75vw', height: '30rem' },
    };
    var TOAST_ANIMATION = {
        fadeToast: animations.trigger('fadeAnimation', [
            animations.state('in', animations.style({ opacity: 1 })),
            animations.transition('void => *', [animations.style({ opacity: 0 }), animations.animate('{{ fadeIn }}ms')]),
            animations.transition('default => closing', animations.animate('{{ fadeOut }}ms', animations.style({ opacity: 0 }))),
        ]),
    };

    var VgToastOverlayRef = /** @class */ (function () {
        function VgToastOverlayRef(overlayRef, toastService, msg) {
            this.overlayRef = overlayRef;
            this.toastService = toastService;
            this.msg = msg;
        }
        VgToastOverlayRef.prototype.close = function () {
            this.toastService.msgPool.delete(this.msg);
            this.overlayRef.dispose();
        };
        VgToastOverlayRef.prototype.pushToastBeforeToLowerPosition = function () {
            if (this.toastOverlayRefBefore) {
                if (!this.toastOverlayRefBefore.isVisible()) {
                    this.toastOverlayRefBefore = null;
                    return;
                }
                var toastBeforePositionStrategy = this.toastOverlayRefBefore.overlayRef.getConfig()
                    .positionStrategy;
                var currentPosition = this.toastOverlayRefBefore.getPosition();
                toastBeforePositionStrategy.top(currentPosition.top + currentPosition.height + 20 + 'px');
                this.toastOverlayRefBefore.overlayRef.updatePositionStrategy(toastBeforePositionStrategy);
                this.toastOverlayRefBefore.overlayRef.updatePosition();
                this.toastOverlayRefBefore.pushToastBeforeToLowerPosition();
            }
        };
        VgToastOverlayRef.prototype.isVisible = function () {
            var _a;
            return this.overlayRef && ((_a = this.overlayRef) === null || _a === void 0 ? void 0 : _a.overlayElement);
        };
        VgToastOverlayRef.prototype.getPosition = function () {
            var _a, _b;
            return (_b = (_a = this.overlayRef) === null || _a === void 0 ? void 0 : _a.overlayElement) === null || _b === void 0 ? void 0 : _b.getBoundingClientRect();
        };
        return VgToastOverlayRef;
    }());

    var VgToastComponent = /** @class */ (function () {
        function VgToastComponent(data, toastOverlayRef, conf, runtimeConf) {
            this.data = data;
            this.toastOverlayRef = toastOverlayRef;
            this.conf = conf;
            this.runtimeConf = runtimeConf;
            this.animationState = 'default';
            this.progress = 0;
            this.conf = Object.assign(Object.assign({}, this.conf), this.runtimeConf);
        }
        VgToastComponent.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            if ((_a = this.conf) === null || _a === void 0 ? void 0 : _a.duration) {
                this.progress = 0;
                this.intervalId = setInterval(function () {
                    if (_this.conf.duration && _this.progress >= _this.conf.duration) {
                        clearInterval(_this.intervalId);
                        _this.progress = 0;
                        _this.animationState = 'closing';
                    }
                    else {
                        _this.progress += 10;
                    }
                }, 10);
            }
        };
        VgToastComponent.prototype.close = function () {
            if (!this.conf.duration) {
                this.toastOverlayRef.close();
            }
        };
        VgToastComponent.prototype.onFadeFinished = function (event) {
            var toState = event.toState;
            var isFadeOut = toState === 'closing';
            var itFinished = this.animationState === 'closing';
            if (isFadeOut && itFinished) {
                this.toastOverlayRef.close();
            }
        };
        VgToastComponent.prototype.ngOnDestroy = function () {
            clearTimeout(this.intervalId);
        };
        return VgToastComponent;
    }());
    VgToastComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastComponent, deps: [{ token: TOAST_DATA, optional: true }, { token: TOAST_OVERLAY_REF, optional: true }, { token: TOAST_CONF, optional: true }, { token: RUNTIME_TOAST_CONF, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgToastComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgToastComponent, selector: "vg-toast", ngImport: i0__namespace, template: "<div\n  class=\"vg-toast-container m-0 p-0 rounded-lg\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: conf.animation?.fadeIn ?? 0,\n      fadeOut: conf.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': conf.type?.bgColor ?? 'white',\n    color: conf.type?.textColor ?? 'black',\n    width: conf.size?.width,\n    height: conf.size?.height\n  }\"\n  [ngClass]=\"conf.class ?? ''\"\n>\n  <div class=\"vg-toast-header\">\n    <h5>{{ data.title }}</h5>\n  </div>\n  <div\n    class=\"vg-toast-progress-bar-container\"\n    [ngStyle]=\"{ 'background-color': conf.type?.bgColor ?? 'white' }\"\n  >\n    <div\n      class=\"vg-toast-progress-bar\"\n      [ngStyle]=\"{\n        width: conf.duration ? (progress * 100) / conf.duration + '%' : 0\n      }\"\n    ></div>\n  </div>\n  <div class=\"vg-toast-body\" (click)=\"close()\">\n    <div\n      *ngIf=\"conf.type?.iconClass\"\n      [ngStyle]=\"{ width: '10%' }\"\n      class=\"d-inline-block d-flex justify-content-center\"\n    >\n      <i [className]=\"conf.type?.iconClass ?? ''\"></i>\n    </div>\n    <ng-container *ngIf=\"data.text; else templateReference\">\n      <p\n        [ngStyle]=\"{ width: conf.type?.iconClass ? '90%' : '100%' }\"\n        class=\"d-inline-block text-wrap text-truncate\"\n      >\n        {{ data.text }}\n      </p>\n    </ng-container>\n  </div>\n</div>\n\n<ng-template #templateReference>\n  <ng-container\n    [ngTemplateOutlet]=\"data.template || null\"\n    [ngTemplateOutletContext]=\"data.templateContext || null\"\n  >\n  </ng-container>\n</ng-template>\n<!--<div style=\"width: 20rem; height: 10rem; background-color: red; z-index: 1000000\">-->\n\n<!--</div>-->\n", styles: [".vg-toast-container{box-shadow:-5px 5px 10px 5px #0006}.vg-toast-header{width:100%;height:24%;position:relative;display:flex;align-items:center;justify-content:space-around;padding:.5rem;border-top-left-radius:.3rem!important;border-top-right-radius:.3rem!important;color:inherit;background-color:inherit;filter:brightness(85%)}.vg-toast-body{width:100%;height:74%;position:relative;display:flex;padding:.5rem;border-bottom-left-radius:.3rem!important;border-bottom-right-radius:.3rem!important;color:inherit;background-color:inherit}.vg-toast-progress-bar-container{padding:0;height:2%;background-color:inherit;filter:brightness(80%)}.vg-toast-progress-bar{width:20rem;height:100%;background-color:inherit;filter:brightness(50%)}\n"], directives: [{ type: i1__namespace.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], animations: [TOAST_ANIMATION.fadeToast] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-toast',
                        templateUrl: './vg-toast.component.html',
                        styleUrls: ['./vg-toast.component.scss'],
                        animations: [TOAST_ANIMATION.fadeToast],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [TOAST_DATA]
                        }] }, { type: VgToastOverlayRef, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [TOAST_OVERLAY_REF]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [TOAST_CONF]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [RUNTIME_TOAST_CONF]
                        }] }];
        } });

    var VgSoundUtil = /** @class */ (function () {
        function VgSoundUtil() {
        }
        VgSoundUtil.initSound = function (soundCollection, label, path) {
            if (path === void 0) { path = 'assets/media/sound'; }
            soundCollection.forEach(function (sound) {
                var audioElement = document.createElement('audio');
                audioElement.id = label + "_" + sound; //Give it some ID
                var divsParent = document.getElementsByTagName('body')[0]; //get the element where you want to insert the div into
                divsParent.click();
                divsParent.appendChild(audioElement);
                audioElement.setAttribute('muted', 'muted');
                if (navigator.userAgent.match('Firefox/')) {
                    audioElement.setAttribute('src', path + '/' + sound + '.ogg');
                }
                else {
                    audioElement.setAttribute('src', path + '/' + sound + '.mp3');
                }
            });
        };
        VgSoundUtil.playSound = function (sound, path) {
            if (sound === void 0) { sound = 'default'; }
            if (path === void 0) { path = 'assets/media/sound'; }
            var audioElement = document.getElementById(sound);
            if (!audioElement) {
                audioElement = document.createElement('audio');
                audioElement.setAttribute('muted', 'muted');
                if (navigator.userAgent.match('Firefox/')) {
                    audioElement.setAttribute('src', path + '/' + sound + '.ogg');
                }
                else {
                    audioElement.setAttribute('src', path + '/' + sound + '.mp3');
                }
            }
            // audioElement.addEventListener('load', () => {
            //   audioElement.play().then(() => {
            //     console.debug(`Play ${sound}`);
            //   });
            // }, true);
            // audioElement.pause();
            audioElement.muted = false;
            audioElement
                .play()
                .then(function () {
                console.debug("Play " + sound + " success");
            })
                .catch(function (err) {
                console.error("Play " + sound + " failed", err);
            });
        };
        return VgSoundUtil;
    }());

    var VgToastService = /** @class */ (function () {
        function VgToastService(overlay, parentInjector, toastConfig) {
            this.overlay = overlay;
            this.parentInjector = parentInjector;
            this.toastConfig = toastConfig;
            this.msgPool = new Set();
            this.initialToastSounds = [
                'default',
                'chord',
                'battery-critical',
                'error',
                'balloon',
            ];
            VgSoundUtil.initSound(this.initialToastSounds, 'toastSound');
        }
        VgToastService.prototype.show = function (data, runtimeConfig) {
            if (runtimeConfig === void 0) { runtimeConfig = { duration: 3000 }; }
            if (!(data === null || data === void 0 ? void 0 : data.text) || this.msgPool.has(data.text)) {
                return null;
            }
            else {
                this.msgPool.add(data.text);
            }
            var config = Object.assign(Object.assign({}, this.toastConfig), runtimeConfig);
            VgSoundUtil.playSound(config.sound);
            var positionStrategy = this.getPositionStrategy(config);
            var overlayRef = this.overlay.create({
                positionStrategy: positionStrategy,
                // height: config.size.height,
                // width: config.size.width
            });
            var tmpToastOverlayRef = this.lastToast;
            var toastRef = new VgToastOverlayRef(overlayRef, this, data.text);
            this.lastToast = toastRef;
            this.lastToast.toastOverlayRefBefore = tmpToastOverlayRef;
            var injector = this.getInjector(data, toastRef, this.parentInjector, runtimeConfig);
            var toastPortal = new portal.ComponentPortal(VgToastComponent, null, injector);
            var comp = overlayRef.attach(toastPortal);
            console.debug('Toast component: ', comp);
            this.lastToast.pushToastBeforeToLowerPosition();
            return this.lastToast;
        };
        VgToastService.prototype.getInjector = function (data, toastRef, parentInjector, runtimeConfig) {
            return i0.Injector.create({
                providers: [
                    { provide: TOAST_DATA, useValue: data },
                    { provide: TOAST_OVERLAY_REF, useValue: toastRef },
                    { provide: RUNTIME_TOAST_CONF, useValue: runtimeConfig },
                ],
                parent: parentInjector,
            });
        };
        VgToastService.prototype.getPositionStrategy = function (config) {
            if (config === void 0) { config = { duration: 3000 }; }
            var positionStrategy = this.overlay.position().global();
            if (config.position.top) {
                positionStrategy.top(config.position.top);
            }
            if (config.position.right) {
                positionStrategy.right(config.position.right);
            }
            if (config.position.bottom) {
                positionStrategy.bottom(config.position.bottom);
            }
            if (config.position.left) {
                positionStrategy.left(config.position.left);
            }
            if (config.position.horizontalAlignment) {
                positionStrategy.centerHorizontally();
            }
            if (config.position.verticalAlignment) {
                positionStrategy.centerVertically();
            }
            return positionStrategy;
        };
        VgToastService.prototype.success = function (data, runtimeConfig) {
            if (runtimeConfig === void 0) { runtimeConfig = { duration: 3000 }; }
            this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.SUCCESS, sound: 'chord' }));
        };
        VgToastService.prototype.error = function (data, runtimeConfig) {
            if (runtimeConfig === void 0) { runtimeConfig = { duration: 3000 }; }
            this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.ERROR, sound: 'battery-critical' }));
        };
        VgToastService.prototype.warning = function (data, runtimeConfig) {
            if (runtimeConfig === void 0) { runtimeConfig = { duration: 3000 }; }
            this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.WARNING, sound: 'error' }));
        };
        VgToastService.prototype.info = function (data, runtimeConfig) {
            if (runtimeConfig === void 0) { runtimeConfig = { duration: 3000 }; }
            this.show(data, Object.assign(Object.assign({}, runtimeConfig), { type: TOAST_TYPE.INFO, sound: 'balloon' }));
        };
        return VgToastService;
    }());
    VgToastService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastService, deps: [{ token: i1__namespace$4.Overlay }, { token: i0__namespace.Injector }, { token: TOAST_CONF }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    VgToastService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: i1__namespace$4.Overlay }, { type: i0__namespace.Injector }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [TOAST_CONF]
                        }] }];
        } });

    var VgToastModule = /** @class */ (function () {
        function VgToastModule() {
        }
        VgToastModule.forRoot = function (config) {
            var defaultToastConfig = {
                position: TOAST_POSITION.TOP_CENTER,
                size: TOAST_SIZE.SMALL_DIALOG,
                animation: {
                    fadeOut: 2500,
                    fadeIn: 300,
                },
                duration: 2000,
                type: TOAST_TYPE.NORMAL,
            };
            return {
                ngModule: VgToastModule,
                providers: [
                    {
                        provide: TOAST_CONF,
                        useValue: Object.assign(Object.assign({}, defaultToastConfig), config),
                    },
                ],
            };
        };
        return VgToastModule;
    }());
    VgToastModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgToastModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastModule, declarations: [VgToastComponent], imports: [i1.CommonModule, animations$1.BrowserAnimationsModule, i1$4.OverlayModule], exports: [VgToastComponent] });
    VgToastModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastModule, providers: [VgToastService], imports: [[i1.CommonModule, animations$1.BrowserAnimationsModule, i1$4.OverlayModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgToastModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [VgToastComponent],
                        imports: [i1.CommonModule, animations$1.BrowserAnimationsModule, i1$4.OverlayModule],
                        exports: [VgToastComponent],
                        providers: [VgToastService],
                    }]
            }] });

    var DIALOG_DATA = new i0.InjectionToken('DIALOG_DATA');
    var DIALOG_OPTIONS = new i0.InjectionToken('DIALOG_OPTIONS');
    var DIALOG_TYPE = {
        SUCCESS: { bgColor: '#98FB98', textColor: 'black' },
        ERROR: { bgColor: '#FF6347', textColor: 'white' },
        WARNING: { bgColor: '#F0E68C', textColor: 'black' },
        INFO: { bgColor: '#87CEEB', textColor: 'white' },
        NORMAL: { bgColor: '#F8F8FF', textColor: 'black' },
        CUSTOM: null,
    };
    var DIALOG_POSITION = {
        TOP_LEFT: { top: '32', left: '32' },
        TOP_CENTER: { top: '32', horizontalAlignment: true },
        TOP_RIGHT: { top: '32', right: '32' },
        BOTTOM_LEFT: { bottom: '2rem', left: '2rem' },
        BOTTOM_CENTER: { bottom: '2rem', horizontalAlignment: true },
        BOTTOM_RIGHT: { bottom: '2rem', right: '2rem' },
        CENTER: { horizontalAlignment: true, verticalAlignment: true },
    };
    var DIALOG_SIZE = {
        SMALL_DIALOG: { width: '30vw', height: 'auto' },
        MEDIUM_DIALOG: { width: '60vw', height: 'auto' },
        LARGE_DIALOG: { width: '90vw', height: 'auto' },
    };
    var DIALOG_ANIMATION = {
        fadeDialog: animations.trigger('fadeAnimation', [
            animations.state('in', animations.style({ opacity: 1 })),
            animations.transition('void => *', [animations.style({ opacity: 0 }), animations.animate('{{ fadeIn }}ms')]),
            animations.transition('default => closing', animations.animate('{{ fadeOut }}ms', animations.style({ opacity: 0 }))),
        ]),
    };

    // eslint-disable-next-line
    var DIALOG_REF = new i0.InjectionToken('DIALOG_REF');
    var VgDialogOverlayRef = /** @class */ (function () {
        function VgDialogOverlayRef(overlay) {
            this.overlay = overlay;
        }
        VgDialogOverlayRef.prototype.close = function () {
            this.overlay.dispose();
        };
        VgDialogOverlayRef.prototype.onClose = function () {
            return this.overlay.detachments();
        };
        VgDialogOverlayRef.prototype.isVisible = function () {
            return this.overlay && this.overlay.overlayElement;
        };
        VgDialogOverlayRef.prototype.getPosition = function () {
            return this.overlay.overlayElement.getBoundingClientRect();
        };
        return VgDialogOverlayRef;
    }());

    var VgConfirmDialogComponent = /** @class */ (function () {
        function VgConfirmDialogComponent(dialogOverlayRef, dialogData, dialogOptions) {
            this.dialogOverlayRef = dialogOverlayRef;
            this.dialogData = dialogData;
            this.dialogOptions = dialogOptions;
            this.onClose = new rxjs.Subject();
            this.iconClass = '';
            this.cursor = 1;
            this.animationState = 'default';
        }
        VgConfirmDialogComponent.prototype.onKeydownHandler = function (event) {
            event.preventDefault();
            if (event.shiftKey && event.key === 'Tab') {
                if (this.cursor === 0) {
                    this.cursor = this.buttonCollection.length - 1;
                }
                else {
                    this.cursor--;
                }
                this.buttonCollection[this.cursor].nativeElement.focus();
            }
            else {
                switch (event.key) {
                    case 'Escape':
                        this.cancel();
                        break;
                    case 'Tab':
                        if (this.cursor === this.buttonCollection.length - 1) {
                            this.cursor = 0;
                        }
                        else {
                            this.cursor++;
                        }
                        this.buttonCollection[this.cursor].nativeElement.focus();
                        break;
                    case 'Enter':
                        if (this.cursor === 0) {
                            this.cancel();
                        }
                        else {
                            this.buttonCollection[this.cursor].nativeElement.click();
                        }
                        break;
                }
            }
        };
        VgConfirmDialogComponent.prototype.confirm = function () {
            this.onClose.next(true);
            this.onClose.complete();
            this.dialogOverlayRef.close();
        };
        VgConfirmDialogComponent.prototype.cancel = function () {
            this.onClose.next(false);
            this.onClose.complete();
            this.dialogOverlayRef.close();
        };
        VgConfirmDialogComponent.prototype.ngOnInit = function () {
            var _this = this;
            var focusToConfirmButton = setTimeout(function () {
                _this.cursor = 1;
                _this.buttonCollection = _this.buttonsQueryList.toArray();
                _this.buttonCollection[_this.cursor].nativeElement.focus();
                clearTimeout(focusToConfirmButton);
            }, 0);
        };
        // eslint-disable-next-line
        VgConfirmDialogComponent.prototype.onFadeFinished = function (event) {
            var toState = event.toState;
            var isFadeOut = toState === 'closing';
            var itFinished = this.animationState === 'closing';
            if (isFadeOut && itFinished) {
                this.dialogOverlayRef.close();
            }
        };
        return VgConfirmDialogComponent;
    }());
    VgConfirmDialogComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgConfirmDialogComponent, deps: [{ token: DIALOG_REF }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgConfirmDialogComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgConfirmDialogComponent, selector: "vg-confirm-dialog", host: { listeners: { "document:keydown": "onKeydownHandler($event)" } }, viewQueries: [{ propertyName: "buttonsQueryList", predicate: ["confirmDialogButton"], descendants: true }], ngImport: i0__namespace, template: "<div\n  class=\"vg-dialog-container p-0 m-0 rounded-sm\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: dialogOptions.animation?.fadeIn ?? 0,\n      fadeOut: dialogOptions.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': 'default',\n    color: 'default',\n    width: dialogOptions?.size?.width,\n    height: dialogOptions?.size?.height\n  }\"\n  [ngClass]=\"dialogOptions.panelClass ?? ''\"\n>\n  <div class=\"modal-header\">\n    <h5 style=\"font-size: 1.3em; font-weight: bold\">{{ dialogData.title }}</h5>\n    <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"cancel()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <p class=\"text-center icon-default\">\n      <i *ngIf=\"iconClass\" class=\"{{ iconClass }}\"></i>\n    </p>\n    <p class=\"text-center\">{{ dialogData.message }}</p>\n  </div>\n  <div class=\"modal-footer d-flex justify-content-center\">\n    <button\n      type=\"button\"\n      #confirmDialogButton\n      class=\"btn btn-primary m-2 rounded-pill\"\n      style=\"min-width: 5rem\"\n      (click)=\"confirm()\"\n    >\n      {{ dialogData.buttons?.confirm?.label }}\n    </button>\n    <button\n      type=\"button\"\n      #confirmDialogButton\n      class=\"btn btn-secondary m-2 rounded-pill\"\n      style=\"min-width: 5rem\"\n      (click)=\"cancel()\"\n    >\n      {{ dialogData.buttons?.cancel?.label }}\n    </button>\n  </div>\n</div>\n", styles: [".icon-default{font-size:50px}.modal-header h5{margin-bottom:0!important}.modal-content{border:.1rem solid white}.modal-footer>*{margin-top:0!important;margin-bottom:0!important}.vg-dialog-container{background-color:#fff;box-shadow:-5px 5px 10px 5px #0006}\n"], directives: [{ type: i1__namespace.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [DIALOG_ANIMATION.fadeDialog] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgConfirmDialogComponent, decorators: [{
                type: i0.Component,
                args: [{
                        // tslint:disable-next-line:component-selector
                        selector: 'vg-confirm-dialog',
                        templateUrl: 'vg-confirm-dialog.component.html',
                        styleUrls: ['vg-confirm-dialog.component.scss'],
                        animations: [DIALOG_ANIMATION.fadeDialog],
                    }]
            }], ctorParameters: function () {
            return [{ type: VgDialogOverlayRef, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_REF]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_DATA]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_OPTIONS]
                        }] }];
        }, propDecorators: { buttonsQueryList: [{
                    type: i0.ViewChildren,
                    args: ['confirmDialogButton']
                }], onKeydownHandler: [{
                    type: i0.HostListener,
                    args: ['document:keydown', ['$event']]
                }] } });

    var VgMessageDialogComponent = /** @class */ (function () {
        function VgMessageDialogComponent(dialogOverlayRef, dialogData, dialogOptions) {
            this.dialogOverlayRef = dialogOverlayRef;
            this.dialogData = dialogData;
            this.dialogOptions = dialogOptions;
            this.onClose = new rxjs.Subject();
            this.icon = '';
            this.cursor = 1;
            this.animationState = 'default';
        }
        VgMessageDialogComponent.prototype.onKeydownHandler = function (event) {
            event.preventDefault();
            if (event.shiftKey && event.key === 'Tab') {
                if (this.cursor === 0) {
                    this.cursor = this.buttonCollection.length - 1;
                }
                else {
                    this.cursor--;
                }
                this.buttonCollection[this.cursor].nativeElement.focus();
            }
            else {
                switch (event.key) {
                    case 'Escape':
                        this.ok();
                        break;
                    case 'Tab':
                        if (this.cursor === this.buttonCollection.length - 1) {
                            this.cursor = 0;
                        }
                        else {
                            this.cursor++;
                        }
                        this.buttonCollection[this.cursor].nativeElement.focus();
                        break;
                    case 'Enter':
                        this.ok();
                        break;
                }
            }
        };
        VgMessageDialogComponent.prototype.ngOnInit = function () {
            var _this = this;
            var _a;
            this.icon = ((_a = this.dialogData) === null || _a === void 0 ? void 0 : _a.iconClass)
                ? '<i class="' + this.dialogData.iconClass + '"></i>'
                : '';
            var focusToOkButton = setTimeout(function () {
                _this.cursor = 0;
                _this.buttonCollection = _this.buttonsQueryList.toArray();
                _this.buttonCollection[_this.cursor].nativeElement.focus();
                clearTimeout(focusToOkButton);
            }, 0);
        };
        VgMessageDialogComponent.prototype.ok = function () {
            this.onClose.next(false);
            this.onClose.complete();
            this.dialogOverlayRef.close();
        };
        // eslint-disable-next-line
        VgMessageDialogComponent.prototype.onFadeFinished = function (event) {
            var toState = event.toState;
            var isFadeOut = toState === 'closing';
            var itFinished = this.animationState === 'closing';
            if (isFadeOut && itFinished) {
                this.dialogOverlayRef.close();
            }
        };
        return VgMessageDialogComponent;
    }());
    VgMessageDialogComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgMessageDialogComponent, deps: [{ token: DIALOG_REF }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgMessageDialogComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgMessageDialogComponent, selector: "vg-message-dialog", host: { listeners: { "document:keydown": "onKeydownHandler($event)" } }, viewQueries: [{ propertyName: "buttonsQueryList", predicate: ["messageButton"], descendants: true }], ngImport: i0__namespace, template: "<div\n  class=\"vg-dialog-container p-0 m-0 rounded-sm\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: dialogOptions.animation?.fadeIn ?? 0,\n      fadeOut: dialogOptions.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': 'default',\n    color: 'default',\n    width: dialogOptions?.size?.width,\n    height: dialogOptions?.size?.height\n  }\"\n  [ngClass]=\"dialogOptions.panelClass ?? ''\"\n>\n  <div class=\"modal-header\">\n    <h5 style=\"font-size: 1.3em; font-weight: bold\">{{ dialogData.title }}</h5>\n    <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"ok()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <p class=\"text-center icon-default\" [innerHTML]=\"icon\"></p>\n    <p class=\"text-center\">\n      <img\n        *ngIf=\"imageUrl\"\n        src=\"{{ imageUrl }}\"\n        class=\"iconMessage\"\n        alt=\"message-image\"\n      />\n      <span class=\"d-block\" [innerHTML]=\"dialogData.message\"></span>\n    </p>\n  </div>\n  <div class=\"modal-footer d-flex justify-content-center\">\n    <button\n      #messageButton\n      (click)=\"ok()\"\n      class=\"btn btn-primary m-2 rounded-pill\"\n      style=\"min-width: 5rem !important\"\n    >\n      {{ dialogData.buttons?.confirm?.label }}\n    </button>\n  </div>\n</div>\n", styles: [".icon-default{font-size:2rem;margin-bottom:0}.modal-header h5{margin-bottom:0!important}.modal-content{border:.1rem solid white}.modal-footer>*{margin-top:0!important;margin-bottom:0!important}.vg-dialog-container{background-color:#fff;box-shadow:-5px 5px 10px 5px #0006}\n"], directives: [{ type: i1__namespace.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [DIALOG_ANIMATION.fadeDialog] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgMessageDialogComponent, decorators: [{
                type: i0.Component,
                args: [{
                        // tslint:disable-next-line:component-selector
                        selector: 'vg-message-dialog',
                        templateUrl: 'vg-message-dialog.component.html',
                        styleUrls: ['vg-message-dialog.component.scss'],
                        animations: [DIALOG_ANIMATION.fadeDialog],
                    }]
            }], ctorParameters: function () {
            return [{ type: VgDialogOverlayRef, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_REF]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_DATA]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_OPTIONS]
                        }] }];
        }, propDecorators: { buttonsQueryList: [{
                    type: i0.ViewChildren,
                    args: ['messageButton']
                }], onKeydownHandler: [{
                    type: i0.HostListener,
                    args: ['document:keydown', ['$event']]
                }] } });

    var VgDialogWrapperComponent = /** @class */ (function () {
        function VgDialogWrapperComponent(dialogOverlayRef, dialogData, dialogOptions) {
            this.dialogOverlayRef = dialogOverlayRef;
            this.dialogData = dialogData;
            this.dialogOptions = dialogOptions;
            this.title = '';
            this.disableClose = false;
            this.closeAction = new i0.EventEmitter();
            this.animationState = 'default';
        }
        VgDialogWrapperComponent.prototype.close = function () {
            this.closeAction.emit();
        };
        // eslint-disable-next-line
        VgDialogWrapperComponent.prototype.onFadeFinished = function (event) {
            var toState = event.toState;
            var isFadeOut = toState === 'closing';
            var itFinished = this.animationState === 'closing';
            if (isFadeOut && itFinished) {
                this.dialogOverlayRef.close();
            }
        };
        return VgDialogWrapperComponent;
    }());
    VgDialogWrapperComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogWrapperComponent, deps: [{ token: DIALOG_REF }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgDialogWrapperComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgDialogWrapperComponent, selector: "vg-modal-wrapper", inputs: { title: "title", disableClose: "disableClose" }, outputs: { closeAction: "closeAction" }, viewQueries: [{ propertyName: "content", first: true, predicate: ["content"], descendants: true }], ngImport: i0__namespace, template: "<div\n  class=\"vg-dialog-container m-0 p-0 rounded-sm\"\n  [@fadeAnimation]=\"{\n    value: animationState,\n    params: {\n      fadeIn: dialogOptions.animation?.fadeIn ?? 0,\n      fadeOut: dialogOptions.animation?.fadeOut ?? 0\n    }\n  }\"\n  (@fadeAnimation.done)=\"onFadeFinished($event)\"\n  [ngStyle]=\"{\n    'background-color': 'default',\n    color: 'default',\n    width: dialogOptions?.size?.width,\n    height: dialogOptions?.size?.height\n  }\"\n  [ngClass]=\"dialogOptions.panelClass ?? ''\"\n>\n  <div class=\"modal-header\">\n    <h5 class=\"modal-title\" id=\"modal-basic-title\">{{ title }}</h5>\n    <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"close()\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <ng-content select=\"[modalBody]\"></ng-content>\n  </div>\n  <div class=\"modal-footer d-flex justify-content-end\">\n    <ng-content select=\"[modalFooter]\"></ng-content>\n  </div>\n</div>\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='delete'\" class=\"btn btn-danger btn-sm m-2 rounded-circle\"><i class=\"fas fa-trash-alt\"></i></button>-->\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='create'\" class=\"btn btn-primary m-2 rounded-pill\">{{ title }}</button>-->\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='edit'\" class=\"btn btn-secondary m-2 btn-sm rounded-circle\"><i class=\"fas fa-edit\"></i></button>-->\n<!--<button ngbDropdownItem (click)=\"open(content, $event)\" *ngIf=\"action=='addToPlaylist'\" class=\"btn btn-primary btn-sm\"><i class=\"fas fa-plus mr-1\"></i>{{ 'Add to Playlist' | translate }}</button>-->\n<!--<button (click)=\"open(content, $event)\" *ngIf=\"action=='addToPlaylist_roundedBtn'\" class=\"btn btn-secondary btn-sm rounded-circle\"><i class=\"fas fa-plus\"></i></button>-->\n", styles: [".modal-header h5{margin-bottom:0!important}.modal-content{border:.1rem solid white}.modal-footer>*{margin-top:0!important;margin-bottom:0!important}.vg-dialog-container{background-color:#fff;box-shadow:-5px 5px 10px 5px #0006}\n"], directives: [{ type: i1__namespace.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i1__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], animations: [DIALOG_ANIMATION.fadeDialog], encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogWrapperComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-modal-wrapper',
                        templateUrl: './vg-dialog-wrapper.component.html',
                        styleUrls: ['./vg-dialog-wrapper.component.scss'],
                        encapsulation: i0.ViewEncapsulation.None,
                        animations: [DIALOG_ANIMATION.fadeDialog],
                    }]
            }], ctorParameters: function () {
            return [{ type: VgDialogOverlayRef, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_REF]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_DATA]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_OPTIONS]
                        }] }];
        }, propDecorators: { title: [{
                    type: i0.Input
                }], disableClose: [{
                    type: i0.Input
                }], closeAction: [{
                    type: i0.Output
                }], content: [{
                    type: i0.ViewChild,
                    args: ['content']
                }] } });

    var VgDialogService = /** @class */ (function () {
        function VgDialogService(parentInjector, overlay, dialogData, dialogOptions) {
            this.parentInjector = parentInjector;
            this.overlay = overlay;
            this.dialogData = dialogData;
            this.dialogOptions = dialogOptions;
            this.initialDialogSounds = [
                'info-bar',
                'exclamation',
                'critical-stop',
                'chimes',
                'notify',
            ];
            VgSoundUtil.initSound(this.initialDialogSounds, 'dialogSound');
        }
        VgDialogService.prototype.showDialog = function (
        // eslint-disable-next-line
        content, dialogData, dialogOptions) {
            var _a, _b;
            var options = Object.assign(Object.assign({}, this.dialogOptions), dialogOptions);
            var positionStrategy = this.getPositionStrategy(options);
            var overlayRef = this.overlay.create({
                positionStrategy: positionStrategy,
                panelClass: options.panelClass,
                backdropClass: options.backdropClass,
                hasBackdrop: options.hasBackdrop,
                width: (_a = options === null || options === void 0 ? void 0 : options.size) === null || _a === void 0 ? void 0 : _a.width,
                height: (_b = options === null || options === void 0 ? void 0 : options.size) === null || _b === void 0 ? void 0 : _b.height,
                disposeOnNavigation: options.disposeOnNavigation,
            });
            var dialogRef = new VgDialogOverlayRef(overlayRef);
            this.lastDialogRef = dialogRef;
            var data = Object.assign(Object.assign({}, this.dialogData), dialogData);
            var injector = this.getInjector(dialogRef, this.parentInjector, data);
            var dialogPortal = new portal.ComponentPortal(content, null, injector);
            dialogRef.componentRef = overlayRef.attach(dialogPortal).instance;
            return dialogRef;
        };
        VgDialogService.prototype.getInjector = function (dialogRef, parentInjector, dialogData, runtimeDialogOptions) {
            var dialogOptions = Object.assign(Object.assign({}, this.dialogOptions), runtimeDialogOptions);
            return i0.Injector.create({
                providers: [
                    { provide: DIALOG_REF, useValue: dialogRef },
                    { provide: DIALOG_DATA, useValue: dialogData },
                    { provide: DIALOG_OPTIONS, useValue: dialogOptions },
                ],
                parent: parentInjector,
            });
        };
        VgDialogService.prototype.getPositionStrategy = function (dialogOptions) {
            return this.overlay
                .position()
                .global()
                .top(dialogOptions === null || dialogOptions === void 0 ? void 0 : dialogOptions.top)
                .centerHorizontally();
        };
        VgDialogService.prototype.confirm = function (mainTitle, message, labelYes, labelNo, className) {
            if (mainTitle === void 0) { mainTitle = 'Dialog title'; }
            if (message === void 0) { message = 'Dialog message'; }
            if (labelYes === void 0) { labelYes = 'Yes'; }
            if (labelNo === void 0) { labelNo = 'No'; }
            var initialState = {
                title: mainTitle,
                message: message,
                buttons: {
                    confirm: {
                        label: labelYes,
                        className: '',
                    },
                    cancel: {
                        label: labelNo,
                        className: '',
                    },
                },
                iconClass: 'text-warning fa fa-question-circle',
            };
            VgSoundUtil.playSound('notify');
            this.lastDialogRef = this.showDialog(VgConfirmDialogComponent, initialState, {
                backdropClass: className,
                hasBackdrop: true,
                size: DIALOG_SIZE.SMALL_DIALOG,
                // keyboard: false,
            });
            return this.lastDialogRef.componentRef
                .onClose;
        };
        VgDialogService.prototype.show = function (title, message, iconClass, className, imageUrl, sound) {
            if (title === void 0) { title = 'Dialog title'; }
            if (message === void 0) { message = 'Dialog message'; }
            if (sound === void 0) { sound = 'balloon'; }
            var initialState = {
                title: title,
                message: message,
                buttons: {
                    confirm: {
                        label: 'OK',
                        className: '',
                    },
                },
                iconClass: iconClass,
                imageUrl: imageUrl,
            };
            VgSoundUtil.playSound(sound);
            this.lastDialogRef = this.showDialog(VgMessageDialogComponent, initialState, {
                // keyboard: false,
                panelClass: className,
                hasBackdrop: true,
                size: DIALOG_SIZE.SMALL_DIALOG,
            });
            return this.lastDialogRef.componentRef
                .onClose;
        };
        VgDialogService.prototype.info = function (title, message, className) {
            return this.show(title, message, 'text-info bi bi-question-circle-fill', className, undefined, 'info-bar');
        };
        VgDialogService.prototype.warning = function (title, message, className) {
            return this.show(title, message, 'text-warning bi bi-exclamation-triangle-fill', className, undefined, 'exclamation');
        };
        VgDialogService.prototype.error = function (title, message, className) {
            return this.show(title, message, 'text-danger bi bi-exclamation-circle-fill', className, undefined, 'critical-stop');
        };
        VgDialogService.prototype.success = function (title, message, className) {
            return this.show(title, message, 'text-success bi bi-check-circle-fill', className, undefined, 'chimes');
        };
        return VgDialogService;
    }());
    VgDialogService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogService, deps: [{ token: i0__namespace.Injector }, { token: i1__namespace$4.Overlay }, { token: DIALOG_DATA }, { token: DIALOG_OPTIONS }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    VgDialogService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: i0__namespace.Injector }, { type: i1__namespace$4.Overlay }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_DATA]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [DIALOG_OPTIONS]
                        }] }];
        } });

    var VgDialogModule = /** @class */ (function () {
        function VgDialogModule() {
        }
        VgDialogModule.forRoot = function (dialogData, dialogOptions) {
            var defaultDialogOptions = {
                hasBackdrop: true,
                size: DIALOG_SIZE.SMALL_DIALOG,
                top: '5rem',
                disposeOnNavigation: true,
                type: DIALOG_TYPE.NORMAL,
                animation: {
                    fadeOut: 2500,
                    fadeIn: 300,
                },
            };
            var defaultDialogData = {
                title: 'Default dialog',
                message: 'Hello World!',
                buttons: {
                    confirm: {
                        label: 'Close',
                        className: 'btn btn-primary',
                    },
                },
            };
            return {
                ngModule: VgDialogModule,
                providers: [
                    {
                        provide: DIALOG_DATA,
                        useValue: Object.assign(Object.assign({}, defaultDialogData), dialogData),
                    },
                    {
                        provide: DIALOG_OPTIONS,
                        useValue: Object.assign(Object.assign({}, defaultDialogOptions), dialogOptions),
                    },
                ],
            };
        };
        return VgDialogModule;
    }());
    VgDialogModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgDialogModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogModule, declarations: [VgDialogWrapperComponent,
            VgConfirmDialogComponent,
            VgMessageDialogComponent], imports: [i1.CommonModule, i1$4.OverlayModule], exports: [VgDialogWrapperComponent,
            VgConfirmDialogComponent,
            VgMessageDialogComponent] });
    VgDialogModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogModule, providers: [VgDialogService], imports: [[i1.CommonModule, i1$4.OverlayModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDialogModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            VgDialogWrapperComponent,
                            VgConfirmDialogComponent,
                            VgMessageDialogComponent,
                        ],
                        imports: [i1.CommonModule, i1$4.OverlayModule],
                        providers: [VgDialogService],
                        exports: [
                            VgDialogWrapperComponent,
                            VgConfirmDialogComponent,
                            VgMessageDialogComponent,
                        ],
                    }]
            }] });

    var VgNumberOnlyDirective = /** @class */ (function () {
        function VgNumberOnlyDirective(renderer) {
            this.renderer = renderer;
            this.excludedCharsRegex = /[^+,?\d]/g;
            this.excludedNonLeadPlusMinusRegex = /(?<=[\d+]+)\+/g;
            this.onChange = function (val) {
                console.debug(val);
            };
            this.onTouched = function () {
                console.debug();
            };
        }
        VgNumberOnlyDirective.prototype.writeValue = function (obj) {
            var numberVal = isNaN(Number(obj)) ? 0 : Number(obj);
            this.el.value = numberVal.toString();
            // setTimeout(() => {
            //   this.onChange(numberVal);
            // }, 0);
        };
        VgNumberOnlyDirective.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        VgNumberOnlyDirective.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        VgNumberOnlyDirective.prototype.onInput = function (el) {
            var _a, _b;
            if (el.type !== 'text') {
                return;
            }
            var start = el.selectionStart || 0;
            var end = el.selectionEnd || 0;
            var originalNonDigitCount = ((_a = el.value.match(this.excludedCharsRegex)) === null || _a === void 0 ? void 0 : _a.length) || 0;
            var noDigitsString = el.value
                .toString()
                .replace(this.excludedCharsRegex, '');
            var newValue = noDigitsString
                .toString()
                .replace(this.excludedNonLeadPlusMinusRegex, '');
            var modifiedNonDigitCount = ((_b = newValue.substring(0, start).match(this.excludedCharsRegex)) === null || _b === void 0 ? void 0 : _b.length) || 0;
            el.value = newValue;
            start += modifiedNonDigitCount - originalNonDigitCount;
            this.renderer.setProperty(el, 'selectionStart', start);
            this.renderer.setProperty(el, 'selectionEnd', start > end ? start : end);
        };
        return VgNumberOnlyDirective;
    }());
    VgNumberOnlyDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgNumberOnlyDirective, deps: [{ token: i0__namespace.Renderer2 }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgNumberOnlyDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgNumberOnlyDirective, selector: "[vgNumberOnly]", inputs: { excludedCharsRegex: "excludedCharsRegex", excludedNonLeadPlusMinusRegex: "excludedNonLeadPlusMinusRegex" }, host: { listeners: { "input": "onInput($event.target)" } }, providers: [
            {
                provide: forms.NG_VALUE_ACCESSOR,
                useExisting: i0.forwardRef(function () { return VgNumberOnlyDirective; }),
                multi: true,
            },
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgNumberOnlyDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgNumberOnly]',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: i0.forwardRef(function () { return VgNumberOnlyDirective; }),
                                multi: true,
                            },
                        ],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Renderer2 }]; }, propDecorators: { excludedCharsRegex: [{
                    type: i0.Input
                }], excludedNonLeadPlusMinusRegex: [{
                    type: i0.Input
                }], onInput: [{
                    type: i0.HostListener,
                    args: ['input', ['$event.target']]
                }] } });

    var VgCurrencyInputDirective = /** @class */ (function () {
        function VgCurrencyInputDirective(renderer, elementRef) {
            this.renderer = renderer;
            this.elementRef = elementRef;
            this.currentLocale = 'vi-VN';
            this.thousandSeparator = /(\.)/g;
            this.onChange = function (val) {
                console.debug(val);
            };
            this.onTouched = function () {
                console.debug();
            };
            this.el = elementRef.nativeElement;
        }
        VgCurrencyInputDirective.prototype.writeValue = function (obj) {
            var _this = this;
            var numberVal = isNaN(Number(obj)) ? 0 : Number(obj);
            this.el.value = numberVal.toLocaleString(this.currentLocale);
            setTimeout(function () {
                _this.onChange(numberVal);
            }, 0);
        };
        VgCurrencyInputDirective.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        VgCurrencyInputDirective.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        VgCurrencyInputDirective.prototype.ngOnInit = function () {
            if (navigator.language) {
                this.currentLocale = navigator.language;
            }
            var testStr = 1000;
            var testFormattedStr = testStr.toLocaleString(this.currentLocale);
            if (testFormattedStr.match(/\./g)) {
                this.thousandSeparator = /\./g;
            }
            else {
                this.thousandSeparator = /,/g;
            }
        };
        // @HostListener('focusout', ['$event.target'])
        VgCurrencyInputDirective.prototype.onInput = function (el) {
            this.renderUpdatedValue(el);
        };
        VgCurrencyInputDirective.prototype.updateNumberValue = function (val) {
            this.onChange(val);
        };
        VgCurrencyInputDirective.prototype.renderUpdatedValue = function (el) {
            var _this = this;
            if (el.type !== 'text') {
                return;
            }
            clearTimeout(this.delay);
            this.delay = setTimeout(function (el) {
                var _a, _b;
                var start = el.selectionStart || 0;
                var end = el.selectionEnd || 0;
                var initialVal = el.value;
                var initialDotCount = ((_a = initialVal.substring(0, start).match(_this.thousandSeparator)) === null || _a === void 0 ? void 0 : _a.length) || 0;
                var strWithNoComma = el.value
                    .toString()
                    .replace(_this.thousandSeparator, '');
                var strDigitOnly = strWithNoComma.replace(/\D/g, '');
                var numberVal = Number(strDigitOnly);
                var newValue = numberVal.toLocaleString(_this.currentLocale);
                var modifiedDotCount = ((_b = newValue.substring(0, start).match(_this.thousandSeparator)) === null || _b === void 0 ? void 0 : _b.length) ||
                    0;
                // console.debug(initialDotCount, modifiedDotCount, el.selectionStart, el.selectionEnd);
                el.value = newValue;
                start += modifiedDotCount - initialDotCount;
                _this.renderer.setProperty(el, 'selectionStart', start);
                _this.renderer.setProperty(el, 'selectionEnd', start > end ? start : end);
                _this.updateNumberValue(numberVal);
                clearTimeout(_this.delay);
            }, 200, el);
        };
        return VgCurrencyInputDirective;
    }());
    VgCurrencyInputDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgCurrencyInputDirective, deps: [{ token: i0__namespace.Renderer2 }, { token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgCurrencyInputDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgCurrencyInputDirective, selector: "[vgCurrencyInput]", inputs: { currentLocale: "currentLocale" }, host: { listeners: { "input": "onInput($event.target)" } }, providers: [
            {
                provide: forms.NG_VALUE_ACCESSOR,
                useExisting: i0.forwardRef(function () { return VgCurrencyInputDirective; }),
                multi: true,
            },
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgCurrencyInputDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgCurrencyInput]',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: i0.forwardRef(function () { return VgCurrencyInputDirective; }),
                                multi: true,
                            },
                        ],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.Renderer2 }, { type: i0__namespace.ElementRef }]; }, propDecorators: { currentLocale: [{
                    type: i0.Input
                }],
            // @HostListener('focusout', ['$event.target'])
            onInput: [{
                    type: i0.HostListener,
                    args: ['input', ['$event.target']]
                }] } });

    var VgFocusFirstInvalidDirective = /** @class */ (function () {
        function VgFocusFirstInvalidDirective(el) {
            this.el = el;
        }
        VgFocusFirstInvalidDirective.prototype.onFormSubmit = function () {
            if (this.form) {
                this.form.markAllAsTouched();
            }
            var invalidControls = this.el.nativeElement.querySelectorAll('input.ng-invalid');
            if (invalidControls.length) {
                invalidControls.item(0).focus();
                invalidControls.forEach(function (node) {
                    node.classList.add('ng-touched');
                });
            }
        };
        return VgFocusFirstInvalidDirective;
    }());
    VgFocusFirstInvalidDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFocusFirstInvalidDirective, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgFocusFirstInvalidDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgFocusFirstInvalidDirective, selector: "[vgFocusFirstInvalid]", inputs: { form: "form" }, host: { listeners: { "submit": "onFormSubmit()" } }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgFocusFirstInvalidDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgFocusFirstInvalid]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { form: [{
                    type: i0.Input
                }], onFormSubmit: [{
                    type: i0.HostListener,
                    args: ['submit']
                }] } });

    var VgDelayClickDirective = /** @class */ (function () {
        function VgDelayClickDirective() {
            this.delayTime = 1000;
            this.delayClick = new i0.EventEmitter();
            this.clickSubject = new rxjs.Subject();
        }
        VgDelayClickDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription = this.clickSubject
                .pipe(operators.debounceTime(this.delayTime))
                .subscribe(function (e) { return _this.delayClick.emit(e); });
        };
        VgDelayClickDirective.prototype.clickEvent = function (event) {
            event.preventDefault();
            event.stopPropagation();
            this.clickSubject.next(event);
        };
        VgDelayClickDirective.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        return VgDelayClickDirective;
    }());
    VgDelayClickDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDelayClickDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgDelayClickDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgDelayClickDirective, selector: "[vgDelayClick]", inputs: { delayTime: "delayTime" }, outputs: { delayClick: "delayClick" }, host: { listeners: { "click": "clickEvent($event)" } }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDelayClickDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgDelayClick]',
                    }]
            }], propDecorators: { delayTime: [{
                    type: i0.Input
                }], delayClick: [{
                    type: i0.Output
                }], clickEvent: [{
                    type: i0.HostListener,
                    args: ['click', ['$event']]
                }] } });

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var DROPPABLE_CLASS = 'vg-droppable';
    var DRAGGING_CLASS = 'vg-dragging';
    var DRAG_ENTER_CLASS = 'vg-drag-enter';
    var VgSwappableBase = /** @class */ (function () {
        function VgSwappableBase(idAttr, refMap, el) {
            if (idAttr === void 0) { idAttr = 'id'; }
            if (refMap === void 0) { refMap = {}; }
            this.idAttr = idAttr;
            this.refMap = refMap;
            this.el = el;
            this._collectionName = 'default';
            this.el.setAttribute('draggable', 'true');
            this.el.classList.add(DROPPABLE_CLASS);
        }
        VgSwappableBase.prototype.onDrag = function (event) {
            // console.debug('drag', event);
        };
        VgSwappableBase.prototype.onDragstart = function (event) {
            if (event.dataTransfer) {
                event.dataTransfer.setData(this.idAttr, this.el.getAttribute(this.idAttr));
                event.dataTransfer.dropEffect = 'move';
                var dragItem = event.currentTarget;
                dragItem.classList.remove(DROPPABLE_CLASS, DRAG_ENTER_CLASS);
                dragItem.classList.add(DRAGGING_CLASS);
                this.refMap[this._collectionName] = {
                    dragItem: dragItem,
                    dropItem: null,
                };
            }
        };
        VgSwappableBase.prototype.onDragend = function (event) {
            // console.debug('drag end', event);
            var dropItem = this.refMap[this._collectionName].dropItem;
            dropItem === null || dropItem === void 0 ? void 0 : dropItem.classList.remove(DRAG_ENTER_CLASS);
            var dragItem = this.refMap[this._collectionName].dragItem;
            dragItem === null || dragItem === void 0 ? void 0 : dragItem.classList.remove(DRAGGING_CLASS);
            dragItem === null || dragItem === void 0 ? void 0 : dragItem.classList.add(DROPPABLE_CLASS);
            this.refMap[this._collectionName] = {};
        };
        VgSwappableBase.prototype.onDragenter = function (event) {
            if (this.checkValidDrop(event)) {
                var dropItem = this.refMap[this._collectionName].dropItem;
                dropItem === null || dropItem === void 0 ? void 0 : dropItem.classList.remove(DRAG_ENTER_CLASS);
                dropItem = event.currentTarget;
                dropItem.classList.add(DRAG_ENTER_CLASS);
                this.refMap[this._collectionName].dropItem = dropItem;
                event.preventDefault();
            }
        };
        VgSwappableBase.prototype.onDragleave = function (event) {
            if (this.checkValidDrop(event)) {
                var dropItem = this.refMap[this._collectionName].dropItem;
                if (!(dropItem === null || dropItem === void 0 ? void 0 : dropItem.contains(event.relatedTarget))) {
                    dropItem === null || dropItem === void 0 ? void 0 : dropItem.classList.remove(DRAG_ENTER_CLASS);
                }
                event.preventDefault();
            }
        };
        VgSwappableBase.prototype.onDragover = function (event) {
            if (this.checkValidDrop(event)) {
                event.preventDefault();
            }
        };
        VgSwappableBase.prototype.onDrop = function (event) {
            event.preventDefault();
            this.swapEffect(event);
        };
        VgSwappableBase.prototype.checkValidDrop = function (event) {
            var _a;
            var currentTarget = event.currentTarget;
            return (currentTarget.classList.contains(DROPPABLE_CLASS) &&
                ((_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.types.includes(this.idAttr)));
        };
        return VgSwappableBase;
    }());

    var ID_ATTR$1 = 'id';
    var VgSwappableElementDirective = /** @class */ (function (_super) {
        __extends(VgSwappableElementDirective, _super);
        function VgSwappableElementDirective(ref) {
            var _this = _super.call(this, ID_ATTR$1, VgSwappableElementDirective.REF_MAP, ref.nativeElement) || this;
            _this.ref = ref;
            _this.swapEvent = new i0.EventEmitter();
            _this.animationTime = 0.4;
            return _this;
        }
        Object.defineProperty(VgSwappableElementDirective.prototype, "collectionName", {
            get: function () {
                return _super.prototype._collectionName;
            },
            set: function (value) {
                _super.prototype._collectionName = value;
            },
            enumerable: false,
            configurable: true
        });
        VgSwappableElementDirective.prototype.ngOnChanges = function (changes) {
            if (changes.id) {
                this.el.setAttribute(ID_ATTR$1, String(this.id));
            }
        };
        VgSwappableElementDirective.prototype.onDrag = function (event) {
            _super.prototype.onDrag.call(this, event);
        };
        VgSwappableElementDirective.prototype.onDragstart = function (event) {
            _super.prototype.onDragstart.call(this, event);
        };
        VgSwappableElementDirective.prototype.onDragend = function (event) {
            _super.prototype.onDragend.call(this, event);
        };
        VgSwappableElementDirective.prototype.onDragenter = function (event) {
            _super.prototype.onDragenter.call(this, event);
        };
        VgSwappableElementDirective.prototype.onDragleave = function (event) {
            _super.prototype.onDragleave.call(this, event);
        };
        VgSwappableElementDirective.prototype.onDragover = function (event) {
            _super.prototype.onDragover.call(this, event);
        };
        VgSwappableElementDirective.prototype.onDrop = function (event) {
            _super.prototype.onDrop.call(this, event);
        };
        VgSwappableElementDirective.prototype.swapEffect = function (event) {
            var _this = this;
            var _a;
            var dropItem = event.target;
            var dragTargetId = (_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.getData(ID_ATTR$1);
            var dragItem = document.getElementById(dragTargetId);
            if (dragItem && dropItem) {
                var animation = "dropIn " + this.animationTime + "s ease none";
                dragItem.style.animation = animation;
                dropItem.style.animation = animation;
                setTimeout(function () {
                    dragItem.style.animation = '';
                    dropItem.style.animation = '';
                    var parent = dropItem.parentNode;
                    var tmp = document.createElement('span');
                    tmp.style.display = 'none';
                    parent === null || parent === void 0 ? void 0 : parent.insertBefore(tmp, dropItem);
                    parent === null || parent === void 0 ? void 0 : parent.replaceChild(dropItem, dragItem);
                    parent === null || parent === void 0 ? void 0 : parent.replaceChild(dragItem, tmp);
                    tmp.remove();
                    _this.swapEvent.emit({
                        source_id: dragTargetId,
                        target_id: dropItem.getAttribute(ID_ATTR$1),
                    });
                }, this.animationTime * 1000);
            }
        };
        return VgSwappableElementDirective;
    }(VgSwappableBase));
    VgSwappableElementDirective.REF_MAP = {};
    VgSwappableElementDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgSwappableElementDirective, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgSwappableElementDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgSwappableElementDirective, selector: "[vgSwappableElement]", inputs: { id: "id", collectionName: "collectionName", animationTime: "animationTime" }, outputs: { swapEvent: "swapEvent" }, host: { listeners: { "drag": "onDrag($event)", "dragstart": "onDragstart($event)", "dragend": "onDragend($event)", "dragenter": "onDragenter($event)", "dragleave": "onDragleave($event)", "dragover": "onDragover($event)", "drop": "onDrop($event)" } }, usesInheritance: true, usesOnChanges: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgSwappableElementDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgSwappableElement]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { id: [{
                    type: i0.Input
                }], swapEvent: [{
                    type: i0.Output
                }], collectionName: [{
                    type: i0.Input
                }], animationTime: [{
                    type: i0.Input
                }], onDrag: [{
                    type: i0.HostListener,
                    args: ['drag', ['$event']]
                }], onDragstart: [{
                    type: i0.HostListener,
                    args: ['dragstart', ['$event']]
                }], onDragend: [{
                    type: i0.HostListener,
                    args: ['dragend', ['$event']]
                }], onDragenter: [{
                    type: i0.HostListener,
                    args: ['dragenter', ['$event']]
                }], onDragleave: [{
                    type: i0.HostListener,
                    args: ['dragleave', ['$event']]
                }], onDragover: [{
                    type: i0.HostListener,
                    args: ['dragover', ['$event']]
                }], onDrop: [{
                    type: i0.HostListener,
                    args: ['drop', ['$event']]
                }] } });

    var ID_ATTR = 'vg-swap-item-id';
    var VgSwappableListDirective = /** @class */ (function (_super) {
        __extends(VgSwappableListDirective, _super);
        function VgSwappableListDirective(ref) {
            var _this = _super.call(this, ID_ATTR, VgSwappableListDirective.REF_MAP, ref.nativeElement) || this;
            _this.ref = ref;
            _this.dataList = [];
            _this.animationTime = 0.4;
            return _this;
        }
        Object.defineProperty(VgSwappableListDirective.prototype, "collectionName", {
            get: function () {
                return _super.prototype._collectionName;
            },
            set: function (value) {
                _super.prototype._collectionName = value;
            },
            enumerable: false,
            configurable: true
        });
        VgSwappableListDirective.prototype.ngOnChanges = function (changes) {
            if (changes.id) {
                this.el.setAttribute(ID_ATTR, String(this.id));
            }
        };
        VgSwappableListDirective.prototype.onDrag = function (event) {
            _super.prototype.onDrag.call(this, event);
        };
        VgSwappableListDirective.prototype.onDragstart = function (event) {
            _super.prototype.onDragstart.call(this, event);
        };
        VgSwappableListDirective.prototype.onDragend = function (event) {
            _super.prototype.onDragend.call(this, event);
        };
        VgSwappableListDirective.prototype.onDragenter = function (event) {
            _super.prototype.onDragenter.call(this, event);
        };
        VgSwappableListDirective.prototype.onDragleave = function (event) {
            _super.prototype.onDragleave.call(this, event);
        };
        VgSwappableListDirective.prototype.onDragover = function (event) {
            _super.prototype.onDragover.call(this, event);
        };
        VgSwappableListDirective.prototype.onDrop = function (event) {
            _super.prototype.onDrop.call(this, event);
        };
        VgSwappableListDirective.prototype.swapEffect = function (event) {
            var _this = this;
            var _a;
            var dropItem = VgSwappableListDirective.REF_MAP[this._collectionName].dropItem;
            var dragItem = VgSwappableListDirective.REF_MAP[this._collectionName].dragItem;
            if (dragItem && dropItem) {
                var animation = "dropIn " + this.animationTime + "s ease none";
                dragItem.style.animation = animation;
                dropItem.style.animation = animation;
                var drop_target = event.currentTarget;
                var drag_target_id = (_a = event.dataTransfer) === null || _a === void 0 ? void 0 : _a.getData(ID_ATTR);
                var sourceIndex_1 = Number(drag_target_id);
                var targetIndex_1 = Number(drop_target.getAttribute(ID_ATTR));
                setTimeout(function () {
                    dragItem.style.animation = '';
                    dropItem.style.animation = '';
                    var tmp = _this.dataList[targetIndex_1];
                    _this.dataList[targetIndex_1] = _this.dataList[sourceIndex_1];
                    _this.dataList[sourceIndex_1] = tmp;
                }, this.animationTime * 1000);
            }
        };
        return VgSwappableListDirective;
    }(VgSwappableBase));
    VgSwappableListDirective.REF_MAP = {};
    VgSwappableListDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgSwappableListDirective, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    VgSwappableListDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.3", type: VgSwappableListDirective, selector: "[vgSwappableList]", inputs: { id: "id", dataList: "dataList", collectionName: "collectionName", animationTime: "animationTime" }, host: { listeners: { "drag": "onDrag($event)", "dragstart": "onDragstart($event)", "dragend": "onDragend($event)", "dragenter": "onDragenter($event)", "dragleave": "onDragleave($event)", "dragover": "onDragover($event)", "drop": "onDrop($event)" } }, usesInheritance: true, usesOnChanges: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgSwappableListDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[vgSwappableList]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { id: [{
                    type: i0.Input
                }], dataList: [{
                    type: i0.Input
                }], collectionName: [{
                    type: i0.Input
                }], animationTime: [{
                    type: i0.Input
                }], onDrag: [{
                    type: i0.HostListener,
                    args: ['drag', ['$event']]
                }], onDragstart: [{
                    type: i0.HostListener,
                    args: ['dragstart', ['$event']]
                }], onDragend: [{
                    type: i0.HostListener,
                    args: ['dragend', ['$event']]
                }], onDragenter: [{
                    type: i0.HostListener,
                    args: ['dragenter', ['$event']]
                }], onDragleave: [{
                    type: i0.HostListener,
                    args: ['dragleave', ['$event']]
                }], onDragover: [{
                    type: i0.HostListener,
                    args: ['dragover', ['$event']]
                }], onDrop: [{
                    type: i0.HostListener,
                    args: ['drop', ['$event']]
                }] } });

    var VgDirectivesModule = /** @class */ (function () {
        function VgDirectivesModule() {
        }
        return VgDirectivesModule;
    }());
    VgDirectivesModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDirectivesModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgDirectivesModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDirectivesModule, declarations: [VgNumberOnlyDirective,
            VgCurrencyInputDirective,
            VgFocusFirstInvalidDirective,
            VgDelayClickDirective,
            VgSwappableListDirective,
            VgSwappableElementDirective], imports: [i1.CommonModule], exports: [VgNumberOnlyDirective,
            VgCurrencyInputDirective,
            VgFocusFirstInvalidDirective,
            VgDelayClickDirective,
            VgSwappableListDirective,
            VgSwappableElementDirective] });
    VgDirectivesModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDirectivesModule, imports: [[i1.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgDirectivesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            VgNumberOnlyDirective,
                            VgCurrencyInputDirective,
                            VgFocusFirstInvalidDirective,
                            VgDelayClickDirective,
                            VgSwappableListDirective,
                            VgSwappableElementDirective,
                        ],
                        exports: [
                            VgNumberOnlyDirective,
                            VgCurrencyInputDirective,
                            VgFocusFirstInvalidDirective,
                            VgDelayClickDirective,
                            VgSwappableListDirective,
                            VgSwappableElementDirective,
                        ],
                        imports: [i1.CommonModule],
                    }]
            }] });

    var VgCustomCurrencyPipe = /** @class */ (function () {
        function VgCustomCurrencyPipe() {
            this.currentLocale = 'vi-VN';
            if (navigator.language) {
                this.changeLocale(navigator.language);
            }
        }
        VgCustomCurrencyPipe.prototype.changeLocale = function (locale) {
            this.currentLocale = locale;
        };
        // eslint-disable-next-line
        VgCustomCurrencyPipe.prototype.transform = function (value) {
            var arg = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                arg[_i - 1] = arguments[_i];
            }
            if (arg[0] && arg[0] !== this.currentLocale) {
                this.changeLocale(arg[0]);
            }
            var strWithNoComma = value.toString().replace(/(,|\.)/g, '');
            var strDigitOnly = strWithNoComma.replace(/\D/g, '');
            if (Number(strDigitOnly)) {
                return Number(strDigitOnly).toLocaleString(this.currentLocale);
            }
            else {
                return strDigitOnly.replace(/\D/g, '');
            }
        };
        return VgCustomCurrencyPipe;
    }());
    VgCustomCurrencyPipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgCustomCurrencyPipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    VgCustomCurrencyPipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgCustomCurrencyPipe, name: "vgCurrency" });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgCustomCurrencyPipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'vgCurrency',
                    }]
            }], ctorParameters: function () { return []; } });

    var VgPipeModule = /** @class */ (function () {
        function VgPipeModule() {
        }
        return VgPipeModule;
    }());
    VgPipeModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgPipeModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeModule, declarations: [VgCustomCurrencyPipe], imports: [i1.CommonModule], exports: [VgCustomCurrencyPipe] });
    VgPipeModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeModule, imports: [[i1.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgPipeModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [VgCustomCurrencyPipe],
                        imports: [i1.CommonModule],
                        exports: [VgCustomCurrencyPipe],
                    }]
            }] });

    var VgLoaderService = /** @class */ (function () {
        function VgLoaderService() {
            this.loadingSubject$ = new rxjs.BehaviorSubject(false);
        }
        VgLoaderService.prototype.loading = function (value) {
            if (value === void 0) { value = false; }
            this.loadingSubject$.next(value);
        };
        VgLoaderService.prototype.getLoader = function () {
            return this.loadingSubject$;
        };
        return VgLoaderService;
    }());
    VgLoaderService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    VgLoaderService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderService, decorators: [{
                type: i0.Injectable
            }] });

    var VgLoaderComponent = /** @class */ (function () {
        function VgLoaderComponent(loaderService) {
            this.loaderService = loaderService;
            this.loading$ = this.loaderService.getLoader();
        }
        return VgLoaderComponent;
    }());
    VgLoaderComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderComponent, deps: [{ token: VgLoaderService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgLoaderComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgLoaderComponent, selector: "vg-loader", ngImport: i0__namespace, template: "<div\n  class=\"loading-bar loading-bar--active\"\n  [hidden]=\"(loading$ | async) === false\"\n></div>\n", styles: [".loading-bar{position:fixed;top:0;left:0;width:100%;height:5px;background-color:transparent;overflow:hidden;z-index:100000000}.loading-bar--active:after{content:\"\";position:absolute;top:0;left:0;width:40%;height:5px;background-color:#001aff;border-radius:10%;box-shadow:10px 0 30px 15px #010491,-10px 0 30px 15px #010491;-webkit-animation:moveLoadBar 2s cubic-bezier(.09,.89,.7,.71) infinite;animation:moveLoadBar 2s cubic-bezier(.09,.89,.7,.71) infinite}@-webkit-keyframes moveLoadBar{0%{left:-10%}to{left:110%}}@keyframes moveLoadBar{0%{left:-10%}to{left:110%}}\n"], pipes: { "async": i1__namespace.AsyncPipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-loader',
                        templateUrl: './vg-loader.component.html',
                        styleUrls: ['./vg-loader.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: VgLoaderService }]; } });

    var VgLoaderModule = /** @class */ (function () {
        function VgLoaderModule() {
        }
        return VgLoaderModule;
    }());
    VgLoaderModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgLoaderModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderModule, declarations: [VgLoaderComponent], imports: [i1.CommonModule], exports: [VgLoaderComponent] });
    VgLoaderModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderModule, providers: [VgLoaderService], imports: [[i1.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLoaderModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [VgLoaderComponent],
                        imports: [i1.CommonModule],
                        providers: [VgLoaderService],
                        exports: [VgLoaderComponent],
                    }]
            }] });

    var VgUploadProgressComponent = /** @class */ (function () {
        function VgUploadProgressComponent() {
            this.successMsg = 'Upload successfully';
            this.failureMsg = '';
            // eslint-disable-next-line
            this.successEvent = new i0.EventEmitter();
            // eslint-disable-next-line
            this.failureEvent = new i0.EventEmitter();
            this.completeEvent = new i0.EventEmitter();
            this.subscription = new rxjs.Subscription();
            this.responseData = {
                type: 'info',
                data: 0,
                progress: 0,
            };
        }
        VgUploadProgressComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.httpObs && this.httpObs) {
                if (this.subscription && !this.subscription.closed) {
                    this.subscription.unsubscribe();
                }
                this.responseData = {
                    type: 'info',
                    data: 0,
                    progress: 0,
                };
                this.subscription = this.httpObs.subscribe(
                // eslint-disable-next-line
                function (event) {
                    switch (event.type) {
                        case i1$3.HttpEventType.Sent:
                            console.debug('Request has been made!');
                            break;
                        case i1$3.HttpEventType.ResponseHeader:
                            console.debug('Response header has been received!');
                            break;
                        case i1$3.HttpEventType.UploadProgress:
                            _this.responseData.progress = Math.round((event.loaded / (event.total || 1)) * 100);
                            _this.responseData.data = _this.responseData.progress;
                            console.debug("Uploaded! " + _this.responseData.data + "%");
                            break;
                        case i1$3.HttpEventType.Response:
                            console.debug('Successfully created!', event.body);
                            _this.responseData.data = 0;
                            setTimeout(function () {
                                _this.successEvent.emit(event.body);
                                _this.responseData = {
                                    type: 'success',
                                    data: _this.successMsg,
                                    progress: 100,
                                };
                            }, 1500);
                    }
                }, function (error) {
                    var _a;
                    console.error(error);
                    _this.failureEvent.emit(error);
                    _this.responseData = {
                        type: 'danger',
                        data: (_a = _this.failureMsg) !== null && _a !== void 0 ? _a : error === null || error === void 0 ? void 0 : error.message,
                        progress: 100,
                    };
                }, function () {
                    console.debug('Complete!');
                    _this.completeEvent.emit();
                });
            }
        };
        VgUploadProgressComponent.prototype.ngOnDestroy = function () {
            if (!this.subscription.closed) {
                this.subscription.unsubscribe();
            }
        };
        return VgUploadProgressComponent;
    }());
    VgUploadProgressComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgUploadProgressComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgUploadProgressComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgUploadProgressComponent, selector: "vg-upload-progress", inputs: { httpObs: "httpObs", successMsg: "successMsg", failureMsg: "failureMsg" }, outputs: { successEvent: "successEvent", failureEvent: "failureEvent", completeEvent: "completeEvent" }, usesOnChanges: true, ngImport: i0__namespace, template: "<ngb-progressbar\n  *ngIf=\"httpObs\"\n  [type]=\"responseData.type\"\n  [value]=\"responseData.progress\"\n  [striped]=\"true\"\n  [animated]=\"true\"\n>\n  {{ responseData.data }}{{ responseData.type === \"info\" ? \"%\" : \"\" }}\n</ngb-progressbar>\n", styles: [""], components: [{ type: i1__namespace$1.NgbProgressbar, selector: "ngb-progressbar", inputs: ["value", "max", "animated", "striped", "textType", "type", "showValue", "height"] }], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgUploadProgressComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-upload-progress',
                        templateUrl: './vg-upload-progress.component.html',
                        styleUrls: ['./vg-upload-progress.component.scss'],
                    }]
            }], propDecorators: { httpObs: [{
                    type: i0.Input
                }], successMsg: [{
                    type: i0.Input
                }], failureMsg: [{
                    type: i0.Input
                }], successEvent: [{
                    type: i0.Output
                }], failureEvent: [{
                    type: i0.Output
                }], completeEvent: [{
                    type: i0.Output
                }] } });

    var VgIdleTimer = /** @class */ (function () {
        function VgIdleTimer(timeout, onTimeout) {
            if (timeout === void 0) { timeout = 30; }
            if (onTimeout === void 0) { onTimeout = function () {
                console.debug('Interaction Timeout!');
            }; }
            this.timeout = timeout;
            this.onTimeout = onTimeout;
            this.eventHandler = this.updateExpiredTime.bind(this);
            this.tracker();
            this.startInterval();
        }
        VgIdleTimer.prototype.startInterval = function () {
            var _this = this;
            this.updateExpiredTime();
            this.interval = setInterval(function () {
                var expiredTime = parseInt(localStorage.getItem('_expiredTime'), 10);
                if (expiredTime < Date.now()) {
                    if (_this.onTimeout) {
                        _this.onTimeout();
                        _this.cleanUp();
                    }
                }
            }, 1000);
        };
        VgIdleTimer.prototype.updateExpiredTime = function () {
            var _this = this;
            if (this.timeoutTracker) {
                clearTimeout(this.timeoutTracker);
            }
            this.timeoutTracker = setTimeout(function () {
                localStorage.setItem('_expiredTime', String(Date.now() + _this.timeout * 1000));
            }, 300);
        };
        VgIdleTimer.prototype.tracker = function () {
            window.addEventListener('mousemove', this.eventHandler);
            window.addEventListener('scroll', this.eventHandler);
            window.addEventListener('keydown', this.eventHandler);
        };
        VgIdleTimer.prototype.cleanUp = function () {
            clearInterval(this.interval);
            window.removeEventListener('mousemove', this.eventHandler);
            window.removeEventListener('scroll', this.eventHandler);
            window.removeEventListener('keydown', this.eventHandler);
        };
        return VgIdleTimer;
    }());

    var VgHerokuWakeupComponent = /** @class */ (function () {
        function VgHerokuWakeupComponent(http) {
            var _this = this;
            this.http = http;
            this.configList = {};
            this.delayRetry = 10000;
            this.maxRetries = 3;
            this.interactTimeout = 30000;
            this.pingSuccess = null;
            this.setupAwake = function () { return __awaiter(_this, void 0, void 0, function () {
                var e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.isTriggerReady) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            this.isTriggerReady = false;
                            document.removeEventListener('click', this.setupAwake, {
                                capture: true,
                            });
                            return [4 /*yield*/, this.ping()];
                        case 2:
                            _a.sent();
                            this.timer = new VgIdleTimer(this.interactTimeout, this.trigger);
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            console.error(e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); };
            this.trigger = function () {
                console.debug('Time out, ready to trigger ping!');
                _this.isTriggerReady = true;
                document.addEventListener('click', _this.setupAwake, { capture: true });
            };
        }
        VgHerokuWakeupComponent.prototype.ngOnInit = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.ping()];
                        case 1:
                            _a.sent();
                            this.timer = new VgIdleTimer(this.interactTimeout, this.trigger);
                            return [2 /*return*/];
                    }
                });
            });
        };
        VgHerokuWakeupComponent.prototype.ping = function () {
            return __awaiter(this, void 0, void 0, function () {
                var successCount, retries, i, isSuccess, e_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            console.debug('Start ping services');
                            this.pingSuccess = 0;
                            successCount = 0;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 9, 10, 11]);
                            retries = 0;
                            i = 0;
                            _a.label = 2;
                        case 2:
                            if (!(i < Object.keys(this.configList).length)) return [3 /*break*/, 8];
                            return [4 /*yield*/, this.processLevel(this.configList["" + i])];
                        case 3:
                            isSuccess = _a.sent();
                            if (!isSuccess) return [3 /*break*/, 4];
                            i++;
                            successCount++;
                            return [3 /*break*/, 7];
                        case 4:
                            if (!(retries >= this.maxRetries)) return [3 /*break*/, 5];
                            i++;
                            retries = 0;
                            return [3 /*break*/, 7];
                        case 5:
                            retries++;
                            return [4 /*yield*/, rxjs.of().pipe(operators.delay(this.delayRetry)).toPromise()];
                        case 6:
                            _a.sent();
                            _a.label = 7;
                        case 7: return [3 /*break*/, 2];
                        case 8: return [3 /*break*/, 11];
                        case 9:
                            e_2 = _a.sent();
                            console.error('Error while pinging services!', e_2);
                            return [3 /*break*/, 11];
                        case 10:
                            if (successCount === Object.keys(this.configList).length) {
                                this.pingSuccess = 1;
                            }
                            console.debug("Ping service " + (this.pingSuccess ? 'success' : 'failed') + "!");
                            return [7 /*endfinally*/];
                        case 11: return [2 /*return*/];
                    }
                });
            });
        };
        VgHerokuWakeupComponent.prototype.processLevel = function (serviceConfig) {
            return __awaiter(this, void 0, void 0, function () {
                var obsMap_1, result, e_3;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            obsMap_1 = {};
                            Object.keys(serviceConfig).forEach(function (key) {
                                obsMap_1[key] = _this.http
                                    .head(serviceConfig[key].url + 'ping')
                                    .pipe(operators.map(function () {
                                    serviceConfig[key].status = 'success';
                                    return true;
                                }), operators.catchError(function (e) {
                                    console.error(e);
                                    serviceConfig[key].status = 'failed';
                                    return rxjs.of(false);
                                }));
                                serviceConfig[key].status = 'loading';
                                serviceConfig[key].obs = obsMap_1[key];
                            });
                            return [4 /*yield*/, rxjs.forkJoin(obsMap_1).toPromise()];
                        case 1:
                            result = _a.sent();
                            console.debug(result);
                            return [2 /*return*/, Object.keys(serviceConfig)
                                    .map(function (key) { return serviceConfig[key].status; })
                                    .every(function (status) { return status === 'success'; })];
                        case 2:
                            e_3 = _a.sent();
                            console.debug(e_3);
                            return [2 /*return*/, false];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        return VgHerokuWakeupComponent;
    }());
    VgHerokuWakeupComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupComponent, deps: [{ token: i1__namespace$3.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgHerokuWakeupComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgHerokuWakeupComponent, selector: "vg-heroku-wakeup", inputs: { configList: "configList", delayRetry: "delayRetry", maxRetries: "maxRetries", templateRef: "templateRef", interactTimeout: "interactTimeout" }, ngImport: i0__namespace, template: "<ng-container\n  [ngTemplateOutlet]=\"templateRef\"\n  *ngIf=\"pingSuccess; else loadingDiv\"\n></ng-container>\n<ng-template #loadingDiv>\n  <div class=\"h-100 w-100 d-flex justify-content-center align-items-center\">\n    <div class=\"w-25 h-50\">\n      <div *ngFor=\"let servicePriority of $any(configList) | keyvalue\">\n        <h5>Priority: {{ servicePriority.key }}</h5>\n        <ul class=\"list-group\">\n          <li\n            *ngFor=\"let service of $any(servicePriority.value) | keyvalue\"\n            class=\"list-group-item d-flex justify-content-around\"\n          >\n            <div class=\"d-inline-block\">\n              {{ service.key }}\n            </div>\n            <div class=\"d-inline-block\">\n              <ng-container [ngSwitch]=\"$any(service.value).status\">\n                <div *ngSwitchCase=\"'success'\" class=\"text-success text-center\">\n                  <i class=\"bi bi-check-circle\"></i>\n                </div>\n                <div *ngSwitchCase=\"'failed'\" class=\"text-danger text-center\">\n                  <i class=\"bi bi-x-circle\"></i>\n                </div>\n                <div\n                  *ngSwitchCase=\"'loading'\"\n                  class=\"spinner-border spinner-border-sm text-info ms-auto\"\n                  role=\"status\"\n                  aria-hidden=\"true\"\n                ></div>\n                <div *ngSwitchDefault class=\"text-secondary text-center\">\n                  <i class=\"bi bi-clock\"></i>\n                </div>\n              </ng-container>\n            </div>\n          </li>\n        </ul>\n      </div>\n    </div>\n  </div>\n</ng-template>\n", styles: [":host{position:absolute;top:0;bottom:0;right:0;left:0}\n"], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1__namespace.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "keyvalue": i1__namespace.KeyValuePipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-heroku-wakeup',
                        templateUrl: './vg-heroku-wakeup.component.html',
                        styleUrls: ['./vg-heroku-wakeup.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace$3.HttpClient }]; }, propDecorators: { configList: [{
                    type: i0.Input
                }], delayRetry: [{
                    type: i0.Input
                }], maxRetries: [{
                    type: i0.Input
                }], templateRef: [{
                    type: i0.Input
                }], interactTimeout: [{
                    type: i0.Input
                }] } });

    var VgHerokuWakeupService = /** @class */ (function () {
        function VgHerokuWakeupService() {
            this.trackRequest = new rxjs.BehaviorSubject(true);
        }
        return VgHerokuWakeupService;
    }());
    VgHerokuWakeupService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    VgHerokuWakeupService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }] });

    var VgHerokuWakeupNewComponent = /** @class */ (function () {
        function VgHerokuWakeupNewComponent(http, herokuWakeupService) {
            var _this = this;
            this.http = http;
            this.herokuWakeupService = herokuWakeupService;
            this.configList = {};
            this.delayRetry = 10000;
            this.maxRetries = 3;
            this.interactTimeout = 30000; // seconds
            this.pingSuccess = null;
            this.setupAwake = function () { return __awaiter(_this, void 0, void 0, function () {
                var e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.isTriggerReady) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            this.isTriggerReady = false;
                            document.removeEventListener('click', this.setupAwake, {
                                capture: true,
                            });
                            document.removeEventListener('input', this.setupAwake, {
                                capture: true,
                            });
                            document.removeEventListener('scroll', this.setupAwake, {
                                capture: true,
                            });
                            return [4 /*yield*/, this.ping()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            console.error(e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); };
            this.sub = this.herokuWakeupService.trackRequest.subscribe(function (isFirstTime) {
                if (isFirstTime) {
                    console.debug(isFirstTime);
                    if (_this.timer) {
                        clearTimeout(_this.timer);
                    }
                    _this.isTriggerReady = true;
                    _this.setupAwake().finally();
                }
                else {
                    if (_this.timer) {
                        clearTimeout(_this.timer);
                    }
                    _this.timer = setTimeout(function () {
                        console.debug('Time out, ready to trigger ping!');
                        _this.isTriggerReady = true;
                        document.addEventListener('click', _this.setupAwake, {
                            capture: true,
                        });
                        document.addEventListener('input', _this.setupAwake, {
                            capture: true,
                        });
                        document.addEventListener('scroll', _this.setupAwake, {
                            capture: true,
                        });
                    }, _this.interactTimeout);
                }
            });
        }
        VgHerokuWakeupNewComponent.prototype.ping = function () {
            return __awaiter(this, void 0, void 0, function () {
                var successCount, retries, i, isSuccess, e_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            console.debug('Start ping services');
                            this.pingSuccess = 0;
                            successCount = 0;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 9, 10, 11]);
                            retries = 0;
                            i = 0;
                            _a.label = 2;
                        case 2:
                            if (!(i < Object.keys(this.configList).length)) return [3 /*break*/, 8];
                            return [4 /*yield*/, this.processLevel(this.configList["" + i])];
                        case 3:
                            isSuccess = _a.sent();
                            if (!isSuccess) return [3 /*break*/, 4];
                            i++;
                            successCount++;
                            return [3 /*break*/, 7];
                        case 4:
                            if (!(retries >= this.maxRetries)) return [3 /*break*/, 5];
                            i++;
                            retries = 0;
                            return [3 /*break*/, 7];
                        case 5:
                            retries++;
                            return [4 /*yield*/, rxjs.of().pipe(operators.delay(this.delayRetry)).toPromise()];
                        case 6:
                            _a.sent();
                            _a.label = 7;
                        case 7: return [3 /*break*/, 2];
                        case 8: return [3 /*break*/, 11];
                        case 9:
                            e_2 = _a.sent();
                            console.error('Error while pinging services!', e_2);
                            return [3 /*break*/, 11];
                        case 10:
                            if (successCount === Object.keys(this.configList).length) {
                                this.pingSuccess = 1;
                            }
                            console.debug("Ping service " + (this.pingSuccess ? 'success' : 'failed') + "!");
                            return [7 /*endfinally*/];
                        case 11: return [2 /*return*/];
                    }
                });
            });
        };
        VgHerokuWakeupNewComponent.prototype.ngOnInit = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.ping()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        VgHerokuWakeupNewComponent.prototype.processLevel = function (serviceConfig) {
            return __awaiter(this, void 0, void 0, function () {
                var obsMap_1, result, e_3;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            obsMap_1 = {};
                            Object.keys(serviceConfig).forEach(function (key) {
                                obsMap_1[key] = _this.http
                                    .head(serviceConfig[key].url + 'ping')
                                    .pipe(operators.map(function () {
                                    serviceConfig[key].status = 'success';
                                    return true;
                                }), operators.catchError(function (e) {
                                    console.error(e);
                                    serviceConfig[key].status = 'failed';
                                    return rxjs.of(false);
                                }));
                                serviceConfig[key].status = 'loading';
                                serviceConfig[key].obs = obsMap_1[key];
                            });
                            return [4 /*yield*/, rxjs.forkJoin(obsMap_1).toPromise()];
                        case 1:
                            result = _a.sent();
                            console.debug(result);
                            return [2 /*return*/, Object.keys(serviceConfig)
                                    .map(function (key) { return serviceConfig[key].status; })
                                    .every(function (status) { return status === 'success'; })];
                        case 2:
                            e_3 = _a.sent();
                            console.debug(e_3);
                            return [2 /*return*/, false];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        VgHerokuWakeupNewComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        return VgHerokuWakeupNewComponent;
    }());
    VgHerokuWakeupNewComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupNewComponent, deps: [{ token: i1__namespace$3.HttpClient }, { token: VgHerokuWakeupService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgHerokuWakeupNewComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgHerokuWakeupNewComponent, selector: "vg-heroku-wakeup-new", inputs: { configList: "configList", delayRetry: "delayRetry", maxRetries: "maxRetries", templateRef: "templateRef", interactTimeout: "interactTimeout" }, ngImport: i0__namespace, template: "<ng-container\n  [ngTemplateOutlet]=\"templateRef\"\n  *ngIf=\"pingSuccess; else loadingDiv\"\n></ng-container>\n<ng-template #loadingDiv>\n  <div class=\"h-100 w-100 d-flex justify-content-center align-items-center\">\n    <div class=\"w-25 h-50\">\n      <div *ngFor=\"let servicePriority of $any(configList) | keyvalue\">\n        <h5>Priority: {{ servicePriority.key }}</h5>\n        <ul class=\"list-group\">\n          <li\n            *ngFor=\"let service of $any(servicePriority.value) | keyvalue\"\n            class=\"list-group-item d-flex justify-content-around\"\n          >\n            <div class=\"d-inline-block\">\n              {{ service.key }}\n            </div>\n            <div class=\"d-inline-block\">\n              <ng-container [ngSwitch]=\"$any(service.value).status\">\n                <div *ngSwitchCase=\"'success'\" class=\"text-success text-center\">\n                  <i class=\"bi bi-check-circle\"></i>\n                </div>\n                <div *ngSwitchCase=\"'failed'\" class=\"text-danger text-center\">\n                  <i class=\"bi bi-x-circle\"></i>\n                </div>\n                <div\n                  *ngSwitchCase=\"'loading'\"\n                  class=\"spinner-border spinner-border-sm text-info ms-auto\"\n                  role=\"status\"\n                  aria-hidden=\"true\"\n                ></div>\n                <div *ngSwitchDefault class=\"text-secondary text-center\">\n                  <i class=\"bi bi-clock\"></i>\n                </div>\n              </ng-container>\n            </div>\n          </li>\n        </ul>\n      </div>\n    </div>\n  </div>\n</ng-template>\n", styles: [""], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i1__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i1__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i1__namespace.NgSwitchDefault, selector: "[ngSwitchDefault]" }], pipes: { "keyvalue": i1__namespace.KeyValuePipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgHerokuWakeupNewComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-heroku-wakeup-new',
                        templateUrl: './vg-heroku-wakeup-new.component.html',
                        styleUrls: ['./vg-heroku-wakeup-new.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace$3.HttpClient }, { type: VgHerokuWakeupService }]; }, propDecorators: { configList: [{
                    type: i0.Input
                }], delayRetry: [{
                    type: i0.Input
                }], maxRetries: [{
                    type: i0.Input
                }], templateRef: [{
                    type: i0.Input
                }], interactTimeout: [{
                    type: i0.Input
                }] } });

    var VgUtilModule = /** @class */ (function () {
        function VgUtilModule() {
        }
        return VgUtilModule;
    }());
    VgUtilModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgUtilModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgUtilModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgUtilModule, declarations: [VgUploadProgressComponent,
            VgHerokuWakeupComponent,
            VgHerokuWakeupNewComponent], imports: [i1.CommonModule, i1$1.NgbAlertModule, i1$1.NgbProgressbarModule], exports: [VgUploadProgressComponent,
            VgHerokuWakeupComponent,
            VgHerokuWakeupNewComponent] });
    VgUtilModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgUtilModule, imports: [[i1.CommonModule, i1$1.NgbAlertModule, i1$1.NgbProgressbarModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgUtilModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            VgUploadProgressComponent,
                            VgHerokuWakeupComponent,
                            VgHerokuWakeupNewComponent,
                        ],
                        imports: [i1.CommonModule, i1$1.NgbAlertModule, i1$1.NgbProgressbarModule],
                        exports: [
                            VgUploadProgressComponent,
                            VgHerokuWakeupComponent,
                            VgHerokuWakeupNewComponent,
                        ],
                    }]
            }] });

    var VgScrollDataSource = /** @class */ (function (_super) {
        __extends(VgScrollDataSource, _super);
        function VgScrollDataSource(itemService, http, url, params, pageSize, mapper, sizeParamName, pageParamName) {
            var _this = _super.call(this) || this;
            _this.itemService = itemService;
            _this.http = http;
            _this.url = url;
            _this.params = params;
            _this.pageSize = pageSize;
            _this.mapper = mapper;
            _this.sizeParamName = sizeParamName;
            _this.pageParamName = pageParamName;
            _this.lastPage = 0;
            _this.cachedItems = Array.from({ length: 0 });
            _this.dataStream = new rxjs.BehaviorSubject(_this.cachedItems);
            _this.subscription = new rxjs.Subscription();
            // Start with some data.
            _this.fetchItemPage(0);
            return _this;
        }
        VgScrollDataSource.prototype.fetchItemPage = function (page) {
            var _a;
            var _this = this;
            this.http
                .get(this.url, {
                params: Object.assign(Object.assign({}, this.params), (_a = {}, _a[this.pageParamName] = page, _a[this.sizeParamName] = this.pageSize, _a)),
            })
                .subscribe(function (next) {
                _this.cachedItems = _this.cachedItems.concat(_this.mapper(next).content);
                _this.dataStream.next(_this.cachedItems);
            });
        };
        VgScrollDataSource.prototype.getPageForIndex = function (i) {
            return Math.floor(i / this.pageSize);
        };
        VgScrollDataSource.prototype.manualFetch = function () {
            this.fetchItemPage(this.lastPage + 1);
        };
        VgScrollDataSource.prototype.connect = function (collectionViewer) {
            var _this = this;
            this.subscription.add(collectionViewer.viewChange.subscribe(function (range) {
                var currentPage = _this.getPageForIndex(range.end);
                if (currentPage > _this.lastPage) {
                    _this.lastPage = currentPage;
                    _this.fetchItemPage(currentPage);
                }
            }));
            return this.dataStream;
        };
        VgScrollDataSource.prototype.disconnect = function (collectionViewer) {
            console.debug(collectionViewer);
            this.subscription.unsubscribe();
        };
        return VgScrollDataSource;
    }(collections.DataSource));

    var VgScrollerService = /** @class */ (function () {
        function VgScrollerService(http) {
            this.http = http;
        }
        VgScrollerService.prototype.getRandomFact = function () {
            var month = Math.floor(Math.random() * 11) + 1;
            var maxDay = 30;
            if (month === 2) {
                maxDay = 27;
            }
            else if ([4, 6, 9, 11].includes(month)) {
                maxDay = 29;
            }
            var day = Math.floor(Math.random() * maxDay) + 1;
            return this.http.get("http://numbersapi.com/" + month + "/" + day + "/date?json");
        };
        return VgScrollerService;
    }());
    VgScrollerService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgScrollerService, deps: [{ token: i1__namespace$3.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    VgScrollerService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgScrollerService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgScrollerService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return [{ type: i1__namespace$3.HttpClient }]; } });

    var VgScrollerComponent = /** @class */ (function () {
        function VgScrollerComponent(factService, http) {
            this.factService = factService;
            this.http = http;
            this.minBufferPx = 50;
            this.maxBufferPx = 100;
            this.itemSize = 44;
            this.pageSize = 20;
            this.url = '';
            this.params = {};
            this.mapper = function (response) { return ({
                content: response,
                totalPages: response.length,
            }); };
            this.sizeParamName = 'size';
            this.pageParamName = 'page';
        }
        VgScrollerComponent.prototype.ngOnInit = function () {
            this.dataSource = new VgScrollDataSource(this.factService, this.http, this.url, this.params, this.pageSize, this.mapper, this.sizeParamName, this.pageParamName);
        };
        VgScrollerComponent.prototype.fetch = function () {
            this.dataSource.manualFetch();
        };
        return VgScrollerComponent;
    }());
    VgScrollerComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgScrollerComponent, deps: [{ token: VgScrollerService }, { token: i1__namespace$3.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Component });
    VgScrollerComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.3", type: VgScrollerComponent, selector: "vg-scroller", inputs: { minBufferPx: "minBufferPx", maxBufferPx: "maxBufferPx", itemSize: "itemSize", pageSize: "pageSize", url: "url", params: "params", mapper: "mapper", sizeParamName: "sizeParamName", pageParamName: "pageParamName", customTemplate: "customTemplate" }, ngImport: i0__namespace, template: "<cdk-virtual-scroll-viewport\n  *ngIf=\"dataSource\"\n  [itemSize]=\"itemSize\"\n  [minBufferPx]=\"minBufferPx\"\n  [maxBufferPx]=\"maxBufferPx\"\n  class=\"item-scroll-viewport\"\n>\n  <ng-container *ngIf=\"dataSource.cachedItems.length; else noDataTmpl\">\n    <li *cdkVirtualFor=\"let item of dataSource\">\n      <ng-container\n        [ngTemplateOutlet]=\"customTemplate ? customTemplate : defaultItemTmpl\"\n        [ngTemplateOutletContext]=\"{ item: item }\"\n      >\n      </ng-container>\n    </li>\n  </ng-container>\n</cdk-virtual-scroll-viewport>\n<ng-template #defaultItemTmpl let-item=\"item\">\n  <div *ngIf=\"item\" class=\"list-group-item\">\n    <div class=\"text-dark\">{{ item.name }}</div>\n  </div>\n</ng-template>\n<ng-template #noDataTmpl>\n  <div>No data found</div>\n</ng-template>\n", styles: [".item-scroll-viewport{height:100%;width:100%}cdk-virtual-scroll-viewport{border:1px solid black}cdk-virtual-scroll-viewport li{list-style:none}::-webkit-scrollbar{width:.5rem}::-webkit-scrollbar-track{background:#f1f1f1;border-radius:.2rem}::-webkit-scrollbar-thumb{background:#888;border-radius:.2rem}::-webkit-scrollbar-thumb:hover{background:#555}\n"], components: [{ type: i3__namespace.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }], directives: [{ type: i1__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3__namespace.CdkFixedSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "minBufferPx", "maxBufferPx"] }, { type: i3__namespace.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { type: i1__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgScrollerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'vg-scroller',
                        templateUrl: './vg-scroller.component.html',
                        styleUrls: ['./vg-scroller.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: VgScrollerService }, { type: i1__namespace$3.HttpClient }]; }, propDecorators: { minBufferPx: [{
                    type: i0.Input
                }], maxBufferPx: [{
                    type: i0.Input
                }], itemSize: [{
                    type: i0.Input
                }], pageSize: [{
                    type: i0.Input
                }], url: [{
                    type: i0.Input
                }], params: [{
                    type: i0.Input
                }], mapper: [{
                    type: i0.Input
                }], sizeParamName: [{
                    type: i0.Input
                }], pageParamName: [{
                    type: i0.Input
                }], customTemplate: [{
                    type: i0.Input
                }] } });

    var VgLayoutModule = /** @class */ (function () {
        function VgLayoutModule() {
        }
        return VgLayoutModule;
    }());
    VgLayoutModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLayoutModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    VgLayoutModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLayoutModule, declarations: [VgScrollerComponent], imports: [i1.CommonModule, i3.ScrollingModule], exports: [VgScrollerComponent] });
    VgLayoutModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLayoutModule, providers: [VgScrollerService], imports: [[i1.CommonModule, i3.ScrollingModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.3", ngImport: i0__namespace, type: VgLayoutModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [VgScrollerComponent],
                        imports: [i1.CommonModule, i3.ScrollingModule],
                        exports: [VgScrollerComponent],
                        providers: [VgScrollerService],
                    }]
            }] });

    /*
     * Public API Surface of ngx-vengeance-lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DIALOG_ANIMATION = DIALOG_ANIMATION;
    exports.DIALOG_DATA = DIALOG_DATA;
    exports.DIALOG_OPTIONS = DIALOG_OPTIONS;
    exports.DIALOG_POSITION = DIALOG_POSITION;
    exports.DIALOG_REF = DIALOG_REF;
    exports.DIALOG_SIZE = DIALOG_SIZE;
    exports.DIALOG_TYPE = DIALOG_TYPE;
    exports.RUNTIME_TOAST_CONF = RUNTIME_TOAST_CONF;
    exports.TOAST_ANIMATION = TOAST_ANIMATION;
    exports.TOAST_CONF = TOAST_CONF;
    exports.TOAST_DATA = TOAST_DATA;
    exports.TOAST_OVERLAY_REF = TOAST_OVERLAY_REF;
    exports.TOAST_POSITION = TOAST_POSITION;
    exports.TOAST_SIZE = TOAST_SIZE;
    exports.TOAST_TYPE = TOAST_TYPE;
    exports.VgAutoInputComponent = VgAutoInputComponent;
    exports.VgConfirmDialogComponent = VgConfirmDialogComponent;
    exports.VgControlModule = VgControlModule;
    exports.VgCurrencyInputDirective = VgCurrencyInputDirective;
    exports.VgCustomCurrencyPipe = VgCustomCurrencyPipe;
    exports.VgDelayClickDirective = VgDelayClickDirective;
    exports.VgDelayInputDirective = VgDelayInputDirective;
    exports.VgDialogModule = VgDialogModule;
    exports.VgDialogOverlayRef = VgDialogOverlayRef;
    exports.VgDialogService = VgDialogService;
    exports.VgDialogWrapperComponent = VgDialogWrapperComponent;
    exports.VgDirectivesModule = VgDirectivesModule;
    exports.VgErrorDictService = VgErrorDictService;
    exports.VgErrorMessagePipe = VgErrorMessagePipe;
    exports.VgErrorSectionComponent = VgErrorSectionComponent;
    exports.VgFileIconPipe = VgFileIconPipe;
    exports.VgFileInputComponent = VgFileInputComponent;
    exports.VgFocusFirstInvalidDirective = VgFocusFirstInvalidDirective;
    exports.VgHerokuWakeupComponent = VgHerokuWakeupComponent;
    exports.VgHerokuWakeupNewComponent = VgHerokuWakeupNewComponent;
    exports.VgHerokuWakeupService = VgHerokuWakeupService;
    exports.VgIdleTimer = VgIdleTimer;
    exports.VgLayoutModule = VgLayoutModule;
    exports.VgLightTreeTableComponent = VgLightTreeTableComponent;
    exports.VgLoaderComponent = VgLoaderComponent;
    exports.VgLoaderModule = VgLoaderModule;
    exports.VgLoaderService = VgLoaderService;
    exports.VgMessageDialogComponent = VgMessageDialogComponent;
    exports.VgNumberOnlyDirective = VgNumberOnlyDirective;
    exports.VgPipeModule = VgPipeModule;
    exports.VgPipeWrapperPipe = VgPipeWrapperPipe;
    exports.VgScrollDataSource = VgScrollDataSource;
    exports.VgScrollerComponent = VgScrollerComponent;
    exports.VgScrollerService = VgScrollerService;
    exports.VgSwappableElementDirective = VgSwappableElementDirective;
    exports.VgSwappableListDirective = VgSwappableListDirective;
    exports.VgTagInputComponent = VgTagInputComponent;
    exports.VgToastComponent = VgToastComponent;
    exports.VgToastModule = VgToastModule;
    exports.VgToastOverlayRef = VgToastOverlayRef;
    exports.VgToastService = VgToastService;
    exports.VgTreeLevelArrayPipePipe = VgTreeLevelArrayPipePipe;
    exports.VgTreeTableBlockConfigPipe = VgTreeTableBlockConfigPipe;
    exports.VgTreeTableComponent = VgTreeTableComponent;
    exports.VgTreeTableItemComponent = VgTreeTableItemComponent;
    exports.VgTreeTableModule = VgTreeTableModule;
    exports.VgUploadProgressComponent = VgUploadProgressComponent;
    exports.VgUtilModule = VgUtilModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-vengeance-lib.umd.js.map
